#ifndef MCS_CFG_H_
#define MCS_CFG_H_

// MCS generic design parameters, index i is MCS instance number
#define MCS_PARAM_W(i)  		(24)
#define MCS_PARAM_T(i)			(8)
#define MCS_PARAM_RDW(i)		(32)
#define MCS_PARAM_NPS(i)		(5)
#define MCS_PARAM_RAW(i)		(11)
#define MCS_PARAM_USR(i)		(1)


// MCS data-word width
#define MCS_WURM_MASK_WIDTH 			16
#define MCS_SP_CNT_BITS 			3

// MCS supported instructions
// Data transfer instructions
#define MCS_USE_INSTR_MOVL			1
#define MCS_USE_INSTR_MOV 			1
#define MCS_USE_INSTR_MRD 			1
#define MCS_USE_INSTR_MWR 			1
#define MCS_USE_INSTR_MWRL			1
#define MCS_USE_INSTR_MRDI			1
#define MCS_USE_INSTR_MWRI			1
#define MCS_USE_INSTR_MWRIL 		        1
#define MCS_USE_INSTR_POP 			1
#define MCS_USE_INSTR_PUSH 			1
// ARU instrcutions
#define MCS_USE_INSTR_ARD 			1
#define MCS_USE_INSTR_ARDI 			1
#define MCS_USE_INSTR_AWR 			1
#define MCS_USE_INSTR_AWRI 			1
#define MCS_USE_INSTR_NARD 			1
#define MCS_USE_INSTR_NARDI 		        1
// Arithmethic logic instructions
#define MCS_USE_INSTR_ADDL			1
#define MCS_USE_INSTR_ADD			1
#define MCS_USE_INSTR_SUBL			1
#define MCS_USE_INSTR_SUB			1
#define MCS_USE_INSTR_NEG			1
#define MCS_USE_INSTR_ANDL			1
#define MCS_USE_INSTR_AND			1
#define MCS_USE_INSTR_ORL			1
#define MCS_USE_INSTR_OR			1
#define MCS_USE_INSTR_XORL			1
#define MCS_USE_INSTR_XOR			1
#define MCS_USE_INSTR_SHR			1
#define MCS_USE_INSTR_SHL			1
#define MCS_USE_INSTR_ASRU		    0
#define MCS_USE_INSTR_ASRS		    0
#define MCS_USE_INSTR_ASL 		    0
#define MCS_USE_INSTR_MULU			0
#define MCS_USE_INSTR_MULS 			0
#define MCS_USE_INSTR_DIVU			0
#define MCS_USE_INSTR_DIVS			0
#define MCS_USE_INSTR_MINU			0
#define MCS_USE_INSTR_MINS			0
#define MCS_USE_INSTR_MAXU			0
#define MCS_USE_INSTR_MAXS			0
// Test instruction
#define MCS_USE_INSTR_ATUL			1
#define MCS_USE_INSTR_ATU 			1
#define MCS_USE_INSTR_ATSL			1
#define MCS_USE_INSTR_ATS 			1
#define MCS_USE_INSTR_BTL 			1
#define MCS_USE_INSTR_BT			1
// Control Flow Instructions
#define MCS_USE_INSTR_JMP 			1
#define MCS_USE_INSTR_JBS 			1
#define MCS_USE_INSTR_JBC 			1
#define MCS_USE_INSTR_CALL 			1
#define MCS_USE_INSTR_RET			1
// Other Instructions
#define MCS_USE_INSTR_WURM			1
#define MCS_USE_INSTR_NOP 			1

// MCS supported registers
#define MCS_USE_MHB_REG                         1

// Multiplication and Division
#define MCS_MUL_LRES_IS_VARIABLE	1 	// 0 = store result in MCS_MUL_LRES_REG; 1 = store result in register of operand A
#define MCS_MUL_LRES_REG					5
#define MCS_MUL_HRES_REG					4
#define MCS_DIV_RES_IS_VARIABLE		1 	// 0 = store result in MCS_DIV_RES_REG; 1 = store result in register of operand A
#define MCS_DIV_RES_REG 					5

// MCS supported general purpose registers
#define MCS_USE_R0_REG	1
#define MCS_USE_R1_REG	1
#define MCS_USE_R2_REG	1
#define MCS_USE_R3_REG	1
#define MCS_USE_R4_REG	1
#define MCS_USE_R5_REG	1
#define MCS_USE_R6_REG	1
#define MCS_USE_R7_REG	1

// MCS use relative memory address offsets
#define MCS_USE_AOLIT 	0

#endif
