--head:-------------------------------------------------------------------------
--:head-------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- Description    : DPLL SUB_INC generation
--============================================================================ 
-- Important Notes:
--============================================================================ 

--------------------------------------------------------------------------------------
-- WATCHDOG: 
--CLK WATCHDOG 5001 us
--------------------------------------------------------------------------------------

#inc inc/aru_write_addr_map.cmd
#inc inc/chksig_labels.cmd
#inc inc_cfg/gtm_device_cfg.cmd

#if $(#dpll_instances_cnt == 0)
   ALL SYNC ALL
   AEI print "=================================================================================="
   AEI print "Warning : DPLL is not available in this device"
   AEI print "Warning : Test isn't executed"
   AEI print "=================================================================================="
   ALL SYNC ALL
   ALL QUIT
#endif

AEI print "Configure CHK IFS"
AEI print "======================================================="

--CHK ADD_INSTR 0 SSL #TIM0_IN0 HI        -- set input to '1'
CHK ADD_INSTR 0 SSL #TIM0_IN7 HI        -- set input to '1'
CHK ADD_INSTR 0 WSE #ATOM0_OUT7 FE      -- wait for falling edge
CHK ADD_INSTR 0 SSL #TIM0_IN7 LO        -- set input to '0'
CHK ADD_INSTR 0 WSE #ATOM0_OUT7 RE      -- wait for rising edge
CHK ADD_INSTR 0 SSL #TIM0_IN7 HI        -- set input to '1'
CHK ADD_INSTR 0 JMT 0 -4                -- JMP forever
ALL SYNC ALL

-- generate a DPLL input signal 

CHK ENABLE 0 ON
ALL SYNC ALL

CLK FREQ  100 MHz
CLK RESET  1  12
CLK WAIT deltime 100 ns

ALL SYNC ALL
AEI print "configure report level"
AEI print "======================================================="
DBI SET_RPT_LEVEL AEI   INFO
DBI SET_RPT_LEVEL SWI   INFO
--DBI SET_RPT_LEVEL CHK   INFO
DBI SET_RPT_LEVEL dpll   INFO

AEI print "Enable DPLL irq 0-26 in testbench environment"
AEI print "================================================"
ALL IRQ MASK #100 1
--ALL IRQ MASK #101 1
--ALL IRQ MASK #102 1
--ALL IRQ MASK #103 1
--ALL IRQ MASK #104 1
--ALL IRQ MASK #105 1
--ALL IRQ MASK #106 1
--ALL IRQ MASK #107 1
--ALL IRQ MASK #108 1
--ALL IRQ MASK #109 1
--ALL IRQ MASK #110 1
--ALL IRQ MASK #111 1
--ALL IRQ MASK #112 1
--ALL IRQ MASK #113 1
--ALL IRQ MASK #114 1
--ALL IRQ MASK #115 1
--ALL IRQ MASK #116 1
--ALL IRQ MASK #117 1
ALL IRQ MASK #118 1
--ALL IRQ MASK #119 1
--ALL IRQ MASK #120 1
--ALL IRQ MASK #121 1
--ALL IRQ MASK #122 1
ALL IRQ MASK #123 1
ALL IRQ MASK #124 1
--ALL IRQ MASK #125 1
--ALL IRQ MASK #126 1
ALL IRQ MASK #200 1       -- TIM0_CH0 NEWVAL
ALL IRQ MASK #900 1       -- ATOM0_CH0 NEWVAL
ALL SYNC ALL

--AEI print "Configure CHK IFS"
--AEI print "======================================================="
--
--CHK ADD_INSTR 0 SSL #TIM0_IN7 HI        -- set input to '1'
--CHK ADD_INSTR 0 WSE #ATOM0_OUT7 FE      -- wait for falling edge
--CHK ADD_INSTR 0 SSL #TIM0_IN7 LO        -- set input to '0'
--CHK ADD_INSTR 0 WSE #ATOM0_OUT7 RE      -- wait for rising edge
--CHK ADD_INSTR 0 SSL #TIM0_IN7 HI        -- set input to '1'
--CHK ADD_INSTR 0 JMT 0 -4                -- JMP forever
--ALL SYNC ALL
--
---- generate a DPLL input signal 
--
--CHK ENABLE 0 ON
--ALL SYNC ALL


AEI print "start c-test 'dpll_test'"
SWI RUN_SW dpll_an011
AEI print "Run simulation"
AEI print "======================================================="

-- ...

AEI WAIT simtime 50 ms
ALL SYNC ALL

CHK ENABLE 0 OFF NOERR			-- don't drop error, infinit loop!

ALL SYNC ALL

AEI print "======================================================================"
AEI print "End of Test"
AEI print "======================================================================"
ALL SYNC ALL
ALL QUIT


#isr 100
	AEI print "DPLL IRQ 27 fired (irq-100)"
	--SWI RUN_ISR my_test_isr 127
#end

#isr 118
	AEI print "DPLL IRQ 18 fired (irq-100)"
	SWI RUN_ISR dpll_an011_isr 118
#end

#isr 123
	AEI print "DPLL IRQ 23 fired (irq-123)"
	--SWI RUN_ISR my_test_isr 123
#end

#isr 124
	AEI print "DPLL IRQ 24 fired (irq-124)"
	--SWI RUN_ISR my_test_isr 124
#end

#isr 200
	AEI print "TIM0_CH0 NEWVAL IRQ fired (irq-200)"
	SWI RUN_ISR dpll_an011_isr 200
#end

#isr 900
	AEI print "ATOM0_CH0 IRQ fired (irq-900)"
	SWI RUN_ISR dpll_an011_isr 900
#end

#inc inc/empty_isr_out_signals.cmd

-------------------------------------------------------------------------------
-- This is the footer of the file.
-------------------------------------------------------------------------------
