--head:-------------------------------------------------------------------------
--:head-------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- Description    : Creates 6 synchronous symmetrical PWM output signals
--                  Reload duty cycle values via FIFO
--                  Use channel 7 to count number of periods for update period
--============================================================================ 
-- Important Notes:
--============================================================================ 

--------------------------------------------------------------------------------------
-- WATCHDOG: 
CLK WATCHDOG 5001 us
--------------------------------------------------------------------------------------
#inc inc_cfg/gtm_device_cfg.cmd

#inc inc/aru_write_addr_map.cmd
#inc inc/chksig_labels.cmd
#inc inc/check_gtm_resources.cmd

#if $(#atom_instances_cnt == 0)
   ALL SYNC ALL
   AEI print "=================================================================================="
   AEI print "Warning : ATOM is not available in this device"
   AEI print "Warning : Test isn't executed"
   AEI print "=================================================================================="
   ALL SYNC ALL
   ALL QUIT
#endif

AEI SET_RM_ACCESS_CYCLES 3
AEI SET_RM_WAIT_CYCLES 1

ALL IRQ MASK #903 1
ALL IRQ MASK #923 1

CLK FREQ  100 MHz
CLK RESET  1  12
CLK WAIT deltime 100 ns

ALL SYNC ALL
AEI print "configure report level"
AEI print "======================================================="
DBI SET_RPT_LEVEL AEI   INFO
DBI SET_RPT_LEVEL SWI   INFO
--DBI SET_RPT_LEVEL CHK   INFO
--DBI SET_RPT_LEVEL atom0 DBG3
--DBI SET_RPT_LEVEL atom0_ch1 DBG3
--DBI SET_RPT_LEVEL atom0_ch7 DBG3
DBI SET_RPT_LEVEL mcs0_ch0 INFO

ALL SYNC ALL

AEI print "Configure CHK IFS"
AEI print "======================================================="

-- check channel 0:
CHK ADD_INSTR 1 WSE #ATOM0_OUT0 RE         -- synchronize to first RE of channel 0 
CHK ADD_INSTR 1 MSE #ATOM0_OUT0 FE 25000   -- 25000ns high pulse
CHK ADD_INSTR 1 MSE #ATOM0_OUT0 RE 25000   -- 25000ns low pulse
CHK ADD_INSTR 1 JMT 30 -2      -- repeat 30 times  

-- check channel 1:
#if $(#GTM_GEN == 1)
CHK ADD_INSTR 2 WSE #ATOM0_OUT1 RE        -- synchronize to first RE of channel 1 
CHK ADD_INSTR 2 MSE #ATOM0_OUT1 FE 29100 
CHK ADD_INSTR 2 MSE #ATOM0_OUT1 RE 20900 
CHK ADD_INSTR 2 MSE #ATOM0_OUT1 FE 29100 
CHK ADD_INSTR 2 MSE #ATOM0_OUT1 RE 20900 
CHK ADD_INSTR 2 MSE #ATOM0_OUT1 FE 29100 
CHK ADD_INSTR 2 MSE #ATOM0_OUT1 RE 20900 
CHK ADD_INSTR 2 MSE #ATOM0_OUT1 FE 29100 
#else
CHK ADD_INSTR 2 WSE #ATOM0_OUT1 RE
CHK ADD_INSTR 2 WSE #ATOM0_OUT1 RE        -- synchronize to first RE of channel 1 
CHK ADD_INSTR 2 MSE #ATOM0_OUT1 FE 29100 
CHK ADD_INSTR 2 MSE #ATOM0_OUT1 RE 20900 
CHK ADD_INSTR 2 MSE #ATOM0_OUT1 FE 29100 
CHK ADD_INSTR 2 MSE #ATOM0_OUT1 RE 20900 
CHK ADD_INSTR 2 MSE #ATOM0_OUT1 FE 29100 
#endif
CHK ADD_INSTR 2 MSE #ATOM0_OUT1 RE 18850 
CHK ADD_INSTR 2 MSE #ATOM0_OUT1 FE 33200 
CHK ADD_INSTR 2 MSE #ATOM0_OUT1 RE 16800 
CHK ADD_INSTR 2 MSE #ATOM0_OUT1 FE 33200 

-- check channel 4:
#if $(#GTM_GEN == 1)
CHK ADD_INSTR 3 WSE #ATOM0_OUT4 FE        -- synchronize to first FE of channel 4
CHK ADD_INSTR 3 MSE #ATOM0_OUT4 RE 43300 
CHK ADD_INSTR 3 MSE #ATOM0_OUT4 FE  6700 
CHK ADD_INSTR 3 MSE #ATOM0_OUT4 RE 43300 
CHK ADD_INSTR 3 MSE #ATOM0_OUT4 FE  6700 
CHK ADD_INSTR 3 MSE #ATOM0_OUT4 RE 43300 
CHK ADD_INSTR 3 MSE #ATOM0_OUT4 FE  6700 
CHK ADD_INSTR 3 MSE #ATOM0_OUT4 RE 43300 
#else
CHK ADD_INSTR 3 WSE #ATOM0_OUT4 FE
CHK ADD_INSTR 3 WSE #ATOM0_OUT4 FE        -- synchronize to first FE of channel 4
CHK ADD_INSTR 3 MSE #ATOM0_OUT4 RE 43300 
CHK ADD_INSTR 3 MSE #ATOM0_OUT4 FE  6700 
CHK ADD_INSTR 3 MSE #ATOM0_OUT4 RE 43300 
CHK ADD_INSTR 3 MSE #ATOM0_OUT4 FE  6700 
CHK ADD_INSTR 3 MSE #ATOM0_OUT4 RE 43300 
#endif
CHK ADD_INSTR 3 MSE #ATOM0_OUT4 FE  8150 
CHK ADD_INSTR 3 MSE #ATOM0_OUT4 RE 40400 
CHK ADD_INSTR 3 MSE #ATOM0_OUT4 FE  9600 
CHK ADD_INSTR 3 MSE #ATOM0_OUT4 RE 40400 

-- check channel 7:
CHK ADD_INSTR 4 WSE #ATOM0_OUT7 RE         -- synchronize to first RE of channel 7 
CHK ADD_INSTR 4 MSE #ATOM0_OUT7 FE 5000    -- 5000ns high pulse
CHK ADD_INSTR 4 MSE #ATOM0_OUT7 RE 95000   -- + 95000ns = 2*period channel 0
CHK ADD_INSTR 4 JMT 30 -2                  -- repeat 30 times

CHK ENABLE 1 ON
CHK ENABLE 2 ON
CHK ENABLE 3 ON
CHK ENABLE 4 ON

ALL SYNC ALL

AEI print "start c-test 'atom_pmsm'"
SWI RUN_SW mcs_atom_pmsm

AEI print "Run simulation"
AEI print "======================================================="

AEI WAIT simtime 5000 us
ALL SYNC ALL

CHK ENABLE 1 OFF
CHK ENABLE 2 OFF
CHK ENABLE 3 OFF
CHK ENABLE 4 OFF

ALL SYNC ALL

AEI print "======================================================================"
AEI print "End of Test"
AEI print "======================================================================"
ALL SYNC ALL
ALL QUIT


-- 903 used by devices GTM v1xx
#isr 903
AEI print "ATOM-CH6/7 IRQ fired (irq-903)"
SWI RUN_ISR mcs_atom_pmsm_isr 903
#end

-- 923 used by devices GTM v2xx
#isr 923
AEI print "ATOM-CH7 IRQ fired (irq-923)"
SWI RUN_ISR mcs_atom_pmsm_isr 923
#end

#inc inc/empty_isr_out_signals.cmd

-------------------------------------------------------------------------------
-- This is the footer of the file.
-------------------------------------------------------------------------------
