--head:-------------------------------------------------------------------------
--:head-------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- Description    : 
--============================================================================ 
-- Important Notes:
--============================================================================ 

--------------------------------------------------------------------------------------
-- WATCHDOG: 
CLK WATCHDOG 500 ms
--------------------------------------------------------------------------------------

#inc inc/aru_write_addr_map.cmd
#inc inc/chksig_labels.cmd
AEI SET_RM_ACCESS_CYCLES 3
AEI SET_RM_WAIT_CYCLES 1

AEI ASSIGN up_dir1 = 0
AEI ASSIGN down_dir1 = 0
AEI ASSIGN init = 1
ALL SYNC ALL

ALL IRQ MASK #6 1
ALL IRQ MASK #202 1
ALL IRQ MASK #2000 1
ALL IRQ MASK #2001 1
IFS IRQ PRIO 6 19
IFS IRQ PRIO 202 20
IFS IRQ PRIO 2000 18
IFS IRQ PRIO 2001 17
--ALL IRQ MASK #903 1

CLK FREQ  100 MHz
CLK RESET  1  12
CLK WAIT deltime 100 ns

ALL SYNC ALL
AEI print "configure report level"
AEI print "======================================================="
DBI SET_RPT_LEVEL AEI   INFO
--DBI SET_RPT_LEVEL SWI   INFO
--DBI SET_RPT_LEVEL CHK   INFO
--DBI SET_RPT_LEVEL spe0 DBG3
--DBI SET_RPT_LEVEL tom0_ch0 DBG3
--DBI SET_RPT_LEVEL tom0_ch1 DBG3
--DBI SET_RPT_LEVEL tim0_ch0 DBG3
--DBI SET_RPT_LEVEL tim0_ch1 DBG3
--DBI SET_RPT_LEVEL tim0_ch3 DBG3

ALL SYNC ALL
CLK WAIT deltime 10 us

ALL SYNC ALL


AEI print "Configure CHK IFS"
AEI print "======================================================="
AEI ASSIGN elevator_off = 0
AEI ASSIGN up_dir1 = 0
AEI ASSIGN down_dir1 = 0
AEI ASSIGN init = 1
AEI ASSIGN encoder1 = #TIM0_IN0 #TIM0_IN1 #TIM0_IN2
AEI ASSIGN signal_sequence0 = LO LO HI HI
AEI ASSIGN signal_sequence1 = LO HI HI LO
AEI ASSIGN floor_max = 10
AEI ASSIGN floor_min = -2
AEI ASSIGN floor_cnt = $(#floor_max - #floor_min)
AEI ASSIGN [44]floor_height = 255
AEI ASSIGN [44]floor_height = 3
--AEI ASSIGN [44]floor_height = 7
AEI ASSIGN start_floor = 0
AEI ASSIGN start_offset = 0
AEI ASSIGN elevator_pos = 0
AEI ASSIGN t_unit = us 
AEI ASSIGN t_scale = 1
AEI ASSIGN elevator_speed = 1 1 1 1 1 1 1 1 1 
AEI ASSIGN elevator_request = 0 
AEI ASSIGN init_time_tic = 10 ns
AEI ASSIGN up_dir =  1 2 3 4
AEI ASSIGN down_dir = 3 2 1 0
AEI ASSIGN segments = 0 64 128 192 256
AEI ASSIGN segments = 0 4 8 12 16
AEI ASSIGN segments = 0 1 2 3 4
--AEI ASSIGN segments = 0 2 4 6 8
ALL SYNC ALL
AEI ASSIGN start_offset = #elevator_pos
AEI ASSIGN cur_floor = $( #start_floor - #floor_min)
AEI ASSIGN cur_seg = 0
AEI ASSIGN cur_pos = 0
AEI print "Elevator position " #elevator_pos  "Floor " #start_floor

--AEI WAIT simtime $(50 * #t_scale) #t_unit

AEI ASSIGN up_dir = 1
AEI ASSIGN target_floor = 4
CHK ASSIGN up_dir = 0
CHK ASSIGN down_dir = 0
CHK ASSIGN is = 0
CHK ASSIGN xx = 0
CHK ASSIGN cur_posi = 0
CHK ASSIGN end_posi = 0
CHK ASSIGN floor_val = 0
ALL SYNC ALL


AEI print "start c-test 'encoder1'"
SWI RUN_SW encoder1
ALL SYNC ALL


AEI print "Run simulation"
AEI print "======================================================="

AEI WAIT deltime 60 us
ALL SYNC ALL


ALL SYNC ALL

AEI print "======================================================================"
AEI print "End of Test"
AEI print "======================================================================"
ALL SYNC ALL
ALL QUIT


#isr 6
--AEI print "SPE0 IRQ fired (irq-6)"
SWI RUN_ISR encoder1_isr 6
#end

#isr 202
--AEI print "TIM0_CH2 IRQ fired (irq-202)"
SWI RUN_ISR encoder1_isr 202
#end
#inc inc/empty_isr_out_signals.cmd

#isr 2000 
   IST print "TOM0_0  signal change "
   ALL SYNC IST CHK
   IST RETURN_SIG_VAL #TOM0_OUT0 up_dir1
   IST RETURN_SIG_VAL #TOM0_OUT1 down_dir1
   #if $( #init == 1 &&  ~(#up_dir1 == 0 && #down_dir1 == 0))
     IST ASSIGN init = 0
   #endif
   #if $( #init == 0 &&  (#up_dir1 == 1 && #down_dir1 == 0))
     IST print "Testbench detected up request" 
     IST ASSIGN up_dir = 1
     #inc gtm_apps_sw/encoder_signal.cmd
   #endif
#end 
  
#isr 2001 
   IST print "TOM0_1  signal change "
   ALL SYNC IST CHK
   IST RETURN_SIG_VAL #TOM0_OUT0 up_dir1
   IST RETURN_SIG_VAL #TOM0_OUT1 down_dir1
   --IST print "updir 0" #up_dir1 #down_dir1 #init
   #if $( #init == 1 &&  ~(#up_dir1 == 0 && #down_dir1 == 0))
     IST ASSIGN init = 0
   #endif
   #if $( #init == 0 &&  (#up_dir1 == 0 && #down_dir1 == 1))
     IST print "Testbench detected down request" 
     IST ASSIGN up_dir = 0
     --IST print "updir 0" #up_dir
     #inc gtm_apps_sw/encoder_signal.cmd
   #endif
#end 

--#inc inc/empty_isr_out_signals.cmd

-------------------------------------------------------------------------------
-- This is the footer of the file.
-------------------------------------------------------------------------------
