-- GOODS SHALL NOT BE APPLICABLE. THE EXCLUSIVE LEGAL VENUE SHALL BE
-- DUESSELDORF, GERMANY.
--
-- MANDATORY LAW SHALL BE UNAFFECTED BY THE FOREGOING PARAGRAPHS.
--
-- INTELLECTUAL PROPERTY OWNERS/COPYRIGHT OWNERS/CONTRIBUTORS: ROBERT BOSCH
-- GMBH, ROBERT BOSCH PLATZ 1, 70839 GERLINGEN, GERMANY AND ITS LICENSORS.
--
-- ALL RIGHTS RESERVED.
--------------------------------------------------------------------------------
-- Project Name : GTM - Generic Timer Module
--------------------------------------------------------------------------------
-- Copyright   : Robert Bosch GmbH, Gerlingen, Germany
-- Department  : AE/EIY
-- Created     : 05.09.2012
--------------------------------------------------------------------------------
--:head-------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- Descr iption :  
-- Generates two arrays mcs_mp0 and mcs_mp1 with MP0 and MP1 variables 
-- according to specification. Array index denotes MCS instance. Additionally
-- a variable mcs_erm is generated which reflects the value of ERM in GTM_CTRL 
--------------------------------------------------------------------------------

AEI ASSIGN [7]mcfg_cfg = 0

AEI ASSIGN [7]mcs_mp0 = -1
AEI ASSIGN [7]mcs_mp1 = -1

AEI ASSIGN mcfg_erm = 0 

AEI ASSIGN dev_id = 0 
AEI ASSIGN prev_i = 0
AEI ASSIGN cur_cfg = 0
AEI ASSIGN prev_cfg = 0
AEI ASSIGN gtm_hw_conf = 0
AEI GET_DEVICE_ID dev_id
ALL SYNC ALL
CLK WAIT deltime 300 ns

-- MCFG available
#if $(#mcfg_instances_cnt > 0) --i3

  -- Only for generation >= 2
  #if $(#dev_id >= 200 ) --i1
    AEI ASSIGN mcfg_erm = 0	--If (dev_id < 200 | erm configurable) mcs_get_mpx_param need variable mcfg_erm with value 0 or 1 
    AEI READVAR gtm_hw_conf GTM_HW_CONF
    #if $(#gtm_hw_conf & h#2000) --i2
      AEI ASSIGN mcfg_erm = 1
    #endif --i2n
    AEI print "MCFG mcfg_erm=" #mcfg_erm " mcfg_param_maw=" #mcfg_param_maw
  #endif --i1n

  AEI ASSIGN mcfg_ctrl = 0
  AEI READVAR mcfg_ctrl MCFG_CTRL
  ALL SYNC ALL
  #loop i (0, $(#mcs_instances_cnt-1)) --l1
    AEI ASSIGN mcfg_cfg[#i] = $( ( #mcfg_ctrl & (3<<2*#i) ) >> 2* #i ) 
  #eol --l1n

  ALL SYNC ALL
  #loop i (0, $(#mcs_instances_cnt-1)) --l2
    AEI ASSIGN cur_cfg = #mcfg_cfg[#i]
    AEI ASSIGN prev_i = $(#i-1)
    #if $( #i == 0 ) --i4
        AEI ASSIGN prev_i = $(#mcs_instances_cnt-1)
    #endif --i4n
    AEI ASSIGN prev_cfg = #mcfg_cfg[#prev_i]
    
    AEI print "Test-mpx-param : " #i #mcfg_cfg[#i] #cur_cfg #prev_i
    #if $(#mcfg_erm == 0) --i5
        #switch #cur_cfg --s1
        #case 0 -- default
            #switch #prev_cfg --s2
            #case 0 -- default
              AEI ASSIGN  mcs_mp0[#i] = $(1<<(#mcfg_param_maw+2))
              AEI ASSIGN  mcs_mp1[#i] = $((1<<(#mcfg_param_maw+2))+(1<<(#mcfg_param_maw +1)))
            #case 1 -- swap 
              AEI ASSIGN  mcs_mp0[#i] = $(1<<(#mcfg_param_maw+1))
              AEI ASSIGN  mcs_mp1[#i] = $(1<<(#mcfg_param_maw+2))
            #case 2 -- borrow
              AEI ASSIGN  mcs_mp0[#i] = 0
              AEI ASSIGN  mcs_mp1[#i] = $(1<<(#mcfg_param_maw+1))
            #endswitch --s2n
        #case 1 -- swap 
            #switch #prev_cfg --s3
            #case 0 -- default 
              AEI ASSIGN  mcs_mp0[#i] = $(1<<(#mcfg_param_maw+2))
              AEI ASSIGN  mcs_mp1[#i] = $(1<<(#mcfg_param_maw+3))
            #case 1 -- swap 
              AEI ASSIGN  mcs_mp0[#i] = $(1<<(#mcfg_param_maw+1))
              AEI ASSIGN  mcs_mp1[#i] = $((1<<(#mcfg_param_maw+2))+(1<<(#mcfg_param_maw +1)))
            #case 2 -- borrow
              AEI ASSIGN  mcs_mp0[#i] = 0
              AEI ASSIGN  mcs_mp1[#i] = $(1<<(#mcfg_param_maw+2))
            #endswitch --s3n
        #case 2 -- borrow
            #switch #prev_cfg --s4
            #case 0 -- default 
              AEI ASSIGN  mcs_mp0[#i] = $(1<<(#mcfg_param_maw+2))
              AEI ASSIGN  mcs_mp1[#i] = $((1<<(#mcfg_param_maw+3))+(1<<(#mcfg_param_maw +1)))
            #case 1 -- swap 
              AEI ASSIGN  mcs_mp0[#i] = $(1<<(#mcfg_param_maw+1))
              AEI ASSIGN  mcs_mp1[#i] = $(1<<(#mcfg_param_maw+3))
            #case 2 -- borrow
              AEI ASSIGN  mcs_mp0[#i] = 0
              AEI ASSIGN  mcs_mp1[#i] = $((1<<(#mcfg_param_maw+2))+(1<<(#mcfg_param_maw +1)))
            #endswitch --s4n
        #endswitch --s1n
    #else --i5e
        #switch #cur_cfg --s5
        #case 0 -- default
            #switch #prev_cfg --s6
            #case 0 -- default
              AEI ASSIGN  mcs_mp0[#i] = $(1<<(#mcfg_param_maw+2))
              AEI ASSIGN  mcs_mp1[#i] = $(1<<(#mcfg_param_maw+3))
            #case 1 -- swap 
              AEI ASSIGN  mcs_mp0[#i] = $(1<<(#mcfg_param_maw+2))
              AEI ASSIGN  mcs_mp1[#i] = $(1<<(#mcfg_param_maw+3))
            #case 2 -- borrow
              AEI ASSIGN  mcs_mp0[#i] = 0
              AEI ASSIGN  mcs_mp1[#i] = $(1<<(#mcfg_param_maw+2))
            #endswitch --s6n
        #case 1 -- swap 
            #switch #prev_cfg --s7
            #case 0 -- default 
              AEI ASSIGN  mcs_mp0[#i] = $(1<<(#mcfg_param_maw+2))
              AEI ASSIGN  mcs_mp1[#i] = $(1<<(#mcfg_param_maw+3))
            #case 1 -- swap 
              AEI ASSIGN  mcs_mp0[#i] = $(1<<(#mcfg_param_maw+2))
              AEI ASSIGN  mcs_mp1[#i] = $(1<<(#mcfg_param_maw+3))
            #case 2 -- borrow
              AEI ASSIGN  mcs_mp0[#i] = 0
              AEI ASSIGN  mcs_mp1[#i] = $(1<<(#mcfg_param_maw+2))
            #endswitch --s7n
        #case 2 -- borrow
            #switch #prev_cfg --s8
            #case 0 -- default 
              AEI ASSIGN  mcs_mp0[#i] = $(1<<(#mcfg_param_maw+2))
              AEI ASSIGN  mcs_mp1[#i] = $((1<<(#mcfg_param_maw+2))+(1<<(#mcfg_param_maw +3)))
            #case 1 -- swap 
              AEI ASSIGN  mcs_mp0[#i] = $(1<<(#mcfg_param_maw+2))
              AEI ASSIGN  mcs_mp1[#i] = $((1<<(#mcfg_param_maw+2))+(1<<(#mcfg_param_maw +3)))
            #case 2 -- borrow
              AEI ASSIGN  mcs_mp0[#i] = 0
              AEI ASSIGN  mcs_mp1[#i] = $(1<<(#mcfg_param_maw+3))
            #endswitch --s8n
        #endswitch --s5n
    #endif --i5n
    AEI print "MCS" #i ": mcs_mp0=" #mcs_mp0[#i] " mcs_mp1=" #mcs_mp1[#i]
  #eol --l2n

#else --i3e -- MCFG not available
  AEI print "MCFG not available!"

  #if $(#dut_is_rm == 0)
    AEI WRITE GTM_IRQ_NOTIFY   h#0000000F
    AEI READ MCFG_CTRL h#0 h#0 h#3 
    AEI READ  GTM_IRQ_NOTIFY   h#00000002
    AEI WRITE GTM_IRQ_NOTIFY   h#00000002
    AEI READ  GTM_IRQ_NOTIFY   h#00000000
  #else
    -- In RM is implemented as dummy
    AEI READ MCFG_CTRL h#0 h#0 h#3
  #endif

  #loop i (0, $(#mcs_instances_cnt-1)) --l3
--        AEI print "MCS" #i ": mcs_mp0=" #mcs_mp0[#i] " mcs_mp1=" #mcs_mp1[#i]
    #if $((#dev_id >= 200 ) && (#dev_id <300)) --i1
      -- do nothing
    #else
      AEI ASSIGN  mcs_mp0[#i] = $(1<<(#mcs_param_raw[#i] + 2))
      AEI ASSIGN  mcs_mp1[#i] = $(1<<(#mcs_param_raw[#i] + #mcs_param_usr[#i] + 2))
    #endif
      AEI print "MCS" #i ": mcs_mp0=" #mcs_mp0[#i] " mcs_mp1=" #mcs_mp1[#i]
  #eol --l3n
#endif --i3n

ALL SYNC ALL

-------------------------------------------------------------------------------
-- This is the footer of the file.
-------------------------------------------------------------------------------
