--head:-------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- $Id: mcs_cfg.cmd,v 1.2 2013/01/29 06:49:54 aohler Exp $
--------------------------------------------------------------------------------
-- NO WARRANTIES: TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER THE
-- INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND CONTRIBUTORS, NOR ANY
-- PERSON, EITHER EXPRESSLY OR IMPLICITLY, WARRANTS ANY ASPECT OF THIS
-- SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
-- INCLUDING ANY OUTPUT OR RESULTS OF THIS SPECIFICATION, SOFTWARE RELATED
-- THERETO, CODE AND/OR PROGRAM RELATED THERETO UNLESS AGREED TO IN WRITING.
-- THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED
-- THERETO IS BEING PROVIDED "AS IS", WITHOUT ANY WARRANTY OF ANY TYPE OR
-- NATURE, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
-- WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY
-- WARRANTY THAT THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
-- PROGRAM RELATED THERETO IS FREE FROM DEFECTS.
--
-- ASSUMPTION OF RISK: THE RISK OF ANY AND ALL LOSS, DAMAGE, OR UNSATISFACTORY
-- PERFORMANCE OF THIS SPECIFICATION (RESPECTIVELY THE PRODUCTS MAKING USE OF
-- IT IN PART OR AS A WHOLE), SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM
-- RELATED THERETO RESTS WITH YOU AS THE USER. TO THE MAXIMUM EXTENT PERMITTED
-- BY LAW, NEITHER THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND
-- CONTRIBUTORS, NOR ANY PERSON EITHER EXPRESSLY OR IMPLICITLY, MAKES ANY
-- REPRESENTATION OR WARRANTY REGARDING THE APPROPRIOATENESS OF THE USE, OUTPUT,
-- OR RESULTS OF THE USE OF THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE
-- AND/OR PROGRAM RELATED THERETO IN TERMS OF ITS CORRECTNESS, ACCURACY,
-- RELIABILITY, BEING CURRENT OR OTHERWISE. NOR DO THEY HAVE ANY OBLIGATION TO
-- CORRECT ERRORS, MAKE CHANGES, SUPPORT THIS SPECIFICATION, SOFTWARE RELATED
-- THERETO, CODE AND/OR PROGRAM RELATED THERETO, DISTRIBUTE UPDATES, OR PROVIDE
-- NOTIFICATION OF ANY ERROR OR DEFECT, KNOWN OR UNKNOWN. IF YOU RELY UPON THIS
-- SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
-- YOU DO SO AT YOUR OWN RISK, AND YOU ASSUME THE RESPONSIBILITY FOR THE
-- RESULTS. SHOULD THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
-- PROGRAM RELATED THERETO PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL LOSSES,
-- INCLUDING, BUT NOT LIMITED TO, ANY NECESSARY SERVICING, REPAIR OR CORRECTION
-- OF ANY PROPERTY INVOLVED TO THE MAXIMUM EXTEND PERMITTED BY LAW.
--
-- DISCLAIMER: IN NO EVENT, UNLESS REQUIRED BY LAW OR AGREED TO IN WRITING,
-- SHALL THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS OR ANY PERSON BE
-- LIABLE FOR ANY LOSS, EXPENSE OR DAMAGE, OF ANY TYPE OR NATURE ARISING OUT OF
-- THE USE OF, OR INABILITY TO USE THIS SPECIFICATION, SOFTWARE RELATED THERETO,
-- CODE AND/OR PROGRAM RELATED THERETO, INCLUDING, BUT NOT LIMITED TO, CLAIMS,
-- SUITS OR CAUSES OF ACTION INVOLVING ALLEGED INFRINGEMENT OF COPYRIGHTS,
-- PATENTS, TRADEMARKS, TRADE SECRETS, OR UNFAIR COMPETITION.
--
-- INDEMNIFICATION: TO THE MAXIMUM EXTEND PERMITTED BY LAW YOU AGREE TO
-- INDEMNIFY AND HOLD HARMLESS THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT
-- HOLDERS AND CONTRIBUTORS, AND EMPLOYEES, AND ANY PERSON FROM AND AGAINST ALL
-- CLAIMS, LIABILITIES, LOSSES, CAUSES OF ACTION, DAMAGES, JUDGMENTS, AND
-- EXPENSES, INCLUDING THE REASONABLE COST OF ATTORNEYS' FEES AND COURT COSTS,
-- FOR INJURIES OR DAMAGES TO THE PERSON OR PROPERTY OF THIRD PARTIES,
-- INCLUDING, WITHOUT LIMITATIONS, CONSEQUENTIAL, DIRECT AND INDIRECT DAMAGES
-- AND ANY ECONOMIC LOSSES, THAT ARISE OUT OF OR IN CONNECTION WITH YOUR USE,
-- MODIFICATION, OR DISTRIBUTION OF THIS SPECIFICATION, SOFTWARE RELATED
-- THERETO, CODE AND/OR PROGRAM RELATED THERETO, ITS OUTPUT, OR ANY ACCOMPANYING
-- DOCUMENTATION.
--
-- GOVERNING LAW: THE RELATIONSHIP BETWEEN YOU AND ROBERT BOSCH GMBH SHALL BE
-- GOVERNED SOLELY BY THE LAWS OF THE FEDERAL REPUBLIC OF GERMANY. THE
-- STIPULATIONS OF INTERNATIONAL CONVENTIONS REGARDING THE INTERNATIONAL SALE OF
-- GOODS SHALL NOT BE APPLICABLE. THE EXCLUSIVE LEGAL VENUE SHALL BE
-- DUESSELDORF, GERMANY.
--
-- MANDATORY LAW SHALL BE UNAFFECTED BY THE FOREGOING PARAGRAPHS.
--
-- INTELLECTUAL PROPERTY OWNERS/COPYRIGHT OWNERS/CONTRIBUTORS: ROBERT BOSCH
-- GMBH, ROBERT BOSCH PLATZ 1, 70839 GERLINGEN, GERMANY AND ITS LICENSORS.
--
-- ALL RIGHTS RESERVED.
--------------------------------------------------------------------------------
-- Project Name : GTM - Generic Timer Module
--------------------------------------------------------------------------------
-- Copyright   : Robert Bosch GmbH, Gerlingen, Germany
-- Department  : AE/EIY
-- Created     : 05.09.2012
--------------------------------------------------------------------------------
--:head-------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- Description : 
--------------------------------------------------------------------------------

-- define generic design parameters as arrays. Array index is MCS instance number
#if $(#dut_is_rm == 0) --rtl

AEI ASSIGN mcs_param_w      = 24 24 24 24 24 24 x
AEI ASSIGN mcs_param_t      = 8 8 8 8 8 8 x
AEI ASSIGN mcs_param_rdw    = 32 32 32 32 32 32 x
AEI ASSIGN mcs_param_nps    = 5 5 5 5 5 5 x
AEI ASSIGN mcs_param_raw    = 11 11 11 11 11 11 x
AEI ASSIGN mcs_param_usr    = 1 1 1 1 1 1 x
AEI ASSIGN mcs_mp0	    	= h#1000 h#1000 h#1000 h#1000 h#1000 h#1000 h#1000 x
AEI ASSIGN mcs_mp1	    	= h#1800 h#1800 h#1800 h#1800 h#1800 h#1800 h#1800 x

-- define generic design parameters for MCFG module
AEI ASSIGN mcfg_param_maw   = 10
AEI ASSIGN mcfg_erm_port    = 1     -- is 1 if ERM is provided as input port otherweise 0    

#else			--rm

AEI ASSIGN mcs_param_w      = 24 24 24 24 24 24 24 x
AEI ASSIGN mcs_param_t      = 8 8 8 8 8 8 8 x
AEI ASSIGN mcs_param_rdw    = 32 32 32 32 32 32 32 x
AEI ASSIGN mcs_param_nps    = 5 5 5 5 5 5 5 x
AEI ASSIGN mcs_param_raw    = 11 11 11 11 11 11 11 x
AEI ASSIGN mcs_param_usr    = 1 1 1 1 1 1 1 x
AEI ASSIGN mcs_mp0	    	= h#1000 h#1000 h#1000 h#1000 h#1000 h#1000 h#1000 x
AEI ASSIGN mcs_mp1	    	= h#1800 h#1800 h#1800 h#1800 h#1800 h#1800 h#1800 x

-- define generic design parameters for MCFG module
AEI ASSIGN mcfg_param_maw   = 10
AEI ASSIGN mcfg_erm_port    = 0     -- is 1 if ERM is provided as input port otherweise 0 
#endif
-------------------------------------------------------------------------------
-- This is the footer of the file.
-------------------------------------------------------------------------------
