--head:-------------------------------------------------------------------------
--:head-------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- Description : 								      
--------------------------------------------------------------------------------
#inc inc_cfg/gtm_device_cfg.cmd

#if $(#atom_instances_cnt == 0)
   ALL SYNC ALL
   AEI print "=================================================================================="
   AEI print "Warning : ATOM is not available in this device"
   AEI print "Warning : Test isn't executed"
   AEI print "=================================================================================="
   ALL SYNC ALL
   ALL QUIT
#endif

CLK FREQ  100 MHz
CLK RESET  1  12
CLK WAIT deltime 100 ns

#inc inc/chksig_labels.cmd

AEI WAIT deltime 1000 ns
ALL SYNC ALL

CHK ASSIGN loopcnt = 0
#if $(#atom_instances_cnt > 0)
    CHK ASSIGN loopcnt = 8
#endif
#if $(#atom_instances_cnt > 1)
    CHK ASSIGN loopcnt = 16
#endif
#if $(#atom_instances_cnt > 2)
    CHK ASSIGN loopcnt = 24
#endif
#if $(#atom_instances_cnt > 3)
    CHK ASSIGN loopcnt = 32
#endif
#if $(#atom_instances_cnt > 4)
    CHK ASSIGN loopcnt = 40
#endif


--DBI SET_RPT_LEVEL CHK INFO
ALL SYNC ALL
-- check generated OUT signal for ATOM0
CHK ASSIGN ATOM_OUT0_START = #ATOM0_OUT0
ALL SYNC ALL
#loop i #atom_channel_cnt[0]
CHK ADD_INSTR $(#i) WSE $(#ATOM_OUT0_START + #i) FE
CHK ADD_INSTR $(#i) WSE $(#ATOM_OUT0_START + #i) RE  
#eol

-- check generated OUT signal for ATOM1
#if $(#atom_instances_cnt > 1)
  CHK ASSIGN ATOM_OUT0_START = #ATOM1_OUT0
  ALL SYNC ALL
  #loop i #atom_channel_cnt[1]
  CHK ADD_INSTR $(#i) WSE $(#ATOM_OUT0_START + #i) FE
  CHK ADD_INSTR $(#i) WSE $(#ATOM_OUT0_START + #i) RE  
  #eol
#endif

-- check generated OUT signal for ATOM2
#if $(#atom_instances_cnt > 2)
  CHK ASSIGN ATOM_OUT0_START = #ATOM2_OUT0
  ALL SYNC ALL
  #loop i #atom_channel_cnt[2]
  CHK ADD_INSTR $(#i) WSE $(#ATOM_OUT0_START + #i) FE
  CHK ADD_INSTR $(#i) WSE $(#ATOM_OUT0_START + #i) RE  
  #eol
#endif

-- check generated OUT signal for ATOM3
#if $(#atom_instances_cnt > 3)
  CHK ASSIGN ATOM_OUT0_START = #ATOM3_OUT0
  ALL SYNC ALL
  #loop i #atom_channel_cnt[3]
  CHK ADD_INSTR $(#i) WSE $(#ATOM_OUT0_START + #i) FE
  CHK ADD_INSTR $(#i) WSE $(#ATOM_OUT0_START + #i) RE  
  #eol
#endif

-- check generated OUT signal for ATOM4
#if $(#atom_instances_cnt > 4)
  CHK ASSIGN ATOM_OUT0_START = #ATOM4_OUT0
  ALL SYNC ALL
  #loop i #atom_channel_cnt[4]
  CHK ADD_INSTR $(#i) WSE $(#ATOM_OUT0_START + #i) FE
  CHK ADD_INSTR $(#i) WSE $(#ATOM_OUT0_START + #i) RE  
  #eol
#endif

-- enable CHKSIG tasks
ALL SYNC ALL
#if $(#atom_instances_cnt != 0)
   #loop i $(#loopcnt)
       CHK ENABLE #i ON
   #eol
#endif


ALL SYNC ALL

AEI ASSIGN rd_cnt0 = 0
AEI ASSIGN wr_cnt0 = 0
AEI GET_READ_COUNTER_VAL rd_cnt0
AEI GET_WRITE_COUNTER_VAL wr_cnt0
AEI print "Access_counting Write " #wr_cnt0 "Read " #rd_cnt0

AEI print "======================================================================"
AEI print "Software integration tests:"
AEI print "======================================================================"

--DBI SET_RPT_LEVEL AEI INFO

AEI print "calling c-test 'atom_port_test'"
SWI RUN_SW atom_port_test

AEI WAIT deltime 10 us

ALL SYNC ALL

AEI WAIT deltime 100 us
ALL SYNC ALL
#if $(#atom_instances_cnt != 0)
  #loop i $(#loopcnt)
      CHK ENABLE #i OFF
  #eol
#else
  AEI print "Info: no ATOM resources available in this device!"
#endif
ALL SYNC ALL
AEI ASSIGN rd_cnt1 = 0
AEI ASSIGN wr_cnt1 = 0
AEI GET_READ_COUNTER_VAL rd_cnt1
AEI GET_WRITE_COUNTER_VAL wr_cnt1
AEI print "Access_counting Write " $(#wr_cnt1 - #wr_cnt0) "Read " $(#rd_cnt1 - #rd_cnt0)

ALL SYNC ALL
AEI print "======================================================================"
AEI print "End of Test"
AEI print "======================================================================"
ALL SYNC ALL
ALL QUIT

-------------------------------------------------------------------------------
-- Interrupt subroutine description
-------------------------------------------------------------------------------
#inc inc/empty_isr_out_signals.cmd

-------------------------------------------------------------------------------
-- This is the footer of the file.
-------------------------------------------------------------------------------
