// TARGET_SIMULATION=1: Simulation
// TARGET_SIMULATION=0: FPGA

#define UC_ALTERA 0
#define UC_IFX 1
#define UC_JDP 2

#ifndef GTM_RTL
  #ifndef GTM_REF
     #define TARGET_SIMULATION 0     
     #define UC_SOURCE UC_ALTERA
     #define GTM_ADDR_OFFSET 0x8000000
  #else
     #define TARGET_SIMULATION 1
     #define UC_SOURCE 0
  #endif
#else
  #define TARGET_SIMULATION 1
  #define UC_SOURCE 0
#endif

// checks are executed with gtm_halt applied
#define CHECK_WITH_GTM_HALT 0
// isr is executed with gtm_halt applied
#define ISR_WITH_GTM_HALT 0

// global disable of gtm_halt 
//#define GTM_HALT_IN_USE 1
#define GTM_HALT_IN_USE 0

// use loopback mode
// 0 internal
// 1 external
// 2 infineon
// 3 jdp
#define LOOP_BACK_INTERNAL 0
#define LOOP_BACK_EXTERNAL_TB 1
#define LOOP_BACK_INFINEON 2
#define LOOP_BACK_JDP 3

// define how much Tim instances are available for external loopback
// depends on portpin configurability
#define MAX_TOM_INSTANCES_DGB_TRC TOM_INSTANCES

//
// define amount of times to invoke testcase in the execution loop
#define TESTCASE_LOOP_CNT 2
    
//
// define if access to GTM on not word aligned address will be done
#define ISSUE_ILLEGAL_WORD_ACCESS 0

// define if HW reset is initalizing RAMS
#define ram_hw_init_from_reset_c  FALSE

#define GCLK_NUM_BASE 1000000
#define GCLK_DEN_BASE 1000000

#if TARGET_SIMULATION
  #define ERROR_MESSAGES 1
  #define EMBEDDED_REPORT 1
  #define DEBUG_MESSAGES 1
  #define DEBUG_MESSAGES_MCSSIGNATURE_LOG 0
  
  #define DEBUG_MESSAGES_MCSSIGNATURE 0
  #define DEBUG_ISR_CALLMESSAGES 0
  #define DEBUG_MESSAGES_TCERROR 1
  #define DEBUG_MESSAGES_WAIT_TBU 0

  #define SYS_CTRL          	*((gtm_ptr)((GTM_ADDR_OFFSET)+ 0x100000))
  #define IO_CTRL           	*((gtm_ptr)((GTM_ADDR_OFFSET)+ 0x100004))
  #define IO_LOOP_CTRL      	*((gtm_ptr)((GTM_ADDR_OFFSET)+ 0x100044))
  #define TIM_DEL0_CTRL     	*((gtm_ptr)((GTM_ADDR_OFFSET)+ 0x100048))
  #define TIM_DEL1_CTRL     	*((gtm_ptr)((GTM_ADDR_OFFSET)+ 0x10004C)) 
  #define TIM_AEISEL_CTRL   	*((gtm_ptr)((GTM_ADDR_OFFSET)+ 0x100050))
  #define LOOP_BACK LOOP_BACK_INTERNAL
//  #define LOOP_BACK LOOP_BACK_EXTERNAL_TB

  #define ADD_LOOPBACK_DELAY_CYCLES 0
#else
  #define ERROR_MESSAGES 1
  #define EMBEDDED_REPORT 1
  #define DEBUG_MESSAGES 1

  #define DEBUG_MESSAGES_MCSSIGNATURE_LOG 0
  #define DEBUG_MESSAGES_MCSSIGNATURE 0
  #define DEBUG_ISR_CALLMESSAGES 0
  #define DEBUG_MESSAGES_TCERROR 1
  #define DEBUG_MESSAGES_WAIT_TBU 0
  
  #define SYS_CTRL          	*((gtm_ptr)((GTM_ADDR_OFFSET)+ 0x100000))
  #define IO_CTRL           	*((gtm_ptr)((GTM_ADDR_OFFSET)+ 0x100004))
  #define IO_LOOP_CTRL      	*((gtm_ptr)((GTM_ADDR_OFFSET)+ 0x100044))
  #define TIM_DEL0_CTRL     	*((gtm_ptr)((GTM_ADDR_OFFSET)+ 0x100048))
  #define TIM_DEL1_CTRL     	*((gtm_ptr)((GTM_ADDR_OFFSET)+ 0x10004C))
//  #define TIM_AEISEL_CTRL   	*((gtm_ptr)((GTM_ADDR_OFFSET)+ 0x100050))

  #if UC_SOURCE == UC_ALTERA
    //#define LOOP_BACK LOOP_BACK_INTERNAL
    #define LOOP_BACK LOOP_BACK_EXTERNAL_TB
    #define ADD_LOOPBACK_DELAY_CYCLES 0
  #endif
  #if UC_SOURCE == UC_IFX
    #define ISSUE_ILLEGAL_WORD_ACCESS 0
    #define LOOP_BACK LOOP_BACK_INFINEON
    #define ADD_LOOPBACK_DELAY_CYCLES 0
    #define MAX_TOM_INSTANCES_DGB_TRC 1
    #define GCLK_NUM_BASE 1000000
    #define GCLK_DEN_BASE  800000
  #endif
  #if UC_SOURCE == UC_JDP
    #define ISSUE_ILLEGAL_WORD_ACCESS 0
    #define LOOP_BACK LOOP_BACK_JDP
    #define ADD_LOOPBACK_DELAY_CYCLES 0
  #endif
#endif

#define CALCULATE_TABLES 0
#define CALCULATE_TABLES_OUT 0

// ENABLE PRINT STATEMENTS
#define DBG_PRINT if(DEBUG_MESSAGES) cout
#define ERR_PRINT if(ERROR_MESSAGES) cout
