//head:-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// $Id: sw_atom_pmsm.cpp,v 1.2 2013/04/17 08:02:47 aohler Exp $
//------------------------------------------------------------------------------
// NO WARRANTIES: TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER THE
// INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND CONTRIBUTORS, NOR ANY
// PERSON, EITHER EXPRESSLY OR IMPLICITLY, WARRANTS ANY ASPECT OF THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// INCLUDING ANY OUTPUT OR RESULTS OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO UNLESS AGREED TO IN WRITING.
// THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED
// THERETO IS BEING PROVIDED "AS IS", WITHOUT ANY WARRANTY OF ANY TYPE OR
// NATURE, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY
// WARRANTY THAT THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO IS FREE FROM DEFECTS.
//
// ASSUMPTION OF RISK: THE RISK OF ANY AND ALL LOSS, DAMAGE, OR UNSATISFACTORY
// PERFORMANCE OF THIS SPECIFICATION (RESPECTIVELY THE PRODUCTS MAKING USE OF
// IT IN PART OR AS A WHOLE), SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM
// RELATED THERETO RESTS WITH YOU AS THE USER. TO THE MAXIMUM EXTENT PERMITTED
// BY LAW, NEITHER THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND
// CONTRIBUTORS, NOR ANY PERSON EITHER EXPRESSLY OR IMPLICITLY, MAKES ANY
// REPRESENTATION OR WARRANTY REGARDING THE APPROPRIOATENESS OF THE USE, OUTPUT,
// OR RESULTS OF THE USE OF THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE
// AND/OR PROGRAM RELATED THERETO IN TERMS OF ITS CORRECTNESS, ACCURACY,
// RELIABILITY, BEING CURRENT OR OTHERWISE. NOR DO THEY HAVE ANY OBLIGATION TO
// CORRECT ERRORS, MAKE CHANGES, SUPPORT THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, DISTRIBUTE UPDATES, OR PROVIDE
// NOTIFICATION OF ANY ERROR OR DEFECT, KNOWN OR UNKNOWN. IF YOU RELY UPON THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// YOU DO SO AT YOUR OWN RISK, AND YOU ASSUME THE RESPONSIBILITY FOR THE
// RESULTS. SHOULD THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL LOSSES,
// INCLUDING, BUT NOT LIMITED TO, ANY NECESSARY SERVICING, REPAIR OR CORRECTION
// OF ANY PROPERTY INVOLVED TO THE MAXIMUM EXTEND PERMITTED BY LAW.
//
// DISCLAIMER: IN NO EVENT, UNLESS REQUIRED BY LAW OR AGREED TO IN WRITING,
// SHALL THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS OR ANY PERSON BE
// LIABLE FOR ANY LOSS, EXPENSE OR DAMAGE, OF ANY TYPE OR NATURE ARISING OUT OF
// THE USE OF, OR INABILITY TO USE THIS SPECIFICATION, SOFTWARE RELATED THERETO,
// CODE AND/OR PROGRAM RELATED THERETO, INCLUDING, BUT NOT LIMITED TO, CLAIMS,
// SUITS OR CAUSES OF ACTION INVOLVING ALLEGED INFRINGEMENT OF COPYRIGHTS,
// PATENTS, TRADEMARKS, TRADE SECRETS, OR UNFAIR COMPETITION.
//
// INDEMNIFICATION: TO THE MAXIMUM EXTEND PERMITTED BY LAW YOU AGREE TO
// INDEMNIFY AND HOLD HARMLESS THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT
// HOLDERS AND CONTRIBUTORS, AND EMPLOYEES, AND ANY PERSON FROM AND AGAINST ALL
// CLAIMS, LIABILITIES, LOSSES, CAUSES OF ACTION, DAMAGES, JUDGMENTS, AND
// EXPENSES, INCLUDING THE REASONABLE COST OF ATTORNEYS' FEES AND COURT COSTS,
// FOR INJURIES OR DAMAGES TO THE PERSON OR PROPERTY OF THIRD PARTIES,
// INCLUDING, WITHOUT LIMITATIONS, CONSEQUENTIAL, DIRECT AND INDIRECT DAMAGES
// AND ANY ECONOMIC LOSSES, THAT ARISE OUT OF OR IN CONNECTION WITH YOUR USE,
// MODIFICATION, OR DISTRIBUTION OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, ITS OUTPUT, OR ANY ACCOMPANYING
// DOCUMENTATION.
//
// GOVERNING LAW: THE RELATIONSHIP BETWEEN YOU AND ROBERT BOSCH GMBH SHALL BE
// GOVERNED SOLELY BY THE LAWS OF THE FEDERAL REPUBLIC OF GERMANY. THE
// STIPULATIONS OF INTERNATIONAL CONVENTIONS REGARDING THE INTERNATIONAL SALE OF
// GOODS SHALL NOT BE APPLICABLE. THE EXCLUSIVE LEGAL VENUE SHALL BE
// DUESSELDORF, GERMANY.
//
// MANDATORY LAW SHALL BE UNAFFECTED BY THE FOREGOING PARAGRAPHS.
//
// INTELLECTUAL PROPERTY OWNERS/COPYRIGHT OWNERS/CONTRIBUTORS: ROBERT BOSCH
// GMBH, ROBERT BOSCH PLATZ 1, 70839 GERLINGEN, GERMANY AND ITS LICENSORS.
//
// ALL RIGHTS RESERVED.
//------------------------------------------------------------------------------
// Project Name : GTM - Generic Timer Module
//------------------------------------------------------------------------------
// Copyright   : Robert Bosch GmbH, Gerlingen, Germany
// Department  : AE/EIY
// Created     : 25.01.2011
//------------------------------------------------------------------------------
//:head-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// Description     : ATOM PMSM control apllication example
//============================================================================ 
// Important Notes : 
//============================================================================ 

#include <iostream>
#include "gtm.h"
#include <math.h>
#include "gtm_device_cfg.h"

using namespace std;

#define ARU_EMPTY_ADDR 0x1FE
#define F2A0_WRADDR0   0x51
#define F2A0_WRADDR1   0x52
#define F2A0_WRADDR2   0x53
#define F2A0_WRADDR3   0x54
#define F2A0_WRADDR4   0x55
#define F2A0_WRADDR5   0x56
#define F2A0_WRADDR6   0x57

#define mode_somi    (0<<0)
#define mode_somc    (1<<0)
#define mode_somp    (2<<0)
#define mode_soms    (3<<0)

#define aru_off    (0<<3)
#define aru_on     (1<<3)

#define sl_lo    (0<<11)
#define sl_hi    (1<<11)

#define osm_cont    (0<<26)
#define osm_one     (1<<26)

#define cmu_clk0    (0<<12)
#define cmu_clk1    (1<<12)
#define cmu_clk2    (2<<12)
#define cmu_clk3    (3<<12)
#define cmu_clk4    (4<<12)
#define cmu_clk5    (5<<12)
#define cmu_clk6    (6<<12)
#define cmu_clk7    (7<<12)

#define trig_chx    (0<<24)
#define trig_ccu0    (1<<24)

#define rst_on_cm0    (0<<20)
#define rst_on_trig    (1<<20)

#define T0                 1000      // period on channel 0: 1000*50ns = 20kHz
#define CH7_Pulse_length   100       // high pulse length ch7: 100*50ns = 5000 ns
#define PI 3.14159265

#define ARU_ACB 0x0C000000          // ACB=C transfered via ARU

extern unsigned int nr_of_calls;

//------------------------------------------------------------------------------
// main thread:

int atom_pmsm() {

  // required declaration for HAL
  gtm_ptr p;
  int error = 0;
  unsigned int status = 0;

  cout << "configure CMU" << endl;
  cout << "========================================================" << endl;
  CMU_GCLK_NUM   = 0x0000FFFF;
  CMU_GCLK_DEN   = 0x0000FFFF;

  CMU_CLK_0_CTRL  = 0x00000001; // sys_clk_perios *2 = 20ns
  CMU_CLK_1_CTRL  = 0x00000002; // sys_clk_perios *3 = 30ns
  CMU_CLK_2_CTRL  = 0x00000003; // sys_clk_perios *4 = 40ns
  CMU_CLK_3_CTRL  = 0x00000004; // sys_clk_perios *5 = 50ns

  CMU_CLK_EN     = 0x00000080; // enable CMU clock 3
  status = CMU_CLK_EN;
  if (status != 0x000000C0) {
    cout << "ERROR: read value 0x" << hex << status 
	 << " not equat to expected value 0x000000C0" << endl;
  }

  cout << "configure FIFO 0 to 6: store SR0,SR1 values for ATOM" << endl;
  cout << "========================================================" << endl;

  F2A0_CH0_ARU_RD_FIFO  = ARU_EMPTY_ADDR;  // unused
  F2A0_CH0_STR_CFG      = 0x00060000;      // TMODE=2, DIR=1 (FIFO to ARU)
  FIFO0_CH0_CTRL        = 0x00000000;      

  F2A0_CH1_ARU_RD_FIFO  = ARU_EMPTY_ADDR;  // unused
  F2A0_CH1_STR_CFG      = 0x00060000;      // TMODE=2, DIR=1 (FIFO to ARU)
  FIFO0_CH1_CTRL        = 0x00000000;      

  F2A0_CH2_ARU_RD_FIFO  = ARU_EMPTY_ADDR;  // unused
  F2A0_CH2_STR_CFG      = 0x00060000;      // TMODE=2, DIR=1 (FIFO to ARU)
  FIFO0_CH2_CTRL        = 0x00000000;      

  F2A0_CH3_ARU_RD_FIFO  = ARU_EMPTY_ADDR;  // unused
  F2A0_CH3_STR_CFG      = 0x00060000;      // TMODE=2, DIR=1 (FIFO to ARU)
  FIFO0_CH3_CTRL        = 0x00000000;      

  F2A0_CH4_ARU_RD_FIFO  = ARU_EMPTY_ADDR;  // unused
  F2A0_CH4_STR_CFG      = 0x00060000;      // TMODE=2, DIR=1 (FIFO to ARU)
  FIFO0_CH4_CTRL        = 0x00000000;      

  F2A0_CH5_ARU_RD_FIFO  = ARU_EMPTY_ADDR;  // unused
  F2A0_CH5_STR_CFG      = 0x00060000;      // TMODE=2, DIR=1 (FIFO to ARU)
  FIFO0_CH5_CTRL        = 0x00000000;      

  F2A0_CH6_ARU_RD_FIFO  = ARU_EMPTY_ADDR;  // unused
  F2A0_CH6_STR_CFG      = 0x00060000;      // TMODE=2, DIR=1 (FIFO to ARU)
  FIFO0_CH6_CTRL        = 0x00000000;      

  AFD0_CH0_BUF_ACC      = ARU_ACB+(T0/2)-(T0/4+(0*((T0/4)-10))); // new SR0
  AFD0_CH0_BUF_ACC      = ARU_ACB+(T0/2)+(T0/4+(0*((T0/4)-10))); // new SR1
		        
  AFD0_CH1_BUF_ACC      = ARU_ACB+(T0/2)-(T0/4+(0*((T0/4)-10))); // new SR0
  AFD0_CH1_BUF_ACC      = ARU_ACB+(T0/2)+(T0/4+(0*((T0/4)-10))); // new SR1
		        
  AFD0_CH2_BUF_ACC      = ARU_ACB+(T0/2)-(T0/4+(int)(0.866*((T0/4)-10))); // new SR0
  AFD0_CH2_BUF_ACC      = ARU_ACB+(T0/2)+(T0/4+(int)(0.866*((T0/4)-10))); // new SR1
  		        
  AFD0_CH3_BUF_ACC      = ARU_ACB+(T0/2)-(T0/4+(int)(0.866*((T0/4)-10))); // new SR0
  AFD0_CH3_BUF_ACC      = ARU_ACB+(T0/2)+(T0/4+(int)(0.866*((T0/4)-10))); // new SR1
  		        
  AFD0_CH4_BUF_ACC      = ARU_ACB+(T0/2)-(T0/4+(int)(-0.866*((T0/4)-10))); // new SR0
  AFD0_CH4_BUF_ACC      = ARU_ACB+(T0/2)+(T0/4+(int)(-0.866*((T0/4)-10))); // new SR1
  		        
  AFD0_CH5_BUF_ACC      = ARU_ACB+(T0/2)-(T0/4+(int)(-0.866*((T0/4)-10))); // new SR0
  AFD0_CH5_BUF_ACC      = ARU_ACB+(T0/2)+(T0/4+(int)(-0.866*((T0/4)-10))); // new SR1
  
  AFD0_CH6_BUF_ACC      = ARU_ACB+(2*T0);              // SR0 
  AFD0_CH6_BUF_ACC      = ARU_ACB+CH7_Pulse_length;    // SR1

  cout << "configure ATOM channel 0 to 7" << endl;
  cout << "=======================================================" << endl;

  ATOM0_CH1_RDADDR   = (F2A0_WRADDR0<<16)+(F2A0_WRADDR0);
  ATOM0_CH2_RDADDR   = (F2A0_WRADDR1<<16)+(F2A0_WRADDR1);
  ATOM0_CH3_RDADDR   = (F2A0_WRADDR2<<16)+(F2A0_WRADDR2);
  ATOM0_CH4_RDADDR   = (F2A0_WRADDR3<<16)+(F2A0_WRADDR3);
  ATOM0_CH5_RDADDR   = (F2A0_WRADDR4<<16)+(F2A0_WRADDR4);
  ATOM0_CH6_RDADDR   = (F2A0_WRADDR5<<16)+(F2A0_WRADDR5);

  ATOM0_CH7_RDADDR   = (F2A0_WRADDR6<<16)+(F2A0_WRADDR6);

  // channel 0 is master channel that defines period of PWM
  ATOM0_CH0_CTRL     = (mode_somp)+(sl_hi)+(trig_ccu0)+(cmu_clk3);

  // channel 1 to 6 are synchronized to channel 1 and middle symmetrical
  ATOM0_CH1_CTRL     = (mode_somp)+(aru_on)+(sl_hi)+(rst_on_trig)+(cmu_clk3);
  ATOM0_CH2_CTRL     = (mode_somp)+(aru_on)+(sl_lo)+(rst_on_trig)+(cmu_clk3);
  ATOM0_CH3_CTRL     = (mode_somp)+(aru_on)+(sl_hi)+(rst_on_trig)+(cmu_clk3);
  ATOM0_CH4_CTRL     = (mode_somp)+(aru_on)+(sl_lo)+(rst_on_trig)+(cmu_clk3);
  ATOM0_CH5_CTRL     = (mode_somp)+(aru_on)+(sl_hi)+(rst_on_trig)+(cmu_clk3);
  ATOM0_CH6_CTRL     = (mode_somp)+(aru_on)+(sl_lo)+(rst_on_trig)+(cmu_clk3);
  
  // channel 7 triggers reload of SRx register
  ATOM0_CH7_CTRL     = (mode_somp)+(aru_on)+(sl_hi)+(cmu_clk3)+(trig_ccu0);

  // initial values for ATOM channel 0:
  ATOM0_CH0_CM0      = T0;          // period 1000*50ns = 20kHz
  ATOM0_CH0_CM1      = T0/2;     // duty cycle 500*50ns
  ATOM0_CH0_CN0      = 0x00000000;
  ATOM0_CH0_SR0      = T0;
  ATOM0_CH0_SR1      = T0/2;

  // initial value for channel 7:
  ATOM0_CH7_CM1      = CH7_Pulse_length;  // falling edge
  ATOM0_CH7_CM0      = T0;            // rising edge
  ATOM0_CH7_SR1      = CH7_Pulse_length;
  ATOM0_CH7_SR0      = T0;

  ATOM0_CH7_IRQ_EN  = 0xFFFFFFFF;   // enable interrupts of ATOM0_CH7
  status = ATOM0_CH7_IRQ_EN;
  if (status != 0x00000003) {
    cout << "ERROR: read value 0x" << hex << status 
	 << " not equal to expected value 0x00000003" << endl;
  }

  cout << "configure ATOM global channel control unit" << endl;
  cout << "=======================================================" << endl;

  F2A0_ENABLE      = 0x00002AAA;      // enable streams 0 to 6

  ATOM0_AGC_INT_TRIG = 0x00008000;      // int. trig channel 7

  ATOM0_AGC_GLB_CTRL = 0x00020000;	// update enable of ch 0
  // normally enable only output of channel 1 to 6
  // for demonstration, enable output of channel 0 to 7
  ATOM0_AGC_OUTEN_CTRL = 0x0000AAAA;  // enable output 0 to 7 (1 to 6)
  ATOM0_AGC_ENDIS_CTRL = 0x0000AAAA;  // anable all channel
  ATOM0_AGC_FUPD_CTRL  = 0xAAAAAAAA;  // force update on ch 1 to 7
  status = ATOM0_AGC_FUPD_CTRL;
  cout << "ATOM0_AGC_FUPD_CTRL = 0x" << hex << status<< endl;

  cout << "== start ATOM with host trigger" << endl;
  ATOM0_AGC_GLB_CTRL   = 0x00000001;      // host trigger for start of ATOM0

  status = ATOM0_AGC_ENDIS_STAT;
  cout << "ATOM0_AGC_ENDIS_STAT = 0x" << hex << status<< endl;

  // after enable by host trigger set force update flags for next internal trigger
  ATOM0_AGC_FUPD_CTRL  = 0xAAA9AAA9;      // force update on ch 1 to 7
  status = ATOM0_AGC_FUPD_CTRL;
  cout << "ATOM0_AGC_FUPD_CTRL = 0x" << hex << status<< endl;

  // to check if main thread is interrupted by isr, uncomment the following
//  for (int i=0; i<5000; i++) {
//    status = TBU_CH0_BASE;    // dummy read replaces a wait until ..
//    cout << dec << i << " dummy read to TBU_CH0_BASE in main thread atom_pmsm" << endl;
//  }


  //---------------------------------------------------------------------------
  return error;

}

//------------------------------------------------------------------------------
// ISR:

int atom_pmsm_isr(int number) {

  unsigned int status;

  if (number == 903) {

    nr_of_calls++;
    cout << "ISR call number " << dec << nr_of_calls << endl; 

    status = ATOM0_CH7_IRQ_NOTIFY;
    cout << "ISR: ATOM0_CH7_IRQ_NOTIFY = 0x" << hex << status << endl;
    ATOM0_CH7_IRQ_NOTIFY  =  0x00000007;

    // sinus factor
    double sin_fact1 = sin(((nr_of_calls*10)%360)*PI/180);
    double sin_fact2 = sin(((nr_of_calls*10+120)%360)*PI/180);
    double sin_fact3 = sin(((nr_of_calls*10+240)%360)*PI/180);

    // releoad fifo 0 to 6 with new values    
    AFD0_CH0_BUF_ACC  = ARU_ACB+(T0/2)-(T0/4+(int)(sin_fact1*((T0/4)-10))); // new SR0
    AFD0_CH0_BUF_ACC  = ARU_ACB+(T0/2)+(T0/4+(int)(sin_fact1*((T0/4)-10))); // new SR1
  
    AFD0_CH1_BUF_ACC  = ARU_ACB+(T0/2)-(T0/4+(int)(sin_fact1*((T0/4)-10))); // new SR0
    AFD0_CH1_BUF_ACC  = ARU_ACB+(T0/2)+(T0/4+(int)(sin_fact1*((T0/4)-10))); // new SR1
  
    AFD0_CH2_BUF_ACC  = ARU_ACB+(T0/2)-(T0/4+(int)(sin_fact2*((T0/4)-10))); // new SR0
    AFD0_CH2_BUF_ACC  = ARU_ACB+(T0/2)+(T0/4+(int)(sin_fact2*((T0/4)-10))); // new SR1
  
    AFD0_CH3_BUF_ACC  = ARU_ACB+(T0/2)-(T0/4+(int)(sin_fact2*((T0/4)-10))); // new SR0
    AFD0_CH3_BUF_ACC  = ARU_ACB+(T0/2)+(T0/4+(int)(sin_fact2*((T0/4)-10))); // new SR1
  
    AFD0_CH4_BUF_ACC  = ARU_ACB+(T0/2)-(T0/4+(int)(sin_fact3*((T0/4)-10))); // new SR0
    AFD0_CH4_BUF_ACC  = ARU_ACB+(T0/2)+(T0/4+(int)(sin_fact3*((T0/4)-10))); // new SR1
  
    AFD0_CH5_BUF_ACC  = ARU_ACB+(T0/2)-(T0/4+(int)(sin_fact3*((T0/4)-10))); // new SR0
    AFD0_CH5_BUF_ACC  = ARU_ACB+(T0/2)+(T0/4+(int)(sin_fact3*((T0/4)-10))); // new SR1
  
    AFD0_CH6_BUF_ACC  = ARU_ACB+(2*T0);              // SR0
    AFD0_CH6_BUF_ACC  = ARU_ACB+CH7_Pulse_length;    // SR1
  
    status = ATOM0_CH1_CM0;
    cout << "ISR: ATOM_CH1_CM0 = 0x" << hex << status << endl;
    status = ATOM0_CH1_CM1;
    cout << "ISR: ATOM_CH1_CM1 = 0x" << hex << status << endl;
    status = ATOM0_CH1_SR0;
    cout << "ISR: ATOM_CH1_SR0 = 0x" << hex << status << endl;
    status = ATOM0_CH1_SR1;
    cout << "ISR: ATOM_CH1_SR1 = 0x" << hex << status << endl;

    return 0;
  } else {
    cout << "no ISR for interrupt " << dec << number << endl;
    return 1;
  }
}
