//head:-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// $Id: sw_dpll_an013.cpp,v 1.4 2013/09/20 11:19:34 opfitzer Exp $
//------------------------------------------------------------------------------
// NO WARRANTIES: TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER THE
// INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND CONTRIBUTORS, NOR ANY
// PERSON, EITHER EXPRESSLY OR IMPLICITLY, WARRANTS ANY ASPECT OF THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// INCLUDING ANY OUTPUT OR RESULTS OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO UNLESS AGREED TO IN WRITING.
// THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED
// THERETO IS BEING PROVIDED "AS IS", WITHOUT ANY WARRANTY OF ANY TYPE OR
// NATURE, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY
// WARRANTY THAT THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO IS FREE FROM DEFECTS.
//
// ASSUMPTION OF RISK: THE RISK OF ANY AND ALL LOSS, DAMAGE, OR UNSATISFACTORY
// PERFORMANCE OF THIS SPECIFICATION (RESPECTIVELY THE PRODUCTS MAKING USE OF
// IT IN PART OR AS A WHOLE), SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM
// RELATED THERETO RESTS WITH YOU AS THE USER. TO THE MAXIMUM EXTENT PERMITTED
// BY LAW, NEITHER THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND
// CONTRIBUTORS, NOR ANY PERSON EITHER EXPRESSLY OR IMPLICITLY, MAKES ANY
// REPRESENTATION OR WARRANTY REGARDING THE APPROPRIOATENESS OF THE USE, OUTPUT,
// OR RESULTS OF THE USE OF THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE
// AND/OR PROGRAM RELATED THERETO IN TERMS OF ITS CORRECTNESS, ACCURACY,
// RELIABILITY, BEING CURRENT OR OTHERWISE. NOR DO THEY HAVE ANY OBLIGATION TO
// CORRECT ERRORS, MAKE CHANGES, SUPPORT THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, DISTRIBUTE UPDATES, OR PROVIDE
// NOTIFICATION OF ANY ERROR OR DEFECT, KNOWN OR UNKNOWN. IF YOU RELY UPON THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// YOU DO SO AT YOUR OWN RISK, AND YOU ASSUME THE RESPONSIBILITY FOR THE
// RESULTS. SHOULD THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL LOSSES,
// INCLUDING, BUT NOT LIMITED TO, ANY NECESSARY SERVICING, REPAIR OR CORRECTION
// OF ANY PROPERTY INVOLVED TO THE MAXIMUM EXTEND PERMITTED BY LAW.
//
// DISCLAIMER: IN NO EVENT, UNLESS REQUIRED BY LAW OR AGREED TO IN WRITING,
// SHALL THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS OR ANY PERSON BE
// LIABLE FOR ANY LOSS, EXPENSE OR DAMAGE, OF ANY TYPE OR NATURE ARISING OUT OF
// THE USE OF, OR INABILITY TO USE THIS SPECIFICATION, SOFTWARE RELATED THERETO,
// CODE AND/OR PROGRAM RELATED THERETO, INCLUDING, BUT NOT LIMITED TO, CLAIMS,
// SUITS OR CAUSES OF ACTION INVOLVING ALLEGED INFRINGEMENT OF COPYRIGHTS,
// PATENTS, TRADEMARKS, TRADE SECRETS, OR UNFAIR COMPETITION.
//
// INDEMNIFICATION: TO THE MAXIMUM EXTEND PERMITTED BY LAW YOU AGREE TO
// INDEMNIFY AND HOLD HARMLESS THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT
// HOLDERS AND CONTRIBUTORS, AND EMPLOYEES, AND ANY PERSON FROM AND AGAINST ALL
// CLAIMS, LIABILITIES, LOSSES, CAUSES OF ACTION, DAMAGES, JUDGMENTS, AND
// EXPENSES, INCLUDING THE REASONABLE COST OF ATTORNEYS' FEES AND COURT COSTS,
// FOR INJURIES OR DAMAGES TO THE PERSON OR PROPERTY OF THIRD PARTIES,
// INCLUDING, WITHOUT LIMITATIONS, CONSEQUENTIAL, DIRECT AND INDIRECT DAMAGES
// AND ANY ECONOMIC LOSSES, THAT ARISE OUT OF OR IN CONNECTION WITH YOUR USE,
// MODIFICATION, OR DISTRIBUTION OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, ITS OUTPUT, OR ANY ACCOMPANYING
// DOCUMENTATION.
//
// GOVERNING LAW: THE RELATIONSHIP BETWEEN YOU AND ROBERT BOSCH GMBH SHALL BE
// GOVERNED SOLELY BY THE LAWS OF THE FEDERAL REPUBLIC OF GERMANY. THE
// STIPULATIONS OF INTERNATIONAL CONVENTIONS REGARDING THE INTERNATIONAL SALE OF
// GOODS SHALL NOT BE APPLICABLE. THE EXCLUSIVE LEGAL VENUE SHALL BE
// DUESSELDORF, GERMANY.
//
// MANDATORY LAW SHALL BE UNAFFECTED BY THE FOREGOING PARAGRAPHS.
//
// INTELLECTUAL PROPERTY OWNERS/COPYRIGHT OWNERS/CONTRIBUTORS: ROBERT BOSCH
// GMBH, ROBERT BOSCH PLATZ 1, 70839 GERLINGEN, GERMANY AND ITS LICENSORS.
//
// ALL RIGHTS RESERVED.
//------------------------------------------------------------------------------
// Project Name : GTM - Generic Timer Module
//------------------------------------------------------------------------------
// Copyright   : Robert Bosch GmbH, Gerlingen, Germany
// Department  : AE/EIY
// Created     : 10.08.2011
//------------------------------------------------------------------------------
//:head-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// Description     : Application note AN013: DPLL PMT Calculation
//============================================================================ 
// Important Notes : 
//============================================================================ 

#include <iostream>
#include "platform.h"
#include "gtm.h"         // includes also register_map.h
#include "functions.h"
#include "gtm_device_cfg.h"
#include "dpll_def.h"
#include "dpll_functions.h"
#include "loopback.h"

//#include <math.h>
//#include <cstdlib>
//#include "aru_write_addr_map.h"

using namespace std;

#ifndef MCS_ARCH 
#   error "require preprocessor variable MCS_ARCH"
#elif MCS_ARCH > 2
#   error "bad value for MCS_ARCH"
#endif

extern unsigned int dut_is_rm;

void tb_setup(void);
void init_tbu(void);
void init_dpll(void);

unsigned mcs0_mem[] = { 
    0xE0000208,
    0xE0000234,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000000,
    0x00000190,
    0x0001B000,
    0xA0010200,
    0xA1010204,
    0x19000003,
    0x12000001,
    0xF2A00001,
    0xB0110000,
    0xB450018D,
    0xE8810230,
    0xB4510001,
    0xE0000220,
    0x48FFFFFE,
    0xA0010200,
    0xA1010204,
    0x1900001F,
    0xB0110003,
    0x12000001,
    0xF2A00001,
    0x19000003,
    0xB0110002,
    0xB4500121,
    0x58000002,
    0x48FFFFFE
};

//------------------------------------------------------------------------------
// main thread:

int dpll_an013() {
  // required declaration for HAL
  gtm_ptr p;
  unsigned int tmp;

  // testbench setup
  tb_setup();
  
  // determine underlying hardware
  dut_is_rm   = GTM_REV;
  cout << "Device revision number: " << hex << dut_is_rm << endl;
  dut_is_rm >>= 20;
  if (dut_is_rm == 0x100)
    dut_is_rm = 1;
  else
    dut_is_rm = 0;

  cout << "configure CMU" << endl;
  cout << "========================================================" << endl;
  // setup global clock divider
  CMU_GCLK_NUM 	= 0xFFFFFF;		// define 100 MHz clock
  CMU_GCLK_DEN 	= 0xFFFFFF;

  // setup the CMU_CLKx prescalers
  CMU_CLK_0_CTRL	= 0x4;			// define 20 MHz clock
  CMU_CLK_1_CTRL	= 0x0;
  CMU_CLK_2_CTRL	= 0x0;
  CMU_CLK_3_CTRL	= 0x0;
  CMU_CLK_4_CTRL	= 0x0;
  CMU_CLK_5_CTRL	= 0x0;
  CMU_CLK_6_CTRL	= 0x0;
  CMU_CLK_7_CTRL	= 0x0;

  // enable the clock prescalers
  CMU_CLK_EN		= 0x2;

  cout << "Configure TBU" << endl;
  cout << "=======================================================" << endl;
  init_tbu();

  cout << "Configure TIM0 channel 0" << endl;
  cout << "=======================================================" << endl;
  TIM0_CH0_IRQ_EN	=   0x1;		// enable NEWVAL IRQ
  TIM0_CH0_CTRL     =   0x00000040; 
  TIM0_CH0_CTRL		=   0x00004045; // for TRIGGER 

  cout << "Configure DPLL" << endl;
  cout << "=======================================================" << endl;
  // setup DPLL PMTR read addresses before DPLL enable
  cout << "Setup DPLL PMTR 14, 15 first" << endl;
  DPLL_ID_PMTR_14       = 0x077;		// receive PMT value from MCS0 CH0
  DPLL_ID_PMTR_15       = 0x079;		// receive PMT value from MCS0 CH1
  init_dpll();

  // start the MCS ch0, ch1 programs
  cout << "Initialize MCS0 RAM..." << sizeof(mcs0_mem) << endl;
  p = &MCS0_MEM;
  for (tmp = 0; tmp<sizeof(mcs0_mem); tmp++) {
	p[tmp] = mcs0_mem[tmp];
  }
  MCS0_CH0_CTRL   = 0x1;
  MCS0_CH1_IRQ_EN = 0x1;   // enable channel 1 IRQ
  MCS0_CH1_CTRL   = 0x1;

  // setup ATOM channels 1 and 2
  cout << "Setup ATOM CH1,2..." << endl;
  ATOM0_CH1_RDADDR		= 0x078;		// get data from MCS0 ch0
  ATOM0_CH1_IRQ_EN		= 0x3;          // enable CCU0/1 IRQ
  ATOM0_CH1_CTRL		= 0x9;			// ATOM0 ch1 in SOMC, ARU enabled
  ATOM0_CH2_RDADDR		= 0x018E007A;	// get data from DPLL ch15 and MCS0 ch1
  ATOM0_CH2_CTRL		= 0x9;			// ATOM0 ch2 in SOMC, ARU enabled

  ATOM0_AGC_OUTEN_STAT	= 0x0028;		// enable ch1 and ch2 output
  ATOM0_AGC_ENDIS_STAT	= 0x0028;		// enable ch1 and ch2
  
  // setup and enable DPLL action calculation for channels 14 and 15
  cout << "Enable DPLL PMTR 14, 15..." << endl;
  DPLL_CTRL_3			= 0x00C0C000;	// enable actions for CH14 and CH15

  // initialize get of lock interrupt
  cout << "Enable DPLL GL1I interrupt..." << endl;
  tmp = DPLL_IRQ_EN;
  tmp |=0x00002000;
  DPLL_IRQ_EN = tmp;

  return 0;
}

//=============================================================================
// ISR:

int dpll_an013_isr(int number) {
	
  unsigned int ach1ccu0  = 0;	// match time of ATOM0 CH1 CCU0
  unsigned int ach1ccu1  = 0;	// match time of ATOM0 CH1 CCU1
  unsigned int mch1r4    = 0;	// match time of MCS0 CH1 R4 --> received from ATOM0 CH2 CCU0
  unsigned int mch1r5    = 0;	// match time of MCS0 CH1 R5 --> received from ATOM0 CH2 CCU1

  cout << "-----> ISR call of interrupt " << dec << number << endl; 
//
  switch (number) {

	case 113: 
	  cout << "DPLL GL1I interrupt" << endl;
      MCS0_STRG = 0x1; // TRIGGER MCS channel programs to start

	  break;

	case 401: 
	  cout << "MCS0 CH1 IRQ" << endl;
	  MCS0_CH1_IRQ_NOTIFY = 0x1;  // clear IRQ
	  // check ATOM CH0, CH1 MATCH times
      ach1ccu0 = ATOM0_CH1_SR0;
	  mch1r4   = MCS0_CH1_R4;
	  if ((ach1ccu0 != mch1r4) || (ach1ccu0==0) || (mch1r4==0)) {
		  cout << "ERROR: Wrong TBU_TS0 match time for PMT!" << endl;
		  break;
	  }
      ach1ccu1 = ATOM0_CH1_SR1;
      mch1r5   = MCS0_CH1_R5;
	  if ((ach1ccu1 != mch1r5) || (ach1ccu1==0) || (mch1r5==0)) {
		  cout << "ERROR: Wrong TBU_TS1 match time for PMT!" << endl;
		  break;
	  }
	  cout << "AN013 PMT checks successful." << endl;
      break;

	case 901: 
	  cout << "ATOM0 CH1 interrupt" << endl;
	  // disable NOTIFY bit
	  ATOM0_CH1_IRQ_NOTIFY = 0x3;
	  // Cancel MCS0 CH0 ARU transfer --> will stop MCS0 CH0

#if MCS_ARCH == 1 
      MCS0_RST = 0x100;
#elif MCS_ARCH == 2
      MCS0_CAT = 0x01;
#endif
	  break;

	default:
	  break;
  }

  return 0;
}
