//head:-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// $Id: sw_encoder1.cpp,v 1.2 2012/02/13 13:26:36 jhanisch Exp $
//------------------------------------------------------------------------------
// NO WARRANTIES: TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER THE
// INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND CONTRIBUTORS, NOR ANY
// PERSON, EITHER EXPRESSLY OR IMPLICITLY, WARRANTS ANY ASPECT OF THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// INCLUDING ANY OUTPUT OR RESULTS OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO UNLESS AGREED TO IN WRITING.
// THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED
// THERETO IS BEING PROVIDED "AS IS", WITHOUT ANY WARRANTY OF ANY TYPE OR
// NATURE, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY
// WARRANTY THAT THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO IS FREE FROM DEFECTS.
//
// ASSUMPTION OF RISK: THE RISK OF ANY AND ALL LOSS, DAMAGE, OR UNSATISFACTORY
// PERFORMANCE OF THIS SPECIFICATION (RESPECTIVELY THE PRODUCTS MAKING USE OF
// IT IN PART OR AS A WHOLE), SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM
// RELATED THERETO RESTS WITH YOU AS THE USER. TO THE MAXIMUM EXTENT PERMITTED
// BY LAW, NEITHER THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND
// CONTRIBUTORS, NOR ANY PERSON EITHER EXPRESSLY OR IMPLICITLY, MAKES ANY
// REPRESENTATION OR WARRANTY REGARDING THE APPROPRIOATENESS OF THE USE, OUTPUT,
// OR RESULTS OF THE USE OF THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE
// AND/OR PROGRAM RELATED THERETO IN TERMS OF ITS CORRECTNESS, ACCURACY,
// RELIABILITY, BEING CURRENT OR OTHERWISE. NOR DO THEY HAVE ANY OBLIGATION TO
// CORRECT ERRORS, MAKE CHANGES, SUPPORT THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, DISTRIBUTE UPDATES, OR PROVIDE
// NOTIFICATION OF ANY ERROR OR DEFECT, KNOWN OR UNKNOWN. IF YOU RELY UPON THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// YOU DO SO AT YOUR OWN RISK, AND YOU ASSUME THE RESPONSIBILITY FOR THE
// RESULTS. SHOULD THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL LOSSES,
// INCLUDING, BUT NOT LIMITED TO, ANY NECESSARY SERVICING, REPAIR OR CORRECTION
// OF ANY PROPERTY INVOLVED TO THE MAXIMUM EXTEND PERMITTED BY LAW.
//
// DISCLAIMER: IN NO EVENT, UNLESS REQUIRED BY LAW OR AGREED TO IN WRITING,
// SHALL THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS OR ANY PERSON BE
// LIABLE FOR ANY LOSS, EXPENSE OR DAMAGE, OF ANY TYPE OR NATURE ARISING OUT OF
// THE USE OF, OR INABILITY TO USE THIS SPECIFICATION, SOFTWARE RELATED THERETO,
// CODE AND/OR PROGRAM RELATED THERETO, INCLUDING, BUT NOT LIMITED TO, CLAIMS,
// SUITS OR CAUSES OF ACTION INVOLVING ALLEGED INFRINGEMENT OF COPYRIGHTS,
// PATENTS, TRADEMARKS, TRADE SECRETS, OR UNFAIR COMPETITION.
//
// INDEMNIFICATION: TO THE MAXIMUM EXTEND PERMITTED BY LAW YOU AGREE TO
// INDEMNIFY AND HOLD HARMLESS THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT
// HOLDERS AND CONTRIBUTORS, AND EMPLOYEES, AND ANY PERSON FROM AND AGAINST ALL
// CLAIMS, LIABILITIES, LOSSES, CAUSES OF ACTION, DAMAGES, JUDGMENTS, AND
// EXPENSES, INCLUDING THE REASONABLE COST OF ATTORNEYS' FEES AND COURT COSTS,
// FOR INJURIES OR DAMAGES TO THE PERSON OR PROPERTY OF THIRD PARTIES,
// INCLUDING, WITHOUT LIMITATIONS, CONSEQUENTIAL, DIRECT AND INDIRECT DAMAGES
// AND ANY ECONOMIC LOSSES, THAT ARISE OUT OF OR IN CONNECTION WITH YOUR USE,
// MODIFICATION, OR DISTRIBUTION OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, ITS OUTPUT, OR ANY ACCOMPANYING
// DOCUMENTATION.
//
// GOVERNING LAW: THE RELATIONSHIP BETWEEN YOU AND ROBERT BOSCH GMBH SHALL BE
// GOVERNED SOLELY BY THE LAWS OF THE FEDERAL REPUBLIC OF GERMANY. THE
// STIPULATIONS OF INTERNATIONAL CONVENTIONS REGARDING THE INTERNATIONAL SALE OF
// GOODS SHALL NOT BE APPLICABLE. THE EXCLUSIVE LEGAL VENUE SHALL BE
// DUESSELDORF, GERMANY.
//
// MANDATORY LAW SHALL BE UNAFFECTED BY THE FOREGOING PARAGRAPHS.
//
// INTELLECTUAL PROPERTY OWNERS/COPYRIGHT OWNERS/CONTRIBUTORS: ROBERT BOSCH
// GMBH, ROBERT BOSCH PLATZ 1, 70839 GERLINGEN, GERMANY AND ITS LICENSORS.
//
// ALL RIGHTS RESERVED.
//------------------------------------------------------------------------------
// Project Name : GTM - Generic Timer Module
//------------------------------------------------------------------------------
// Copyright   : Robert Bosch GmbH, Gerlingen, Germany
// Department  : AE/EIY
// Created     : 25.01.2011
//------------------------------------------------------------------------------
//:head-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// Description     : ATOM PMSM control apllication example
//============================================================================ 
// Important Notes : 
//============================================================================ 

#include <iostream>
#include "gtm.h"
#include <math.h>
#include "gtm_device_cfg.h"

using namespace std;



#define mode_tiem (0x2 << 1)
#define isl (0x1 << 14)
#define dsl (0x1 << 13)
#define newval (0x1 << 0)
#define spe_newpattern (0x1 << 0)
#define spe_nipd (0x1 << 0)
#define spe_rcmp (0x1 << 4)


extern unsigned int nr_of_calls;
unsigned int no_match = 1;
unsigned int floor_offset = 0;
signed int act_floor = 0;
int error3 = 0;

//------------------------------------------------------------------------------
// main thread:
int elevator_request(signed int new_floor ) {
  unsigned int value = 0;
  unsigned int i = 0;

  cout << "configure next elevator request to floor " << dec << new_floor << endl;
  if (new_floor > act_floor ) {
    TOM0_CH0_CTRL = (0x0 << 11);
    SPE0_REV_CMP  = new_floor * 4 + floor_offset;
    cout << "elevator up " << endl;
  } else {
    TOM0_CH1_CTRL = (0x0 << 11);
    SPE0_REV_CMP  = new_floor * 4  + floor_offset;
    cout << "elevator down " << endl;
  }
  
  value = SPE0_IRQ_EN;
  SPE0_IRQ_EN = value | 0x10;
  no_match = 1;
  while (no_match ) { 
   // dummy read to consume time
    value = SPE0_CTRL_STAT;
  }
  TOM0_CH0_CTRL = (0x1 << 11);
  TOM0_CH1_CTRL = (0x1 << 11);
  cout << " Stopping elevator"  << endl;
  act_floor = new_floor;
  // wait some time
  for ( i=0; i<= 0x50; i++) {
     // dummy read to consume time
     value = SPE0_CTRL_STAT;
  }
  return 0;
}

int encoder1() {

  // required declaration for HAL
  gtm_ptr p;
  unsigned int ipattern = 0;
  unsigned int status = 0;

  cout << "configure TIM0_ch0-1" << endl;
  cout << "========================================================" << endl;
  // configure tim ch0-1 to input event mode and enable
  TIM0_CH0_CTRL = mode_tiem | 0x1 | isl;
  TIM0_CH1_CTRL = mode_tiem | 0x1 | isl;
  
  cout << "configure TIM0_ch2" << endl;
  cout << "========================================================" << endl;
  // configure tim ch3 to input event mode sensitive on rising edge and enable
  // enable Newval IRQ
  TIM0_CH2_CTRL = mode_tiem | 0x1 | dsl;
  TIM0_CH2_IRQ_EN = newval;  

  cout << "configure TOM0_ch0-1" << endl;
  cout << "========================================================" << endl;  
  TOM0_CH0_CTRL = (0x1 << 11);
  TOM0_CH1_CTRL = (0x1 << 11);


  cout << "configure SPE0" << endl;
  cout << "========================================================" << endl;
  // define each pattern of encoder
  ipattern = ((0x0 << 1) | 0x1) |                     
             (((0x2 << 1) | 0x1) << 4) |
             (((0x3 << 1) | 0x1) << 8) |
             (((0x1 << 1) | 0x1) << 12) 
	     ; 
  SPE0_PAT = ipattern;

  // enable all SPE IRQ
  
  SPE0_IRQ_EN = 0x1F;
  
  // enable SPE
  SPE0_CTRL_STAT = 0x7;
  
  elevator_request(2);
  elevator_request(4);
// elevator_request(8);
// elevator_request(5);
  elevator_request(-1);

  return error3;

}

//------------------------------------------------------------------------------
// ISR:

int encoder1_isr(int number) {

  unsigned int status;
  signed short pos_cnt_org;
  signed short pos_cnt;
  signed short stop_pos;
  unsigned int spe_ctrl_stat;
  unsigned int dir;
  unsigned int value;

  if (number == 6) {

    //nr_of_calls++;
    //cout << "ISR call number " << dec << nr_of_calls << endl; 

    status = SPE0_IRQ_NOTIFY;
    cout << "ISR: SPE0_IRQ_NOTIFY = 0x" << hex << status << endl;
    SPE0_IRQ_NOTIFY  =  0x00000001F;
    if ( status & spe_nipd) {
       pos_cnt_org = SPE0_REV_CNT;
       spe_ctrl_stat = SPE0_CTRL_STAT;
       dir = (spe_ctrl_stat & 0x8000) >> 15;
       pos_cnt = (pos_cnt_org - floor_offset) >> 2;

       cout << "ISR: Elevator Floor: " << dec << pos_cnt << endl;
       stop_pos = SPE0_REV_CMP;
       cout << "ISR:position =" << dec << pos_cnt_org << " rev_cmp =" << dec << stop_pos << endl;
       if (pos_cnt_org == stop_pos && (status & spe_rcmp) == 0 ) {
          cout << "ISR:ERROR position compare is not working pos_cnt =" << dec << pos_cnt_org << " rev_cmp =" << dec << stop_pos << endl;
          TOM0_CH0_CTRL = (0x1 << 11);
          TOM0_CH1_CTRL = (0x1 << 11);
	  error3++;
       }
       //cout << "ISR: SPE0 Dir = " << dec << dir << endl;
       //cout << "ISR: SPE0 Stat = 0x" << hex << spe_ctrl_stat << endl;
    }
    if ( status & spe_rcmp) {
       value = SPE0_IRQ_EN;
       SPE0_IRQ_EN = ( value & (~ 0x10));
       no_match = 0;
       cout << "ISR: Count  matches reference"  << endl;
    }
    return 0;
  } else if  (number == 202){
    status = TIM0_CH2_IRQ_NOTIFY;
    cout << "ISR: TIM0_CH2_IRQ_NOTIFY = 0x" << hex << status << endl;
    TIM0_CH2_IRQ_NOTIFY  =  0x000000001;

    SPE0_REV_CNT = floor_offset;
    // reference correction only done once
    TIM0_CH2_IRQ_EN = 0;  
 
    cout << "ISR: reference position detected SPE0 Count = " << dec << floor_offset << endl;
    return 0;
  } else {
    cout << "no ISR for interrupt " << dec << number << endl;
    return 1;
  }
}
