//head:-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// $Id: sw_encoder2.cpp,v 1.4 2012/04/26 12:34:41 twagner Exp $
//------------------------------------------------------------------------------
// NO WARRANTIES: TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER THE
// INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND CONTRIBUTORS, NOR ANY
// PERSON, EITHER EXPRESSLY OR IMPLICITLY, WARRANTS ANY ASPECT OF THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// INCLUDING ANY OUTPUT OR RESULTS OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO UNLESS AGREED TO IN WRITING.
// THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED
// THERETO IS BEING PROVIDED "AS IS", WITHOUT ANY WARRANTY OF ANY TYPE OR
// NATURE, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY
// WARRANTY THAT THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO IS FREE FROM DEFECTS.
//
// ASSUMPTION OF RISK: THE RISK OF ANY AND ALL LOSS, DAMAGE, OR UNSATISFACTORY
// PERFORMANCE OF THIS SPECIFICATION (RESPECTIVELY THE PRODUCTS MAKING USE OF
// IT IN PART OR AS A WHOLE), SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM
// RELATED THERETO RESTS WITH YOU AS THE USER. TO THE MAXIMUM EXTENT PERMITTED
// BY LAW, NEITHER THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND
// CONTRIBUTORS, NOR ANY PERSON EITHER EXPRESSLY OR IMPLICITLY, MAKES ANY
// REPRESENTATION OR WARRANTY REGARDING THE APPROPRIOATENESS OF THE USE, OUTPUT,
// OR RESULTS OF THE USE OF THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE
// AND/OR PROGRAM RELATED THERETO IN TERMS OF ITS CORRECTNESS, ACCURACY,
// RELIABILITY, BEING CURRENT OR OTHERWISE. NOR DO THEY HAVE ANY OBLIGATION TO
// CORRECT ERRORS, MAKE CHANGES, SUPPORT THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, DISTRIBUTE UPDATES, OR PROVIDE
// NOTIFICATION OF ANY ERROR OR DEFECT, KNOWN OR UNKNOWN. IF YOU RELY UPON THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// YOU DO SO AT YOUR OWN RISK, AND YOU ASSUME THE RESPONSIBILITY FOR THE
// RESULTS. SHOULD THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL LOSSES,
// INCLUDING, BUT NOT LIMITED TO, ANY NECESSARY SERVICING, REPAIR OR CORRECTION
// OF ANY PROPERTY INVOLVED TO THE MAXIMUM EXTEND PERMITTED BY LAW.
//
// DISCLAIMER: IN NO EVENT, UNLESS REQUIRED BY LAW OR AGREED TO IN WRITING,
// SHALL THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS OR ANY PERSON BE
// LIABLE FOR ANY LOSS, EXPENSE OR DAMAGE, OF ANY TYPE OR NATURE ARISING OUT OF
// THE USE OF, OR INABILITY TO USE THIS SPECIFICATION, SOFTWARE RELATED THERETO,
// CODE AND/OR PROGRAM RELATED THERETO, INCLUDING, BUT NOT LIMITED TO, CLAIMS,
// SUITS OR CAUSES OF ACTION INVOLVING ALLEGED INFRINGEMENT OF COPYRIGHTS,
// PATENTS, TRADEMARKS, TRADE SECRETS, OR UNFAIR COMPETITION.
//
// INDEMNIFICATION: TO THE MAXIMUM EXTEND PERMITTED BY LAW YOU AGREE TO
// INDEMNIFY AND HOLD HARMLESS THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT
// HOLDERS AND CONTRIBUTORS, AND EMPLOYEES, AND ANY PERSON FROM AND AGAINST ALL
// CLAIMS, LIABILITIES, LOSSES, CAUSES OF ACTION, DAMAGES, JUDGMENTS, AND
// EXPENSES, INCLUDING THE REASONABLE COST OF ATTORNEYS' FEES AND COURT COSTS,
// FOR INJURIES OR DAMAGES TO THE PERSON OR PROPERTY OF THIRD PARTIES,
// INCLUDING, WITHOUT LIMITATIONS, CONSEQUENTIAL, DIRECT AND INDIRECT DAMAGES
// AND ANY ECONOMIC LOSSES, THAT ARISE OUT OF OR IN CONNECTION WITH YOUR USE,
// MODIFICATION, OR DISTRIBUTION OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, ITS OUTPUT, OR ANY ACCOMPANYING
// DOCUMENTATION.
//
// GOVERNING LAW: THE RELATIONSHIP BETWEEN YOU AND ROBERT BOSCH GMBH SHALL BE
// GOVERNED SOLELY BY THE LAWS OF THE FEDERAL REPUBLIC OF GERMANY. THE
// STIPULATIONS OF INTERNATIONAL CONVENTIONS REGARDING THE INTERNATIONAL SALE OF
// GOODS SHALL NOT BE APPLICABLE. THE EXCLUSIVE LEGAL VENUE SHALL BE
// DUESSELDORF, GERMANY.
//
// MANDATORY LAW SHALL BE UNAFFECTED BY THE FOREGOING PARAGRAPHS.
//
// INTELLECTUAL PROPERTY OWNERS/COPYRIGHT OWNERS/CONTRIBUTORS: ROBERT BOSCH
// GMBH, ROBERT BOSCH PLATZ 1, 70839 GERLINGEN, GERMANY AND ITS LICENSORS.
//
// ALL RIGHTS RESERVED.
//------------------------------------------------------------------------------
// Project Name : GTM - Generic Timer Module
//------------------------------------------------------------------------------
// Copyright   : Robert Bosch GmbH, Gerlingen, Germany
// Department  : AE/EIY
// Created     : 25.01.2011
//------------------------------------------------------------------------------
//:head-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// Description     : 
//============================================================================ 
// Important Notes : 
//============================================================================ 

#include <iostream>
#include "gtm.h"
#include <math.h>
#include "gtm_device_cfg.h"

using namespace std;



#define mode_tiem (0x2 << 1)
#define mode_tbcm (0x4 << 1)
#define isl (0x1 << 14)
#define dsl (0x1 << 13)
#define newval (0x1 << 0)


extern unsigned int nr_of_calls;
unsigned int no_match2 = 1;
unsigned int floor_offset2 = 4 * 4;
signed int act_floor2 = 0;
signed int position = 0;
signed int cmp_position = 0;
unsigned int dir = 0;
unsigned int encoder_segment = 0;
const int encoder[4] =
{
	0x0 ,     
	0x2 ,     
	0x3 ,     
	0x1      
};
//------------------------------------------------------------------------------
// main thread:
int elevator_request2(signed int new_floor ) {
  unsigned int value = 0;
  unsigned int i = 0;

  cout << "configure next elevator request to floor " << dec << new_floor << endl;
  if (new_floor > act_floor2 ) {
    TOM0_CH0_CTRL = (0x0 << 11);
    cmp_position  = new_floor * 4 + floor_offset2;
    cout << "elevator up " << endl;
  } else {
    TOM0_CH1_CTRL = (0x0 << 11);
    cmp_position  = new_floor * 4  + floor_offset2;
    cout << "elevator down " << endl;
  }
  no_match2 = 1;  
  while (no_match2 ) { 
   // dummy read to consume time
    value = SPE0_CTRL_STAT;
  }
  TOM0_CH0_CTRL = (0x1 << 11);
  TOM0_CH1_CTRL = (0x1 << 11);
  cout << " Stopping elevator"  << endl;
  act_floor2 = new_floor;
  // wait some time
  for ( i=0; i<= 0x50; i++) {
     // dummy read to consume time
     value = SPE0_CTRL_STAT;
  }
  return 0;
}

int encoder2() {

  // required declaration for HAL
  gtm_ptr p;
  int error = 0;
  unsigned int ipattern = 0;
  unsigned int status = 0;

  cout << "configure TIM0_ch0-1" << endl;
  cout << "========================================================" << endl;
  // configure tim ch0-1 to input event mode and enable
  TIM0_CH0_CTRL = mode_tbcm | 0x1 ;
  TIM0_CH0_CNTS = 0x303;
  TIM0_CH0_IRQ_EN = newval;  
  
  cout << "configure TIM0_ch3" << endl;
  cout << "========================================================" << endl;
  // configure tim ch3 to input event mode sensitive on rising edge and enable
  // enable Newval IRQ
  TIM0_CH3_CTRL = mode_tiem | 0x1 | dsl;
  TIM0_CH3_IRQ_EN = newval;  

  cout << "configure TOM0_ch0-1" << endl;
  cout << "========================================================" << endl;  
  TOM0_CH0_CTRL = (0x1 << 11);
  TOM0_CH1_CTRL = (0x1 << 11);


 	     ; 
  
  elevator_request2(2);
  elevator_request2(4);
// elevator_request2(8);
// elevator_request2(5);
  elevator_request2(2);
 
  return error;

}

//------------------------------------------------------------------------------
// ISR:

int encoder2_isr(int number) {

  unsigned int status;
  signed short pos_cnt ;
  unsigned int new_pattern;
  unsigned int next_segment;
  unsigned int prev_segment;

  if (number == 200) {

    //nr_of_calls++;
    //cout << "ISR call number " << dec << nr_of_calls << endl; 

    status = TIM0_CH0_IRQ_NOTIFY;
    cout << "ISR: TIM0_CH0_IRQ_NOTIFY = 0x" << hex << status << endl;
    TIM0_CH0_IRQ_NOTIFY  =  0x00000001;
    if ( status & newval) {
       new_pattern = TIM0_CH0_GPR1 & 0x3;
       next_segment = ((encoder_segment + 1) & 0x3);
       prev_segment = ((encoder_segment + 3) & 0x3);
       if ( dir == 0) { 
         if ( encoder[next_segment ] == new_pattern) {
           position = position + 1;
	   encoder_segment = next_segment;
	 } else if (encoder[prev_segment] == new_pattern) {
	   // direction change
           position = position - 1;
	   encoder_segment = prev_segment;
	   dir = 1;
	 } else {
           cout << "ISR: ERROR  Unexpected pattern detected" << endl;	   
	 }
       } else if (encoder[prev_segment ] == new_pattern) {
               position = position - 1;
	       encoder_segment = prev_segment;
       } else if (encoder[next_segment] == new_pattern) {
	      // direction change
              position = position + 1;
	      encoder_segment = next_segment;
	      dir = 0;
       } else {
               cout << "ISR: ERROR  Unexpected pattern detected" << endl;	   
       }
       pos_cnt = (position - floor_offset2) >> 2;
       cout << "ISR: Elevator Floor: " << dec << pos_cnt << endl;
       cout << "ISR: encoder Pattern = 0x" << hex << new_pattern << endl;
       cout << "ISR: encoder Direction = " << dec << dir << endl;
       //cout << "ISR: SPE0 Stat = 0x" << hex << spe_ctrl_stat << endl;
    }
    cout << "ISR: encoder Position = 0x" << hex << position << endl;
    cout << "ISR: encoder CMP Position = 0x" << hex << cmp_position << endl;
    if ( position == cmp_position) {
       no_match2 = 0;
       cout << "ISR: Count  matches reference"  << endl;
    }
    return 0;
  } else if  (number == 203){
    status = TIM0_CH3_IRQ_NOTIFY;
    cout << "ISR: TIM0_CH3_IRQ_NOTIFY = 0x" << hex << status << endl;
    TIM0_CH3_IRQ_NOTIFY  =  0x000000001;

    position = floor_offset2;
    // reference correction only done once
    TIM0_CH3_IRQ_EN = 0;  
 
    cout << "ISR: reference position detected Position Count = " << dec << floor_offset2 << endl;
    return 0;
  } else {
    cout << "no ISR for interrupt " << dec << number << endl;
    return 1;
  }
}
