//head:-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// $Id: sw_encoder3.cpp,v 1.6 2012/07/05 12:23:11 twagner Exp $
//------------------------------------------------------------------------------
// NO WARRANTIES: TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER THE
// INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND CONTRIBUTORS, NOR ANY
// PERSON, EITHER EXPRESSLY OR IMPLICITLY, WARRANTS ANY ASPECT OF THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// INCLUDING ANY OUTPUT OR RESULTS OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO UNLESS AGREED TO IN WRITING.
// THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED
// THERETO IS BEING PROVIDED "AS IS", WITHOUT ANY WARRANTY OF ANY TYPE OR
// NATURE, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY
// WARRANTY THAT THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO IS FREE FROM DEFECTS.
//
// ASSUMPTION OF RISK: THE RISK OF ANY AND ALL LOSS, DAMAGE, OR UNSATISFACTORY
// PERFORMANCE OF THIS SPECIFICATION (RESPECTIVELY THE PRODUCTS MAKING USE OF
// IT IN PART OR AS A WHOLE), SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM
// RELATED THERETO RESTS WITH YOU AS THE USER. TO THE MAXIMUM EXTENT PERMITTED
// BY LAW, NEITHER THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND
// CONTRIBUTORS, NOR ANY PERSON EITHER EXPRESSLY OR IMPLICITLY, MAKES ANY
// REPRESENTATION OR WARRANTY REGARDING THE APPROPRIOATENESS OF THE USE, OUTPUT,
// OR RESULTS OF THE USE OF THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE
// AND/OR PROGRAM RELATED THERETO IN TERMS OF ITS CORRECTNESS, ACCURACY,
// RELIABILITY, BEING CURRENT OR OTHERWISE. NOR DO THEY HAVE ANY OBLIGATION TO
// CORRECT ERRORS, MAKE CHANGES, SUPPORT THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, DISTRIBUTE UPDATES, OR PROVIDE
// NOTIFICATION OF ANY ERROR OR DEFECT, KNOWN OR UNKNOWN. IF YOU RELY UPON THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// YOU DO SO AT YOUR OWN RISK, AND YOU ASSUME THE RESPONSIBILITY FOR THE
// RESULTS. SHOULD THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL LOSSES,
// INCLUDING, BUT NOT LIMITED TO, ANY NECESSARY SERVICING, REPAIR OR CORRECTION
// OF ANY PROPERTY INVOLVED TO THE MAXIMUM EXTEND PERMITTED BY LAW.
//
// DISCLAIMER: IN NO EVENT, UNLESS REQUIRED BY LAW OR AGREED TO IN WRITING,
// SHALL THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS OR ANY PERSON BE
// LIABLE FOR ANY LOSS, EXPENSE OR DAMAGE, OF ANY TYPE OR NATURE ARISING OUT OF
// THE USE OF, OR INABILITY TO USE THIS SPECIFICATION, SOFTWARE RELATED THERETO,
// CODE AND/OR PROGRAM RELATED THERETO, INCLUDING, BUT NOT LIMITED TO, CLAIMS,
// SUITS OR CAUSES OF ACTION INVOLVING ALLEGED INFRINGEMENT OF COPYRIGHTS,
// PATENTS, TRADEMARKS, TRADE SECRETS, OR UNFAIR COMPETITION.
//
// INDEMNIFICATION: TO THE MAXIMUM EXTEND PERMITTED BY LAW YOU AGREE TO
// INDEMNIFY AND HOLD HARMLESS THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT
// HOLDERS AND CONTRIBUTORS, AND EMPLOYEES, AND ANY PERSON FROM AND AGAINST ALL
// CLAIMS, LIABILITIES, LOSSES, CAUSES OF ACTION, DAMAGES, JUDGMENTS, AND
// EXPENSES, INCLUDING THE REASONABLE COST OF ATTORNEYS' FEES AND COURT COSTS,
// FOR INJURIES OR DAMAGES TO THE PERSON OR PROPERTY OF THIRD PARTIES,
// INCLUDING, WITHOUT LIMITATIONS, CONSEQUENTIAL, DIRECT AND INDIRECT DAMAGES
// AND ANY ECONOMIC LOSSES, THAT ARISE OUT OF OR IN CONNECTION WITH YOUR USE,
// MODIFICATION, OR DISTRIBUTION OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, ITS OUTPUT, OR ANY ACCOMPANYING
// DOCUMENTATION.
//
// GOVERNING LAW: THE RELATIONSHIP BETWEEN YOU AND ROBERT BOSCH GMBH SHALL BE
// GOVERNED SOLELY BY THE LAWS OF THE FEDERAL REPUBLIC OF GERMANY. THE
// STIPULATIONS OF INTERNATIONAL CONVENTIONS REGARDING THE INTERNATIONAL SALE OF
// GOODS SHALL NOT BE APPLICABLE. THE EXCLUSIVE LEGAL VENUE SHALL BE
// DUESSELDORF, GERMANY.
//
// MANDATORY LAW SHALL BE UNAFFECTED BY THE FOREGOING PARAGRAPHS.
//
// INTELLECTUAL PROPERTY OWNERS/COPYRIGHT OWNERS/CONTRIBUTORS: ROBERT BOSCH
// GMBH, ROBERT BOSCH PLATZ 1, 70839 GERLINGEN, GERMANY AND ITS LICENSORS.
//
// ALL RIGHTS RESERVED.
//------------------------------------------------------------------------------
// Project Name : GTM - Generic Timer Module
//------------------------------------------------------------------------------
// Copyright   : Robert Bosch GmbH, Gerlingen, Germany
// Department  : AE/EIY
// Created     : 25.01.2011
//------------------------------------------------------------------------------
//:head-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// Description     : 
//============================================================================ 
// Important Notes : 
//============================================================================ 

#include <iostream>
#include "gtm.h"
#include <math.h>
#include "gtm_device_cfg.h"
#include "gtm_defs.h"

#ifndef MCS_ARCH 
#   error "require preprocessor variable MCS_ARCH"
#elif MCS_ARCH > 2
#   error "bad value for MCS_ARCH"
#endif

using namespace std;

// TIM_CH_CTRL register definitions:
#define mode_tiem (0x2 << 1)
#define mode_tbcm (0x4 << 1)
#define isl (0x1 << 14)
#define dsl (0x1 << 13)
#define newval (0x1 << 0)

// ATOM_CH_CTRL register definitions:
#define mode_somi    (0<<0)
#define mode_somc    (1<<0)
#define mode_somp    (2<<0)
#define mode_soms    (3<<0)

#define aru_off    (0<<3)
#define aru_on     (1<<3)

#define sl_lo    (0<<11)
#define sl_hi    (1<<11)

#define osm_cont    (0<<26)
#define osm_one     (1<<26)


#define trig_chx     (0<<24)
#define trig_ccu0    (1<<24)

#define rst_on_cm0    (0<<20)
#define rst_on_trig   (1<<20)

// CMU register definitions:
#define cmu_clk0    (0<<12)
#define cmu_clk1    (1<<12)
#define cmu_clk2    (2<<12)
#define cmu_clk3    (3<<12)
#define cmu_clk4    (4<<12)
#define cmu_clk5    (5<<12)
#define cmu_clk6    (6<<12)
#define cmu_clk7    (7<<12)

// test case specific definitions
#define T0                 4         // period on channel 0: 4*50ns = 200ns
#define atom_sl1           4         // duty on channel 0: 100%
#define atom_sl0           0         // duty on channel 0: 0%

extern unsigned int nr_of_calls;
unsigned int no_match3 = 1;
unsigned int floor_offset3 = 4 * 4;
signed int act_floor3 = 0;
signed int position3 = 0;
signed int cmp_position3 = 0;
unsigned int dir3 = 0;
unsigned int encoder_segment3 = 0;
const int encoder_pattern[4] =
{
	0x0 ,     
	0x2 ,     
	0x3 ,     
	0x1      
};
//------------------------------------------------------------------------------
// main thread:
int elevator_request3(signed int new_floor ) {
  unsigned int value = 0;
  unsigned int i = 0;

  cout << "configure next elevator request to floor " << dec << new_floor << endl;
  if (new_floor > act_floor3 ) {
    ATOM0_CH0_SR1      = atom_sl1;
    cmp_position3  = new_floor * 4 + floor_offset3;
    cout << "elevator up " << endl;
  } else {
    ATOM0_CH1_SR1      = atom_sl1;
    cmp_position3  = new_floor * 4  + floor_offset3;
    cout << "elevator down " << endl;
  }
  no_match3 = 1;  
  while (no_match3 ) { 
   // dummy read to consume time
    value = SPE0_CTRL_STAT;
  }
  ATOM0_CH0_SR1      = atom_sl0;
  ATOM0_CH1_SR1      = atom_sl0;
  cout << " Stopping elevator"  << endl;
  act_floor3 = new_floor;
  // wait some time
  for ( i=0; i<= 0x50; i++) {
     // dummy read to consume time
     value = SPE0_CTRL_STAT;
  }
  return 0;
}

int encoder3() {

  // required declaration for HAL
  gtm_ptr p;
  int error = 0;
  unsigned int ipattern = 0;
  unsigned int status = 0;
  unsigned int i;

  cout << "configure TIM0_ch0-1" << endl;
  cout << "========================================================" << endl;
  // configure tim ch0-1 to input event mode and enable
  TIM0_CH0_CTRL = mode_tbcm | 0x1 ;
  TIM0_CH0_CNTS = 0x303;
  TIM0_CH0_IRQ_EN = newval;  
  //TIM0_CH1_CTRL = mode_tiem | 0x1 | isl;
  
  cout << "configure TIM0_ch3" << endl;
  cout << "========================================================" << endl;
  // configure tim ch3 to input event mode sensitive on rising edge and enable
  // enable Newval IRQ
  TIM0_CH3_CTRL = mode_tiem | 0x1 | dsl;
  TIM0_CH3_IRQ_EN = newval;  

cout << "configure ATOM0_ch0-1" << endl;
  cout << "========================================================" << endl;  
  ATOM0_CH0_CTRL = (0x1 << 11);
  ATOM0_CH1_CTRL = (0x1 << 11);

  cout << "configure CMU" << endl;
  cout << "========================================================" << endl;
  CMU_GCLK_NUM   = 0x0000FFFF;
  CMU_GCLK_DEN   = 0x0000FFFF;

  CMU_CLK_0_CTRL  = 0x00000001; // sys_clk_perios *2 = 20ns
  CMU_CLK_1_CTRL  = 0x00000002; // sys_clk_perios *3 = 30ns
  CMU_CLK_2_CTRL  = 0x00000003; // sys_clk_perios *4 = 40ns
  CMU_CLK_3_CTRL  = 0x00000004; // sys_clk_perios *5 = 50ns

  CMU_CLK_EN     = 0x00000080; // enable CMU clock 3
  status = CMU_CLK_EN;
  if (status != 0x000000C0) {
    cout << "ERROR: read value 0x" << hex << status 
	 << " not equat to expected value 0x000000C0" << endl;
  }
  
  cout << "configure MCS" << endl;
  cout << "========================================================" << endl;

#include "sw_mcs_encoder3_label.h"
// definition of MCS0_RAM_E3
#include "sw_mcs_encoder3_MCS0_RAM_E3.h"


#if MCS_ARCH == 1 
      status = MCS0_CTRL;
#elif MCS_ARCH == 2
      status = MCS0_CTRL_STAT;
#endif
  if ((status & 0x00010000) > 0) {
    cout << "MCS RAM initialization running ";
    // wait until MCS RAM intitialisation finished
    do { 
#if MCS_ARCH == 1 
      status = MCS0_CTRL;
#elif MCS_ARCH == 2
      status = MCS0_CTRL_STAT;
#endif
      cout << ".";
    } while ((status & 0x00010000) > 0);
    cout << endl;  
  }

 
  // copy MCS program code to RAM
  cout << "write program code to MCS0 RAM" << endl;
  p = &MCS0_MEM;               // pointer to first entry of MCS0 RAM

  for (i=0; i<(SIZE_MCS0_RAM_E3/4); i++) {
    p[i] = MCS0_RAM_E3[i];        // store value to MCS RAM
  }

  p = &MCS0_MEM;               // pointer to first entry of MCS0 RAM
  cout << "MCS0_MEM   = 0x" << hex << p[0] << endl;

  cout << "enable MCS0 channel 0" << endl;
  MCS0_CH0_CTRL = 0x00000001;  // enable channel 0


  cout << "configure ATOM channel 0 to 1" << endl;
  cout << "=======================================================" << endl;

  ATOM0_CH0_RDADDR   = (MCS0_WRADDR0<<16)+(MCS0_WRADDR0); // read from MCS WR_ADDR0
  ATOM0_CH1_RDADDR   = (MCS0_WRADDR1<<16)+(MCS0_WRADDR1);
 
  // channel 0 is master channel that defines period of PWM
  ATOM0_CH0_CTRL     = (mode_somp)+(aru_on)+(sl_hi)+(trig_ccu0)+(cmu_clk3);
  ATOM0_CH1_CTRL     = (mode_somp)+(aru_on)+(sl_hi)+(trig_ccu0)+(cmu_clk3);


  // initial values for ATOM channel 0/1:
  ATOM0_CH0_CM0      = T0;          // period = 1000*50ns = 20kHz
  ATOM0_CH0_CM1      = atom_sl0;    // duty cycle = 0%
  ATOM0_CH0_CN0      = 0x00000000;  // initial delay = 0
  ATOM0_CH0_SR0      = T0;
  ATOM0_CH0_SR1      = atom_sl0;
  ATOM0_CH1_CM0      = T0;          // period = 1000*50ns = 20kHz
  ATOM0_CH1_CM1      = atom_sl0;    // duty cycle = 0%
  ATOM0_CH1_CN0      = 0x00000000;  // initial delay = 0
  ATOM0_CH1_SR0      = T0;
  ATOM0_CH1_SR1      = atom_sl0;

   elevator_request3(2);
  elevator_request3(4);
// elevator_request3(8);
// elevator_request3(5);
  elevator_request3(2);
 
  return error;

}

//------------------------------------------------------------------------------
// ISR:

int encoder3_isr(int number) {

  unsigned int status;
  signed short pos_cnt ;
  unsigned int new_pattern;
  unsigned int next_segment;
  unsigned int prev_segment;

  if (number == 200) {

    //nr_of_calls++;
    //cout << "ISR call number " << dec << nr_of_calls << endl; 

    status = TIM0_CH0_IRQ_NOTIFY;
    cout << "ISR: TIM0_CH0_IRQ_NOTIFY = 0x" << hex << status << endl;
    TIM0_CH0_IRQ_NOTIFY  =  0x00000001;
    if ( status & newval) {
       new_pattern = TIM0_CH0_GPR1 & 0x3;
       next_segment = ((encoder_segment3 + 1) & 0x3);
       prev_segment = ((encoder_segment3 + 3) & 0x3);
       if ( dir3 == 0) { 
         if ( encoder_pattern[next_segment ] == new_pattern) {
           position3 = position3 + 1;
	   encoder_segment3 = next_segment;
	 } else if (encoder_pattern[prev_segment] == new_pattern) {
	   // direction change
           position3 = position3 - 1;
	   encoder_segment3 = prev_segment;
	   dir3 = 1;
	 } else {
           cout << "ISR: ERROR  Unexpected pattern detected" << endl;	   
	 }
       } else if (encoder_pattern[prev_segment ] == new_pattern) {
               position3 = position3 - 1;
	       encoder_segment3 = prev_segment;
       } else if (encoder_pattern[next_segment] == new_pattern) {
	      // direction change
              position3 = position3 + 1;
	      encoder_segment3 = next_segment;
	      dir3 = 0;
       } else {
               cout << "ISR: ERROR  Unexpected pattern detected" << endl;	   
       }
       pos_cnt = (position3 - floor_offset3) >> 2;
       cout << "ISR: Elevator Floor: " << dec << pos_cnt << endl;
       cout << "ISR: encoder Pattern = 0x" << hex << new_pattern << endl;
       cout << "ISR: encoder Direction = " << dec << dir3 << endl;
       //cout << "ISR: SPE0 Stat = 0x" << hex << spe_ctrl_stat << endl;
    }
    cout << "ISR: encoder position = 0x" << hex << position3 << endl;
    cout << "ISR: encoder CMP position = 0x" << hex << cmp_position3 << endl;
    if ( position3 == cmp_position3) {
       no_match3 = 0;
       cout << "ISR: Count  matches reference"  << endl;
    }
    return 0;
  } else if  (number == 203){
    status = TIM0_CH3_IRQ_NOTIFY;
    cout << "ISR: TIM0_CH3_IRQ_NOTIFY = 0x" << hex << status << endl;
    TIM0_CH3_IRQ_NOTIFY  =  0x000000001;

    position3 = floor_offset3;
    // reference correction only done once
    TIM0_CH3_IRQ_EN = 0;  
 
    cout << "ISR: reference position3 detected position3 Count = " << dec << floor_offset3 << endl;
    return 0;
  } else {
    cout << "no ISR for interrupt " << dec << number << endl;
    return 1;
  }
}
