//head:-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// $Id: sw_mcs_atom_pmsm.cpp,v 1.12 2013/05/14 14:49:01 fisadmin Exp $
//------------------------------------------------------------------------------
// NO WARRANTIES: TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER THE
// INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND CONTRIBUTORS, NOR ANY
// PERSON, EITHER EXPRESSLY OR IMPLICITLY, WARRANTS ANY ASPECT OF THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// INCLUDING ANY OUTPUT OR RESULTS OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO UNLESS AGREED TO IN WRITING.
// THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED
// THERETO IS BEING PROVIDED "AS IS", WITHOUT ANY WARRANTY OF ANY TYPE OR
// NATURE, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY
// WARRANTY THAT THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO IS FREE FROM DEFECTS.
//
// ASSUMPTION OF RISK: THE RISK OF ANY AND ALL LOSS, DAMAGE, OR UNSATISFACTORY
// PERFORMANCE OF THIS SPECIFICATION (RESPECTIVELY THE PRODUCTS MAKING USE OF
// IT IN PART OR AS A WHOLE), SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM
// RELATED THERETO RESTS WITH YOU AS THE USER. TO THE MAXIMUM EXTENT PERMITTED
// BY LAW, NEITHER THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND
// CONTRIBUTORS, NOR ANY PERSON EITHER EXPRESSLY OR IMPLICITLY, MAKES ANY
// REPRESENTATION OR WARRANTY REGARDING THE APPROPRIOATENESS OF THE USE, OUTPUT,
// OR RESULTS OF THE USE OF THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE
// AND/OR PROGRAM RELATED THERETO IN TERMS OF ITS CORRECTNESS, ACCURACY,
// RELIABILITY, BEING CURRENT OR OTHERWISE. NOR DO THEY HAVE ANY OBLIGATION TO
// CORRECT ERRORS, MAKE CHANGES, SUPPORT THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, DISTRIBUTE UPDATES, OR PROVIDE
// NOTIFICATION OF ANY ERROR OR DEFECT, KNOWN OR UNKNOWN. IF YOU RELY UPON THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// YOU DO SO AT YOUR OWN RISK, AND YOU ASSUME THE RESPONSIBILITY FOR THE
// RESULTS. SHOULD THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL LOSSES,
// INCLUDING, BUT NOT LIMITED TO, ANY NECESSARY SERVICING, REPAIR OR CORRECTION
// OF ANY PROPERTY INVOLVED TO THE MAXIMUM EXTEND PERMITTED BY LAW.
//
// DISCLAIMER: IN NO EVENT, UNLESS REQUIRED BY LAW OR AGREED TO IN WRITING,
// SHALL THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS OR ANY PERSON BE
// LIABLE FOR ANY LOSS, EXPENSE OR DAMAGE, OF ANY TYPE OR NATURE ARISING OUT OF
// THE USE OF, OR INABILITY TO USE THIS SPECIFICATION, SOFTWARE RELATED THERETO,
// CODE AND/OR PROGRAM RELATED THERETO, INCLUDING, BUT NOT LIMITED TO, CLAIMS,
// SUITS OR CAUSES OF ACTION INVOLVING ALLEGED INFRINGEMENT OF COPYRIGHTS,
// PATENTS, TRADEMARKS, TRADE SECRETS, OR UNFAIR COMPETITION.
//
// INDEMNIFICATION: TO THE MAXIMUM EXTEND PERMITTED BY LAW YOU AGREE TO
// INDEMNIFY AND HOLD HARMLESS THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT
// HOLDERS AND CONTRIBUTORS, AND EMPLOYEES, AND ANY PERSON FROM AND AGAINST ALL
// CLAIMS, LIABILITIES, LOSSES, CAUSES OF ACTION, DAMAGES, JUDGMENTS, AND
// EXPENSES, INCLUDING THE REASONABLE COST OF ATTORNEYS' FEES AND COURT COSTS,
// FOR INJURIES OR DAMAGES TO THE PERSON OR PROPERTY OF THIRD PARTIES,
// INCLUDING, WITHOUT LIMITATIONS, CONSEQUENTIAL, DIRECT AND INDIRECT DAMAGES
// AND ANY ECONOMIC LOSSES, THAT ARISE OUT OF OR IN CONNECTION WITH YOUR USE,
// MODIFICATION, OR DISTRIBUTION OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, ITS OUTPUT, OR ANY ACCOMPANYING
// DOCUMENTATION.
//
// GOVERNING LAW: THE RELATIONSHIP BETWEEN YOU AND ROBERT BOSCH GMBH SHALL BE
// GOVERNED SOLELY BY THE LAWS OF THE FEDERAL REPUBLIC OF GERMANY. THE
// STIPULATIONS OF INTERNATIONAL CONVENTIONS REGARDING THE INTERNATIONAL SALE OF
// GOODS SHALL NOT BE APPLICABLE. THE EXCLUSIVE LEGAL VENUE SHALL BE
// DUESSELDORF, GERMANY.
//
// MANDATORY LAW SHALL BE UNAFFECTED BY THE FOREGOING PARAGRAPHS.
//
// INTELLECTUAL PROPERTY OWNERS/COPYRIGHT OWNERS/CONTRIBUTORS: ROBERT BOSCH
// GMBH, ROBERT BOSCH PLATZ 1, 70839 GERLINGEN, GERMANY AND ITS LICENSORS.
//
// ALL RIGHTS RESERVED.
//------------------------------------------------------------------------------
// Project Name : GTM - Generic Timer Module
//------------------------------------------------------------------------------
// Copyright   : Robert Bosch GmbH, Gerlingen, Germany
// Department  : AE/EIY
// Created     : 25.01.2012
//------------------------------------------------------------------------------
//:head-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// Description     : MCS-ATOM PMSM control apllication example
//============================================================================ 
// Important Notes : 
//============================================================================ 

#include <iostream>
#include "gtm.h"
#include <math.h>
#include "gtm_device_cfg.h"
#include "functions.h"
#include "gtm_defs.h"

#ifndef MCS_ARCH 
#   error "require preprocessor variable MCS_ARCH"
#elif MCS_ARCH > 2
#   error "bad value for MCS_ARCH"
#endif

using namespace std;

// ATOM_CH_CTRL register definitions:
#define mode_somi    (0<<0)
#define mode_somc    (1<<0)
#define mode_somp    (2<<0)
#define mode_soms    (3<<0)

#define aru_off    (0<<3)
#define aru_on     (1<<3)

#define sl_lo    (0<<11)
#define sl_hi    (1<<11)

#define osm_cont    (0<<26)
#define osm_one     (1<<26)

#define cmu_clk0    (0<<12)
#define cmu_clk1    (1<<12)
#define cmu_clk2    (2<<12)
#define cmu_clk3    (3<<12)
#define cmu_clk4    (4<<12)
#define cmu_clk5    (5<<12)
#define cmu_clk6    (6<<12)
#define cmu_clk7    (7<<12)

#define trig_chx    (0<<24)
#define trig_ccu0    (1<<24)

#define rst_on_cm0    (0<<20)
#define rst_on_trig    (1<<20)

// test case specific definitions
#define T0                 1000      // period on channel 0: 1000*50ns = 20kHz
#define CH7_Pulse_length   100       // high pulse length ch7: 100*50ns = 5000 ns
#define PI 3.14159265

#define ARU_ACB 0x0C000000          // ACB=C transfered via ARU

#define TIMEOUT 100000

extern unsigned int nr_of_calls;

//------------------------------------------------------------------------------
// main thread:

int mcs_atom_pmsm() {

  // required declaration for HAL
  gtm_ptr p;
  int error = 0;
  unsigned int i;
  unsigned int status = 0;

  cout << "=======================================================" << endl;
  cout << "configure CMU" << endl;
  CMU_GCLK_NUM   = 0x0000FFFF; // global divider = *1
  CMU_GCLK_DEN   = 0x0000FFFF;

  //  CMU_CLK_0_CTRL  = 0x00000001; // sys_clk_period *2 = 20ns
  //  CMU_CLK_1_CTRL  = 0x00000002; // sys_clk_period *3 = 30ns
  //  CMU_CLK_2_CTRL  = 0x00000003; // sys_clk_period *4 = 40ns
  CMU_CLK_3_CTRL  = 0x00000004; // sys_clk_period *5 = 50ns

  CMU_CLK_EN     = 0x00000080; // enable CMU clock 3
  status = CMU_CLK_EN;
  if (status != 0x000000C0) {
    cout << "ERROR: read value 0x" << hex << status 
	 << " not equat to expected value 0x000000C0" << endl;
  }
  cout << "=======================================================" << endl;
  cout << "configure MCS" << endl;

  #include "sw_mcs_atom_pmsm_label.h"
  // definition of MCS0_RAM
  #include "sw_mcs_atom_pmsm_MCS0_RAM.h"

  cout << "MCS_ARCH =" << MCS_ARCH << endl;

#if MCS_ARCH == 1 
  status = MCS0_CTRL;
#elif MCS_ARCH == 2
  status = MCS0_CTRL_STAT;
#endif
  cout << "MCS0_CTRL =" << status << endl;


  if ((status & 0x00010000) > 0) {
    cout << "MCS RAM initialization running ";
    // wait until MCS RAM intitialisation finished
    do { 
#if MCS_ARCH == 1 
      status = MCS0_CTRL;
#elif MCS_ARCH == 2
      status = MCS0_CTRL_STAT;
#endif
      cout << ".";
    } while ((status & 0x00010000) > 0);
    cout << endl;  
  }

  // check some MCS register
#if MCS_ARCH == 1 
  error += check(MCS0_CTRL ,0x00000000,"MCS0_CTRL");
#elif MCS_ARCH == 2
  error += check(MCS0_CTRL_STAT ,0x00000000,"MCS0_CTRL_STAT");
#endif
  error += check(MCS0_CH0_R0 ,0x00000000,"MCS0_CH0_R0");
  error += check(MCS0_CH0_R1 ,0x00000000,"MCS0_CH0_R1");
  error += check(MCS0_CH0_R2 ,0x00000000,"MCS0_CH0_R2");
  error += check(MCS0_CH0_CTRL ,0x00000000,"MCS0_CH0_CTRL");

  // copy MCS program code to RAM
  cout << "write program code to MCS0 RAM" << endl;
  p = &MCS0_MEM;               // pointer to first entry of MCS0 RAM

  for (i=0; i<(SIZE_MCS0_RAM/4); i++) {
    p[i] = MCS0_RAM[i];        // store value to MCS RAM
    cout << "write to MCS RAM 0x" << hex << MCS0_RAM[i] << endl;
  }

  p = &MCS0_MEM;               // pointer to first entry of MCS0 RAM
  cout << "MCS0_MEM   = 0x" << hex << p[0] << endl;

  // sinus factor
  double sin_fact1 = sin(((1*10)%360)*PI/180);
  double sin_fact2 = sin(((1*10+120)%360)*PI/180);
  double sin_fact3 = sin(((1*10+240)%360)*PI/180);

  // initial values
  p[LABEL_MCS0_RAM_ACH1_SR0] = (T0/2)-(T0/4+(int)(sin_fact1*((T0/4)-10)));
  p[LABEL_MCS0_RAM_ACH1_SR1] = (T0/2)+(T0/4+(int)(sin_fact1*((T0/4)-10)));
  p[LABEL_MCS0_RAM_ACH2_SR0] = (T0/2)-(T0/4+(int)(sin_fact1*((T0/4)-10)));
  p[LABEL_MCS0_RAM_ACH2_SR1] = (T0/2)+(T0/4+(int)(sin_fact1*((T0/4)-10))); 
  p[LABEL_MCS0_RAM_ACH3_SR0] = (T0/2)-(T0/4+(int)(sin_fact2*((T0/4)-10)));
  p[LABEL_MCS0_RAM_ACH3_SR1] = (T0/2)+(T0/4+(int)(sin_fact2*((T0/4)-10)));
  p[LABEL_MCS0_RAM_ACH4_SR0] = (T0/2)-(T0/4+(int)(sin_fact2*((T0/4)-10)));
  p[LABEL_MCS0_RAM_ACH4_SR1] = (T0/2)+(T0/4+(int)(sin_fact2*((T0/4)-10)));
  p[LABEL_MCS0_RAM_ACH5_SR0] = (T0/2)-(T0/4+(int)(sin_fact3*((T0/4)-10)));
  p[LABEL_MCS0_RAM_ACH5_SR1] = (T0/2)+(T0/4+(int)(sin_fact3*((T0/4)-10)));
  p[LABEL_MCS0_RAM_ACH6_SR0] = (T0/2)-(T0/4+(int)(sin_fact3*((T0/4)-10)));
  p[LABEL_MCS0_RAM_ACH6_SR1] = (T0/2)+(T0/4+(int)(sin_fact3*((T0/4)-10)));

  p[LABEL_MCS0_RAM_ACH7_SR0] = (2*T0);
  p[LABEL_MCS0_RAM_ACH7_SR1] = CH7_Pulse_length;

  cout << "enable MCS0 channel 0" << endl;
  MCS0_CH0_CTRL = 0x00000001;  // enable channel 0
  status = MCS0_CH0_CTRL;
  cout << "MCS0_CH0_CTRL = 0x" << hex << status << endl;;

  if (DTM_INSTANCES > 0) {
//    cout << "=======================================================" << endl;
//    cout << "configure DTM24" << endl;
//    
//    // DTM24_CTRL        
//    // DTM24_CH_CTRL1    
//    DTM24_CH_CTRL2    = 0x88888800; // enable dead time channel 1,2,3
//    // DTM24_CH_CTRL2_SR 
//    // DTM24_PS_CTRL     
//    // DTM24_CH0_DTV     
//    DTM24_CH1_DTV     = 0x000A000A; // RELRISE=10, RELFALL=10
//    DTM24_CH2_DTV     = 0x000A000A; // RELRISE=10, RELFALL=10
//    DTM24_CH3_DTV     = 0x000A000A; // RELRISE=10, RELFALL=10
//    // DTM24_CH_SR       
  }

  cout << "=======================================================" << endl;
  cout << "configure ATOM channel 0 to 7" << endl;

  ATOM0_CH1_RDADDR   = (MCS0_WRADDR0<<16)+(MCS0_WRADDR0); // read from MCS WR_ADDR0
  ATOM0_CH2_RDADDR   = (MCS0_WRADDR1<<16)+(MCS0_WRADDR1);
  ATOM0_CH3_RDADDR   = (MCS0_WRADDR2<<16)+(MCS0_WRADDR2);
  ATOM0_CH4_RDADDR   = (MCS0_WRADDR3<<16)+(MCS0_WRADDR3);
  ATOM0_CH5_RDADDR   = (MCS0_WRADDR4<<16)+(MCS0_WRADDR4);
  ATOM0_CH6_RDADDR   = (MCS0_WRADDR5<<16)+(MCS0_WRADDR5);
  ATOM0_CH7_RDADDR   = (MCS0_WRADDR6<<16)+(MCS0_WRADDR6); // read from MCS WR_ADDR6

  // channel 0 is master channel that defines period of PWM
  ATOM0_CH0_CTRL     = (mode_somp)+(sl_hi)+(trig_ccu0)+(cmu_clk3);

  // channel 1 to 6 are synchronized to channel 1 and middle symmetrical
  ATOM0_CH1_CTRL     = (mode_somp)+(aru_on)+(sl_hi)+(rst_on_trig)+(cmu_clk3);
  ATOM0_CH2_CTRL     = (mode_somp)+(aru_on)+(sl_lo)+(rst_on_trig)+(cmu_clk3);
  ATOM0_CH3_CTRL     = (mode_somp)+(aru_on)+(sl_hi)+(rst_on_trig)+(cmu_clk3);
  ATOM0_CH4_CTRL     = (mode_somp)+(aru_on)+(sl_lo)+(rst_on_trig)+(cmu_clk3);
  ATOM0_CH5_CTRL     = (mode_somp)+(aru_on)+(sl_hi)+(rst_on_trig)+(cmu_clk3);
  ATOM0_CH6_CTRL     = (mode_somp)+(aru_on)+(sl_lo)+(rst_on_trig)+(cmu_clk3);
  
  // channel 7 triggers reload of SRx register
  ATOM0_CH7_CTRL     = (mode_somp)+(aru_on)+(sl_hi)+(cmu_clk3)+(trig_ccu0);

  // initial values for ATOM channel 0:
  ATOM0_CH0_CM0      = T0;          // period = 1000*50ns = 20kHz
  ATOM0_CH0_CM1      = T0/2;        // duty cycle = 500*50ns
  ATOM0_CH0_CN0      = 0x00000000;  // initial delay = 0
  ATOM0_CH0_SR0      = T0;
  ATOM0_CH0_SR1      = T0/2;

  // initial value for channel 7:
  ATOM0_CH7_CM1      = CH7_Pulse_length;  // falling edge if ATOM0_CH0_CN0=CH7_Pulse_length
  ATOM0_CH7_CM0      = 2*T0;              // rising edge  if ATOM0_CH0_CN0=2*T0
  ATOM0_CH7_SR1      = CH7_Pulse_length;
  ATOM0_CH7_SR0      = 2*T0;

  ATOM0_CH7_IRQ_EN  = 0x00000001;   // enable interrupt CCU0 of ATOM0_CH7
  status = ATOM0_CH7_IRQ_EN;
  if (status != 0x00000001) {
    cout << "ERROR: read value 0x" << hex << status 
	 << " not equal to expected value 0x00000003" << endl;
  }

  cout << "configure ATOM global channel control unit" << endl;
  cout << "=======================================================" << endl;

  ATOM0_AGC_INT_TRIG = 0x00008000;      // int. trig channel 7

  ATOM0_AGC_GLB_CTRL = 0x00020000;	// update enable of ch 0
  // normally enable only output of channel 1 to 6
  // for demonstration, enable output of channel 0 to 7
  ATOM0_AGC_OUTEN_CTRL = 0x0000AAAA;  // enable output 0 to 7 (1 to 6)
  ATOM0_AGC_ENDIS_CTRL = 0x0000AAAA;  // anable all channel
  ATOM0_AGC_FUPD_CTRL  = 0xAAAAAAAA;  // force update on ch 1 to 7
  status = ATOM0_AGC_FUPD_CTRL;
  cout << "ATOM0_AGC_FUPD_CTRL = 0x" << hex << status<< endl;

  cout << "== start ATOM with host trigger" << endl;
  ATOM0_AGC_GLB_CTRL   = 0x00000001;      // host trigger for start of ATOM0

  status = ATOM0_AGC_ENDIS_STAT;
  cout << "ATOM0_AGC_ENDIS_STAT = 0x" << hex << status<< endl;

  // after enable by host trigger set force update flags for next internal trigger
  ATOM0_AGC_FUPD_CTRL  = 0xAAA9AAA9;      // force update on ch 1 to 7
  status = ATOM0_AGC_FUPD_CTRL;
  cout << "ATOM0_AGC_FUPD_CTRL = 0x" << hex << status<< endl;


  cout << "PWM signal generation started" << endl;
  cout << "=======================================================" << endl;

  int timeout_cnt = 0;
  do {
    status = MCS0_CH0_CTRL;
    timeout_cnt += 1;
  } while (((status & 0x00000001) > 0x00000000) || (timeout_cnt < TIMEOUT));

  // this test finishes by timeout

  if ((status & 0x00000001) == 0x00000000) {
    // EN bit was reset by MCS program
    status = MCS0_CH0_R0;
    cout << "MCS0_CH0_R0 = 0x" << hex << status << endl;
    status = MCS0_CH0_R1;
    cout << "MCS0_CH0_R1 = 0x" << hex << status << endl;
    status = MCS0_CH0_R2;
    cout << "MCS0_CH0_R2 = 0x" << hex << status << endl;
  } else {
    // EN bit was not reset by MCS program
    cout << "Warning: MCS enable not reset by MCS program -> time out!" << endl;
  }

  //---------------------------------------------------------------------------
  return error;

}

//------------------------------------------------------------------------------
// ISR:

int mcs_atom_pmsm_isr(int number) {

  unsigned int status;
  gtm_ptr p;

  // sinus factor
  double sin_fact1=0;
  double sin_fact2=0;
  double sin_fact3=0;

  switch (number) {
  case 903:
    nr_of_calls++;
    cout << "ISR call number " << dec << nr_of_calls << endl; 

    status = ATOM0_CH7_IRQ_NOTIFY;
    cout << "ISR: ATOM0_CH7_IRQ_NOTIFY = 0x" << hex << status << endl;
    ATOM0_CH7_IRQ_NOTIFY  =  0x00000003;
    
    // sinus factor
    sin_fact1 = sin(((nr_of_calls*10)%360)*PI/180);
    sin_fact2 = sin(((nr_of_calls*10+120)%360)*PI/180);
    sin_fact3 = sin(((nr_of_calls*10+240)%360)*PI/180);

    // fill MCS0 RAM with new values
    p = &MCS0_MEM;               // pointer to first entry of MCS0 RAM

    p[LABEL_MCS0_RAM_ACH1_SR0] = (T0/2)-(T0/4+(int)(sin_fact1*((T0/4)-10)));
    p[LABEL_MCS0_RAM_ACH1_SR1] = (T0/2)+(T0/4+(int)(sin_fact1*((T0/4)-10)));
    p[LABEL_MCS0_RAM_ACH2_SR0] = (T0/2)-(T0/4+(int)(sin_fact1*((T0/4)-10)));
    p[LABEL_MCS0_RAM_ACH2_SR1] = (T0/2)+(T0/4+(int)(sin_fact1*((T0/4)-10))); 
    p[LABEL_MCS0_RAM_ACH3_SR0] = (T0/2)-(T0/4+(int)(sin_fact2*((T0/4)-10)));
    p[LABEL_MCS0_RAM_ACH3_SR1] = (T0/2)+(T0/4+(int)(sin_fact2*((T0/4)-10)));
    p[LABEL_MCS0_RAM_ACH4_SR0] = (T0/2)-(T0/4+(int)(sin_fact2*((T0/4)-10)));
    p[LABEL_MCS0_RAM_ACH4_SR1] = (T0/2)+(T0/4+(int)(sin_fact2*((T0/4)-10)));
    p[LABEL_MCS0_RAM_ACH5_SR0] = (T0/2)-(T0/4+(int)(sin_fact3*((T0/4)-10)));
    p[LABEL_MCS0_RAM_ACH5_SR1] = (T0/2)+(T0/4+(int)(sin_fact3*((T0/4)-10)));
    p[LABEL_MCS0_RAM_ACH6_SR0] = (T0/2)-(T0/4+(int)(sin_fact3*((T0/4)-10)));
    p[LABEL_MCS0_RAM_ACH6_SR1] = (T0/2)+(T0/4+(int)(sin_fact3*((T0/4)-10)));

    // trigger update by MCS:
    MCS0_STRG = 0x00000001;  //set bit TRG0

    return 0;
    break;
  case 923:
    nr_of_calls++;
    cout << "ISR call number " << dec << nr_of_calls << endl; 

    status = ATOM0_CH7_IRQ_NOTIFY;
    cout << "ISR: ATOM0_CH7_IRQ_NOTIFY = 0x" << hex << status << endl;
    ATOM0_CH7_IRQ_NOTIFY  =  0x00000003;
    
    // sinus factor
    sin_fact1 = sin(((nr_of_calls*10)%360)*PI/180);
    sin_fact2 = sin(((nr_of_calls*10+120)%360)*PI/180);
    sin_fact3 = sin(((nr_of_calls*10+240)%360)*PI/180);

    // fill MCS0 RAM with new values
    p = &MCS0_MEM;               // pointer to first entry of MCS0 RAM

    p[LABEL_MCS0_RAM_ACH1_SR0] = (T0/2)-(T0/4+(int)(sin_fact1*((T0/4)-10)));
    p[LABEL_MCS0_RAM_ACH1_SR1] = (T0/2)+(T0/4+(int)(sin_fact1*((T0/4)-10)));
    p[LABEL_MCS0_RAM_ACH2_SR0] = (T0/2)-(T0/4+(int)(sin_fact1*((T0/4)-10)));
    p[LABEL_MCS0_RAM_ACH2_SR1] = (T0/2)+(T0/4+(int)(sin_fact1*((T0/4)-10))); 
    p[LABEL_MCS0_RAM_ACH3_SR0] = (T0/2)-(T0/4+(int)(sin_fact2*((T0/4)-10)));
    p[LABEL_MCS0_RAM_ACH3_SR1] = (T0/2)+(T0/4+(int)(sin_fact2*((T0/4)-10)));
    p[LABEL_MCS0_RAM_ACH4_SR0] = (T0/2)-(T0/4+(int)(sin_fact2*((T0/4)-10)));
    p[LABEL_MCS0_RAM_ACH4_SR1] = (T0/2)+(T0/4+(int)(sin_fact2*((T0/4)-10)));
    p[LABEL_MCS0_RAM_ACH5_SR0] = (T0/2)-(T0/4+(int)(sin_fact3*((T0/4)-10)));
    p[LABEL_MCS0_RAM_ACH5_SR1] = (T0/2)+(T0/4+(int)(sin_fact3*((T0/4)-10)));
    p[LABEL_MCS0_RAM_ACH6_SR0] = (T0/2)-(T0/4+(int)(sin_fact3*((T0/4)-10)));
    p[LABEL_MCS0_RAM_ACH6_SR1] = (T0/2)+(T0/4+(int)(sin_fact3*((T0/4)-10)));

    // trigger update by MCS:
    MCS0_STRG = 0x00000001;  //set bit TRG0

    return 0;
    break;
  default:
    cout << "no ISR for interrupt " << dec << number << endl;
    return 1;
    break;
  }

}
