//head:-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// $Id: sw_mcs_spi_app.cpp,v 1.13 2014/04/11 13:09:28 twagner Exp $
//------------------------------------------------------------------------------
// NO WARRANTIES: TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER THE
// INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND CONTRIBUTORS, NOR ANY
// PERSON, EITHER EXPRESSLY OR IMPLICITLY, WARRANTS ANY ASPECT OF THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// INCLUDING ANY OUTPUT OR RESULTS OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO UNLESS AGREED TO IN WRITING.
// THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED
// THERETO IS BEING PROVIDED "AS IS", WITHOUT ANY WARRANTY OF ANY TYPE OR
// NATURE, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY
// WARRANTY THAT THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO IS FREE FROM DEFECTS.
//
// ASSUMPTION OF RISK: THE RISK OF ANY AND ALL LOSS, DAMAGE, OR UNSATISFACTORY
// PERFORMANCE OF THIS SPECIFICATION (RESPECTIVELY THE PRODUCTS MAKING USE OF
// IT IN PART OR AS A WHOLE), SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM
// RELATED THERETO RESTS WITH YOU AS THE USER. TO THE MAXIMUM EXTENT PERMITTED
// BY LAW, NEITHER THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND
// CONTRIBUTORS, NOR ANY PERSON EITHER EXPRESSLY OR IMPLICITLY, MAKES ANY
// REPRESENTATION OR WARRANTY REGARDING THE APPROPRIOATENESS OF THE USE, OUTPUT,
// OR RESULTS OF THE USE OF THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE
// AND/OR PROGRAM RELATED THERETO IN TERMS OF ITS CORRECTNESS, ACCURACY,
// RELIABILITY, BEING CURRENT OR OTHERWISE. NOR DO THEY HAVE ANY OBLIGATION TO
// CORRECT ERRORS, MAKE CHANGES, SUPPORT THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, DISTRIBUTE UPDATES, OR PROVIDE
// NOTIFICATION OF ANY ERROR OR DEFECT, KNOWN OR UNKNOWN. IF YOU RELY UPON THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// YOU DO SO AT YOUR OWN RISK, AND YOU ASSUME THE RESPONSIBILITY FOR THE
// RESULTS. SHOULD THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL LOSSES,
// INCLUDING, BUT NOT LIMITED TO, ANY NECESSARY SERVICING, REPAIR OR CORRECTION
// OF ANY PROPERTY INVOLVED TO THE MAXIMUM EXTEND PERMITTED BY LAW.
//
// DISCLAIMER: IN NO EVENT, UNLESS REQUIRED BY LAW OR AGREED TO IN WRITING,
// SHALL THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS OR ANY PERSON BE
// LIABLE FOR ANY LOSS, EXPENSE OR DAMAGE, OF ANY TYPE OR NATURE ARISING OUT OF
// THE USE OF, OR INABILITY TO USE THIS SPECIFICATION, SOFTWARE RELATED THERETO,
// CODE AND/OR PROGRAM RELATED THERETO, INCLUDING, BUT NOT LIMITED TO, CLAIMS,
// SUITS OR CAUSES OF ACTION INVOLVING ALLEGED INFRINGEMENT OF COPYRIGHTS,
// PATENTS, TRADEMARKS, TRADE SECRETS, OR UNFAIR COMPETITION.
//
// INDEMNIFICATION: TO THE MAXIMUM EXTEND PERMITTED BY LAW YOU AGREE TO
// INDEMNIFY AND HOLD HARMLESS THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT
// HOLDERS AND CONTRIBUTORS, AND EMPLOYEES, AND ANY PERSON FROM AND AGAINST ALL
// CLAIMS, LIABILITIES, LOSSES, CAUSES OF ACTION, DAMAGES, JUDGMENTS, AND
// EXPENSES, INCLUDING THE REASONABLE COST OF ATTORNEYS' FEES AND COURT COSTS,
// FOR INJURIES OR DAMAGES TO THE PERSON OR PROPERTY OF THIRD PARTIES,
// INCLUDING, WITHOUT LIMITATIONS, CONSEQUENTIAL, DIRECT AND INDIRECT DAMAGES
// AND ANY ECONOMIC LOSSES, THAT ARISE OUT OF OR IN CONNECTION WITH YOUR USE,
// MODIFICATION, OR DISTRIBUTION OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, ITS OUTPUT, OR ANY ACCOMPANYING
// DOCUMENTATION.
//
// GOVERNING LAW: THE RELATIONSHIP BETWEEN YOU AND ROBERT BOSCH GMBH SHALL BE
// GOVERNED SOLELY BY THE LAWS OF THE FEDERAL REPUBLIC OF GERMANY. THE
// STIPULATIONS OF INTERNATIONAL CONVENTIONS REGARDING THE INTERNATIONAL SALE OF
// GOODS SHALL NOT BE APPLICABLE. THE EXCLUSIVE LEGAL VENUE SHALL BE
// DUESSELDORF, GERMANY.
//
// MANDATORY LAW SHALL BE UNAFFECTED BY THE FOREGOING PARAGRAPHS.
//
// INTELLECTUAL PROPERTY OWNERS/COPYRIGHT OWNERS/CONTRIBUTORS: ROBERT BOSCH
// GMBH, ROBERT BOSCH PLATZ 1, 70839 GERLINGEN, GERMANY AND ITS LICENSORS.
//
// ALL RIGHTS RESERVED.
//------------------------------------------------------------------------------
// Project Name : GTM - Generic Timer Module
//------------------------------------------------------------------------------
// Copyright   : Robert Bosch GmbH, Gerlingen, Germany
// Department  : AE/EIY
// Created     : 25.01.2012
//------------------------------------------------------------------------------
//:head-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// Description     : MCS-ATOM PMSM control apllication example
//============================================================================ 
// Important Notes : 
//============================================================================ 

#include <iostream>
#include <time.h>
#include "gtm.h"
#include <math.h>
#include "gtm_device_cfg.h"
#include "functions.h"
#include <stdlib.h>
#include "platform.h"
#include "sw_mcs_spi_app_label.h"
#include "mcs_cfg.h"  /* generic MCS parameters go into mcs_cfg.h*/
namespace spi_app {
#include "sw_mcs_spi_app_mcs_code.h" // definition global variable mcs_code conatining MCS machine code 
};

#define MAX(a, b)   (((a)>(b))? (a):(b))
#define MIN(a, b)   (((a)<(b))? (a):(b))

//Contol data for Testbench
#define NUM_TEST_DATA   200	//Number of test data per Instance!!!
#define NUM_ABORTS	10	//percentage of aborts
#define NUM_INST     MIN(MIN(MCS_INSTANCES, TIM_INSTANCES), ATOM_INSTANCES)	//Number of parallel running instances

//Control for SPI Transfer
#define MIN_PERIOD      6	//minimal 6 
#define MAX_PERIOD      15

#define REAL_MAX_PERIOD (MAX_PERIOD - (MIN_PERIOD - 1))

#define isr_number_offset 401

struct test_data_type
{
	int width;
	int data;
	int period;
	int abort_time;		
};

static test_data_type testdata[NUM_INST][NUM_TEST_DATA];	//array for testdata
static int x;							//count variable
static int cnt_array[NUM_INST] ={0};				//count array for different mcs instances
static int max_sim_time = 24 * 15 * NUM_TEST_DATA;



using namespace std;
using namespace spi_app;
  

//Error codes (MCS Code)
#define RTX_ERROR_WD_CMU		6		//Wrong data in Register CMU_CLK_EN
#define RTX_ERROR_WD_TBU		7		//Wrong data in Register TBU_CHEN
#define RX_ERROR_WD_TIM			8		//Wrong data in Register TIM_IN_SRC
#define TX_ERROR_WD_IRQ_REG 		10		//Wrong data in Register MCS_CH_IRQ_EN
#define TX_ERROR_WD_ATOM_GLB_REG 	11		//Wrong data in Register ATO_AGC_GLB_CTRL
#define TX_ERROR_WD_ATOM_FUPD_REG 	12		//Wrong data in Register ATO_AGC_FUPD_CTRL
#define TX_ERROR_CAE			13		//TX Channel Already Enabled
#define TX_ERROR_SPI_AR			14		//SPI Transfer already Running
#define TX_ERROR_NO_ABORT		15
#define RX_ERROR_CE    			21
#define	RX_ERROR_EDGE_OVW  		22
#define RX_ERROR_TO   			23
#define RX_ERROR_CAE			24
#define RX_ERROR_SPI_NC			25		//SPI transfer not completed
#define RX_ERROR_WD_IRQ_REG		26		//Wrong data in Register MCS_CH_IRQ_EN
#define RX_ERROR_WD_TIM_CTRL_REG	27		//Wrong data in Register TIM_CH_CTRL
#define RX_TO_ABORT 			99


// allocated maximum of GTM resources
#define INST_COUNT ((unsigned int)MIN(MIN(ATOM_INSTANCES, TIM_INSTANCES), MCS_INSTANCES))



// MCS specific definitions
// Bit definitions for register STA (MCS[i]_CH[x]_CTRL)
#define MCS_STA_EN				0
#define MCS_STA_IRQ 				1
#define MCS_STA_ERR 				2
#define MCS_STA_MCA 				3
#define MCS_STA_CY				4
#define MCS_STA_Z 				5
#define MCS_STA_V 				6
#define MCS_STA_N 				7
#define MCS_STA_CAT 				8
#define MCS_STA_CWT 				9
#define MCS_STA_SAT 				10
#define MCS_STA_SP_CNT				16

// Bit definitions for IRQ registers
#define MCS_MCS_IRQ 					0
#define MCS_STK_ERR_IRQ 				1
#define MCS_MEM_ERR_IRQ 				2

#if MCS_ARCH == 1
	// Bit definitions for MCS[i]_CTRL register
	#define MCS_CTRL_SCHED				0
	#define MCS_CTRL_SCHED_BITS			1
	#define MCS_CTRL_HLT_SP_OFL 			1
	#define MCS_CTRL_RAM_RST			16
#else // MCS_ARCH == 2
	// Bit definitions for MCS[i]_CTRL_STAT register
	#define MCS_CTRL_STAT_SCHED			0
	#define MCS_CTRL_STAT_SCHED_BITS		3
	#define MCS_CTRL_STAT_RAM_RST			16
	#define MCS_CTRL_STAT_HLT_SP_OFL 		17
#endif

#if MCS_ARCH == 1
	// Bit definitions for MCS[i]_RST register
	#define MCS_RST_RST0			0
	#define MCS_RST_CAT0			8
	#define MCS_RST_CWT0			16
#endif // Architecture 2 uses seperate registers for RESET, CWT and CAT

// Bit mask definitions for register STA (MCS[i]_CH[x]_CTRL)
#define MCS_STA_EN_MSK    		(1<<MCS_STA_EN) 
#define MCS_STA_IRQ_MSK 		(1<<MCS_STA_IRQ
#define MCS_STA_ERR_MSK 		(1<<MCS_STA_ERR)
#define MCS_STA_MCA_MSK 		(1<<MCS_STA_MCA)
#define MCS_STA_CY_MSK			(1<<MCS_STA_CY)
#define MCS_STA_Z_MSK     		(1<<MCS_STA_Z)
#define MCS_STA_V_MSK     		(1<<MCS_STA_V)
#define MCS_STA_N_MSK   		(1<<MCS_STA_N)
#define MCS_STA_CAT_MSK   		(1<<MCS_STA_CAT)
#define MCS_STA_CWT_MSK   		(1<<MCS_STA_CWT)
#define MCS_STA_SAT_MSK   		(1<<MCS_STA_SAT)
#define MCS_STA_SP_CNT_MSK		((unsigned int)(pow((double)2, (double)MCS_SP_CNT_BITS)-1)<<MCS_STA_SP_CNT)

// Bit mask definitions for IRQ registers
#define MCS_MCS_IRQ_MSK 		(1<<MCS_MCS_IRQ)
#define MCS_STK_ERR_IRQ_MSK (1<<MCS_STK_ERR_IRQ)
#define MCS_MEM_ERR_IRQ_MSK (1<<MCS_MEM_ERR_IRQ)


// Register masks
#define MCS_DATA_WIDTH_MSK  ((unsigned int)(pow((double)2, MCS_DATA_WIDTH)-1))
#define MCS_WURM_MASK 			((unsigned int)(pow((double)2, MCS_WURM_MASK_WIDTH)-1))
#define MCS_MHB_MSK 				((unsigned int)(pow((double)2, MCS_RAM_DATA_WIDTH-MCS_DATA_WIDTH)-1))
#define MCS_ACB_MSK 				0x1F

// ARU specific defines
// ARU MCS write address
#define ARU_ACCESS_ADDR_MSK		0x1FF
#define ARU_ACCESS_RREQ 		12
#define ARU_ACCESS_WREQ 		13
#define ARU_ACCESS_RREQ_MSK 		(1<<ARU_ACCESS_RREQ)
#define ARU_ACCESS_WREQ_MSK 		(1<<ARU_ACCESS_WREQ)
#define ARU_ACCESS_WRADDR 		0

#define MCS_WRADDR(X0, X1)		(0x077+(X0)*24+X1)			//X0 MCS index
#define TIM_WRADDR(X0, X1)		(0x1+0x8*(X0)+X1)	

 
#define MCS_CH_ENABLED			1
#define MCS_CH_DISABLED			0

#define SPI_ABORT_ACTIVE		1
#define SPI_ABORT_INACTIVE		0


//------------------------------------------------------------------------------
//spi_tx_init initialize the spi transceiver
//------------------------------------------------------------------------------

static int spi_tx_init(int inst)
{
 
  gtm_ptr p_mem;
  int error = 0;
  int i;
  
  if ((MCS_CH_CTRL(inst,0) & 0x1) == MCS_CH_ENABLED)
  {
  	  RPT_PRINT << "Inst:" << inst <<" ERROR(13): spi_tx_init: channel 0 alredy running ERR" << endl;  
  	  error = TX_ERROR_CAE;
  	  return error;
  }
  
   RPT_PRINT << "Inst:" << inst <<" setup ATOM channels for SPI TX" << endl;  
  // initialize ARU read channels
  ATOM_CH_RDADDR(inst, 0) = MCS_WRADDR(inst, 0);
  ATOM_CH_RDADDR(inst, 1) = MCS_WRADDR(inst, 1);
  ATOM_CH_RDADDR(inst, 2) = MCS_WRADDR(inst, 2);
  // setup SOMP mode for all signal outputs
  ATOM_CH_CTRL(inst, 0) = 0x0000082A; 			
  ATOM_CH_CTRL(inst, 1) = 0x0000082A; 
  ATOM_CH_CTRL(inst, 2) = 0x0000082A; 
  // setup period for all signal outputs
  ATOM_CH_SR0(inst, 0) = 10; 				//defualt values for start
  ATOM_CH_SR0(inst, 1) = 10;				//defualt values for start
  ATOM_CH_SR0(inst, 2) = 10; 				//defualt values for start
  // setup initial level for each input
  ATOM_CH_SR1(inst, 0) = 0; 
  ATOM_CH_SR1(inst, 1) = 10;				//disable CE (PWM =100%)
  ATOM_CH_SR1(inst, 2) = 0; 
  // update signal output immediately 
  ATOM_AGC_ENDIS_CTRL(inst) = 0x2A;  			//channel 0->2 enabled
  ATOM_AGC_OUTEN_CTRL(inst) = 0x2A;  			//enable channel output 0-> 2 on an update trigger
  ATOM_AGC_GLB_CTRL(inst) = 0x002A0001;  		//update and trigger enable 
  
    RPT_PRINT << "Inst:" << inst <<" wait until RAM initialization has finished"  << endl;  
#if MCS_ARCH == 1
  while ( MCS_CTRL(inst) & 0x10000 ); 
#else
  while ( MCS_CTRL_STAT(inst) & 0x10000 );
  //RPT_PRINT << "wait until RAM initialization has finished"  << endl;
#endif
	
  RPT_PRINT << "Inst:" << inst <<" loading MCS micro code to MCS_RAM " <<  endl;
  p_mem = &MCS_MEM(inst);  				// initialize memory pointer with target instance
    for (i=0; i<(SIZE_MCS_CODE/4); i++) {
    p_mem[i] = mcs_code[i];        			// store value to MCS RAM[inst]
  }
 
  MCS_CH_IRQ_EN(inst, 0) =  0x1; 			//MCS[inst] channel 0 enable MCS IRQ 
  error = check(MCS_CH_IRQ_EN(inst, 0), 0x01, "MCS_CH_IRQ_EN");
  if(error != 0)
  { 
  	  RPT_PRINT << "Inst:" << inst <<"ERROR(10): Wrong data in register MCS_CH_IRQ_EN" <<  endl;
  	  error = TX_ERROR_WD_IRQ_REG ;
  	  return error;
  }

  return error;
}


	
//------------------------------------------------------------------------------
// send data via SPI 
//------------------------------------------------------------------------------

static int spi_tx_put(int inst, int data, int width , int period )
{
 RPT_PRINT << "entering method spi_tx_put(inst=" << inst 
	    << ", data=" << data << ", width=" << width <<", period=" << period << ")" <<  endl;
	 	    

  int error = 0;
  int ts_start;
  gtm_ptr p_mem = &MCS_MEM(inst);  
  
  if ((MCS_CH_CTRL(inst,0) & 0x1) == MCS_CH_ENABLED) 				//MCS[inst] channel 0 already enabled?
  {
  	  RPT_PRINT << "Inst:" << inst <<" ERROR(14): spi_tx_put: Spi transfer alreading running error" << endl;  
  	  error = TX_ERROR_SPI_AR;
  	  
  	  RPT_PRINT << "Inst:" << inst <<" ERROR(14): Wait until last transfer finished" << endl; 
  	  while ((MCS_CH_CTRL(inst,0) & 0x1) == MCS_CH_ENABLED);
  }
  
 else
 {
  p_mem[LABEL_MCS_CODE_SPI_MEM_ABORT] = SPI_ABORT_INACTIVE;			//Reset Abort value in MCS RAM		 
  MCS_CH_PC(inst, 0) = 	(LABEL_MCS_CODE_SPI_TX_INIT *4) ; 	 		//Set PC at start of mcs code  
  
  // setup RAM-related variables for MCS TX program
  p_mem[LABEL_MCS_CODE_SPI_TX_DATA] = data;		
  p_mem[LABEL_MCS_CODE_SPI_TX_PERIOD] = period;
  p_mem[LABEL_MCS_CODE_SPI_TX_WIDTH] = width;
 
	
  // setup new period for all signal outputs	
  ATOM_CH_SR0(inst, 0) = period; 
  ATOM_CH_SR0(inst, 1) = period;
  ATOM_CH_SR0(inst, 2) = period; 
  // setup initial level for each input	(idle state)
  ATOM_CH_SR1(inst, 0) = 0; 
  ATOM_CH_SR1(inst, 1) = period;
  ATOM_CH_SR1(inst, 2) = 0; 
 


  // enable update for ATOMs
  ATOM_AGC_GLB_CTRL(inst) =  0x002A0000;
  error = check( ATOM_AGC_GLB_CTRL(inst), 0x3F0000, "ATOM_AGC_GLB_CTRL");
   if(error != 0)
  { 
  	  RPT_PRINT << "Inst:" << inst <<"ERROR(11): Wrong data in register ATOM_AGC_GLB_CTRL" <<  endl;
  	  error = TX_ERROR_WD_ATOM_GLB_REG;
  	  return error;
  }
  
  //enable force update and the associated channels
  ATOM_AGC_FUPD_CTRL(inst) = 0x2A002A;						
  error = check( ATOM_AGC_FUPD_CTRL(inst), 0x3F003F, "ATOM_AGC_FUPD_CTRL");
  if(error != 0)
  { 
  	  RPT_PRINT << "Inst:" << inst <<"ERROR(12): Wrong data in register ATOM_AGC_FUPD_CTRL" <<  endl;
  	  error = TX_ERROR_WD_ATOM_GLB_REG;
  	  return error;
  }
  
  //sync time for atom with mcs
  ts_start = TBU_CH0_BASE;					
  ATOM_AGC_ACT_TB(inst) = ((ts_start+2)& 0xFFFFFF) | 0x01000000; 				//generate timestamp + 2us
  								


  p_mem[LABEL_MCS_CODE_TS_START] = ts_start + 3;				//write ts_start (for WURM sync) to memory
  										//wait 1 us more as atom sync time, to start at cnt value 0 of atom[inst]

  MCS_CH_CTRL(inst, 0) = MCS_CH_ENABLED;					//MCS[inst] channel 0 enable MCS sender
 }
  
  return error;
 
}

//------------------------------------------------------------------------------
// spi abort function
//------------------------------------------------------------------------------

static int spi_tx_abort(int inst) 
{
  int error = 0;
  gtm_ptr p_mem = &MCS_MEM(inst);  

  
  if ((MCS_CH_CTRL(inst,0) & 0x1) == MCS_CH_ENABLED) 				//MCS[inst] channel 0 already enabled?
  { 
  	  if ( p_mem[LABEL_MCS_CODE_SPI_MEM_ABORT] == 2)
  	  {
  	  	  RPT_PRINT << "Inst:" << inst <<" ERROR(16):abort already running " << endl;   	  
  	  }
  	  else
  	  {
  	  	  RPT_PRINT << "Inst:" << inst <<" spi transceiver channel enabled --> abort transfer " << endl; 
  	  	  p_mem[LABEL_MCS_CODE_SPI_MEM_ABORT] = SPI_ABORT_ACTIVE;	//Write aktive abort to MCS RAM --> mcs code disalbles spi transfer
  	  }
  }
  else
  {
  	  RPT_PRINT << "Inst:" << inst <<" ERROR(15): spi transceiver channel disabled no transfer aktive --> no abort possible!" << endl;   
  	  error = TX_ERROR_NO_ABORT;
  }
  return error;	
}


//------------------------------------------------------------------------------
// spi_common_init ( initializes the commonly used modules CMU and TBU ) NEW
//------------------------------------------------------------------------------

static int spi_common_init(int inst) 
{
	
  int i;
  int error = 0;
	  		
  RPT_PRINT << "Inst:" << inst <<" setup CMU and TBU"  << endl;  			 	
  CMU_GCLK_NUM = 0xFFFF;							//Numerator of global clk divider					
  CMU_GCLK_DEN = 0xFFFF;							//Denominator of global clk divider
  CMU_CLK_0_CTRL = 99; 								// 1 CMU tick = 1 us
 CMU_CLK_EN = 0x2;
  error = check(CMU_CLK_EN, 0x00000003, "CMU_CLK_EN");
  if(error != 0)
  { 
  	  RPT_PRINT << "Inst:" << inst <<"ERROR(6): Wrong data in register CMU_CLK_EN" <<  endl;
  	  error = RTX_ERROR_WD_CMU;
  	  return error;
  }
  
  TBU_CH0_CTRL = 0x0;								//use cmu_clk 0 for transceiver signal generation
  TBU_CHEN = 0x2;
  error = check(TBU_CHEN, 0x00000003, "TBU_CHEN");            
  if(error != 0)
  { 
  	  RPT_PRINT << "Inst:" << inst <<"ERROR(7): Wrong data in register TBU_CHEN" <<  endl;
  	  error = RTX_ERROR_WD_TBU;
  	  return error;
  }
  


  
  
      switch (LOOP_BACK) {
	   case LOOP_BACK_INTERNAL:
# ifdef TIM_IN_SRC
             TIM_IN_SRC(inst) = 0x00000222;  					//Input signal is set to 1
             error = check(TIM_IN_SRC(inst), 0x00000333, "TIM_IN_SRC"); 	//if 0x...0333 input signal is set to 1
              if(error != 0)
              { 
              	      RPT_PRINT << "Inst:" << inst <<"ERROR(8): Wrong data in register TIM_IN_SRC" <<  endl;
              	      error =  RX_ERROR_WD_TIM;
              	      return error;
  	      }
             
# endif	     
	     break;
	   case LOOP_BACK_EXTERNAL_TB:
	     break;
	   default:
             cout << "Inst:" << inst <<" ERROR (2): Unkown Loopback" << dec << LOOP_BACK << endl;
	     break;
  }
  
  RPT_PRINT << "Inst:" << inst <<" route ATOM outputs to TIM inputs"  << endl;  
  RPT_PRINT << "INST_COUNT=" << INST_COUNT << endl;
  
  switch (LOOP_BACK) {
	   case LOOP_BACK_INTERNAL:
# ifdef GTM_TIM_AUX_IN_SRC
	     for (i = 0; i < INST_COUNT; i++) {  
	     	     GTM_TIM_AUX_IN_SRC(i) = 0x07; 				//connect ATOM with TIM channels (channel: 0,1,2)
	     }				     
# endif	     
	     break;
	   case LOOP_BACK_EXTERNAL_TB:
	     break;
	   default:
             cout << "Inst:" << inst <<" ERROR (3): Unkown Loopback" << dec << LOOP_BACK << endl;
	     break;
  }

  
  return error;
}


//------------------------------------------------------------------------------
// spi_rx_init  initialize reciever
//------------------------------------------------------------------------------
static int spi_rx_init(int inst)
{
	int error = 0;
	gtm_ptr p_mem = &MCS_MEM(inst);
	int i=0;
	

	  RPT_PRINT << "Inst:" << inst <<" wait until RAM initialization has finished"  << endl;
	  #if MCS_ARCH == 1
	  while ( MCS_CTRL(inst) & 0x10000 ); 
	  #else
	  while ( MCS_CTRL_STAT(inst) & 0x10000 );
	  

	  #endif
	  
	  
	   RPT_PRINT << "Inst:" << inst <<" loading MCS micro code to MCS_RAM " <<  endl;
	   p_mem = &MCS_MEM(inst);  						// initialize memory pointer with target instance
	   for (i=0; i<(SIZE_MCS_CODE/4); i++) {
	    	    p_mem[i] = mcs_code[i];        				// store value to MCS RAM[inst]
	   }
	  

	  MCS_CH_IRQ_EN(inst, 1) =  0x1; 					// enable MCS[inst] channel 1 IRQ 
	  error = check(MCS_CH_IRQ_EN(inst, 1),  MCS_CH_ENABLED, "MCS_CH_IRQ_EN(1)");
	   if(error != 0)
	   { 
	   	   RPT_PRINT << "Inst:" << inst <<"ERROR(26): Wrong data in register MCS_CH_IRQ_EN" <<  endl;
	   	   error = RX_ERROR_WD_IRQ_REG;
	   	   return error;
	   }
	  
 return error;	
}




//------------------------------------------------------------------------------
// spi config reciever
//------------------------------------------------------------------------------

static int spi_rx_configure(int inst, int width, int timeout) {

	gtm_ptr p_mem = &MCS_MEM(inst);  
	int error =0;
	int test = 0;
	
	if ((MCS_CH_CTRL(inst,1) & 0x1) == MCS_CH_ENABLED) 			//MCS[inst] channel 0 already enabled?
	{ 
	  RPT_PRINT << "Inst:" << inst <<" ERROR(24): spi_rx_configure: SPI receiver  alreading enabled" << endl;  
  	  error = RX_ERROR_CAE	;
  	  return error;
  	}
  	
  	MCS_CH_PC(inst, 1) = 	(LABEL_MCS_CODE_SPI_RX_INIT *4);		//Reset Programm counter (MCS code) to start address
  	
  	// setup RAM-related variables for MCS TX program
	p_mem[LABEL_MCS_CODE_SPI_RX_WIDTH] = width;						
	p_mem[LABEL_MCS_CODE_SPI_TIM_WRADDR]= TIM_WRADDR(inst, 0); 		//write readadress for MCS RX
#if MCS_ARCH == 1								//write MCS Architecture to RAM 
	p_mem[LABEL_MCS_CODE_SPI_MCS_ARCH] = 1;
#else
	p_mem[LABEL_MCS_CODE_SPI_MCS_ARCH] = 0;
#endif
	 				    

	 RPT_PRINT << "Inst:" << inst <<" setup TIM channels for SPI RX in Bit Compression Mode " << endl; 
	 // configure bit compression mode for TIM channel 0 (CLK signal, 
	 TIM_CH_TDUV(inst, 0) = timeout;   				 	//Ttdu = (timeout+1) * Tcm_clk
	 TIM_CH_CTRL(inst, 0) = 0x90000029; 				 	//channel and timeout detection enabled and routing of ECNT
	 				   				 	//0x00000029 timeout detection disabled
	 error = check(TIM_CH_CTRL(inst, 0),  0x90000029, "TIM_CH_CTRL");
	 if(error != 0)
	   { 
	   	   RPT_PRINT << "Inst:" << inst <<"ERROR(27): Wrong data in register TIM_CH_CTRL" <<  endl;
	   	   error = RX_ERROR_WD_TIM_CTRL_REG;
	   	   return error;
	   }

	 // TIM channel is triggered on each falling edge of CLK)
	 TIM_CH_CNTS(inst, 0) = 0x00000100;
	
	MCS_CH_CTRL(inst, 1) = MCS_CH_ENABLED; 					// enable MCS[inst] channel 1 receiver
	
 return error;
}



//------------------------------------------------------------------------------
// SPI Get Funktion
//------------------------------------------------------------------------------

static int spi_rx_get(int inst)
{
	gtm_ptr p_mem = &MCS_MEM(inst); 
	int data = 0;
	int width = 0;
	int error = 0;
	int zerg = 0;
	int erg = 0;
	
	 if ((MCS_CH_CTRL(inst,1) & 0x1) == MCS_CH_ENABLED)    			//MCS[inst] channel 1  enabled?
	 {
	  RPT_PRINT << "Inst:" << inst <<" ERROR(25): spi_rx_get:SPI transfer not completed" << endl;  
  	  error = RX_ERROR_SPI_NC;
  	  return error;
  	 }
  	 
  	
  	 if (p_mem[LABEL_MCS_CODE_SPI_RX_ERROR_MEM] != 0)			//check for error or abort 
  	 {
  	 	 erg = 0;
  	 }
  	 else
  	 {
  	 	
  	 #if MCS_ARCH == 1							//only for architecture 1
  	
	 data = p_mem[LABEL_MCS_CODE_SPI_RX_DATA];
  	 width = p_mem[LABEL_MCS_CODE_SPI_RX_WIDTH];
  	 
  	 while (width > 0)							//switch data from memory in right order
  	 {
  	 	  zerg = data & 0x1;
  	 	  data >>= 1;
  	 	  width -= 1; 
  	 	  erg <<= 1;
  	 	  erg |= zerg;
  	 }
  	 #else
  		 erg= p_mem[LABEL_MCS_CODE_SPI_RX_DATA];
  	 #endif
  	 
  	 }

	 
  	 RPT_PRINT << "Inst:" << inst <<" spi_rx_get: received data= "<< erg << endl;  
  	 return erg;
}

//------------------------------------------------------------------------------
//spi rx error check
//------------------------------------------------------------------------------
static int spi_rx_get_error(int inst)
{	
	int error =0;
	
	gtm_ptr p_mem = &MCS_MEM(inst); 
	error = p_mem[LABEL_MCS_CODE_SPI_RX_ERROR_MEM];				//read Error byte from memory
 	p_mem[LABEL_MCS_CODE_SPI_RX_ERROR_MEM]= 0;     				//delete Error byte
	
 return error;									//return error
}


//------------------------------------------------------------------------------
//spi print error
//------------------------------------------------------------------------------
static int spi_print_error(int inst, int error)
{
	 cout << "MCS_SPI_APP" << endl;
 switch (error)									//Errors from MCS-Code espacially RX
 	{
 	case 0:  RPT_PRINT << "Inst:" << inst <<" get data from transceiver --> correct" << endl; break;	
 	case RX_ERROR_CE    : RPT_PRINT << "Inst:" << inst <<" ERROR:21:(SPI-Rx) MCS-Code: CE not enabled " << endl; break;
 	case RX_ERROR_EDGE_OVW  : RPT_PRINT << "Inst:" << inst <<" ERROR:22:(SPI-RX) MCS-Code: Input edge overwritten by susequent edge " << endl; break;	
 	case RX_ERROR_TO  : RPT_PRINT << "Inst:" << inst <<" ERROR:23:(SPI-RX) MCS_Code: Timeout detected without valid edge" << endl; break; 
 	case RX_TO_ABORT   : RPT_PRINT << "Inst:" << inst <<" (SPI-RX) MCS_Code: Timeout detected without valid edge after abort--> correct behavior!" << endl; break; 	
 	default: RPT_PRINT << "Inst:" << inst <<" undefinied Error, (more than one error), Error value:" << error << endl; break;	
 	}	
 return 0;
 
 
}
//------------------------------------------------------------------------------
//Test function
//------------------------------------------------------------------------------
static int fill_test_array()
{
	RPT_PRINT << "enter fill_test_array!" << endl;
	int i = 0;
	int j = 0;
	int zerg = 0;
	int sr_time = (int)time(NULL);
	char* psz_env;
	char sz_buf[12];
#ifdef MTI_SYSTEMC // use Modelsim simulator
	psz_env = getenv("DBSIM_BATCH");
	if ( psz_env != NULL && string(psz_env) == "true" ) 
	{
		RPT_PRINT << "Seed Value srand:" << sr_time << endl;
		srand(sr_time);
	}
	else
	{
		RPT_PRINT << "Enter seed value: (0 = generate random seed value)" << endl;
		cin.getline(sz_buf, 100);
        	if (atoi(sz_buf) == 0)
		{
			RPT_PRINT << "Seed Value srand:" << sr_time << endl;
			srand(sr_time);			
		}
		else
		{
			RPT_PRINT << "Seed Value srand:" << sz_buf << endl;
			srand(atoi(sz_buf));			
		}
	}
#else // else use OSCI simuilator
	RPT_PRINT << "Seed Value srand:" << sr_time << endl;
	srand(sr_time);
#endif							//comment out for spi transfer with same data 
	for(i=0; i < NUM_INST ; i++)  
	{
		
		for (j=0; j< NUM_TEST_DATA; j++)
		{
				
			testdata[i][j].width = 	rand()% 24 + 1;								//calculate parameter width (1-24)
			testdata[i][j].data = rand()% ((int)((pow (double(2), double((testdata[i][j].width-1))))));			//calculate parameter data dependent on width
			testdata[i][j].period=  rand()% REAL_MAX_PERIOD + MIN_PERIOD;								//calculate paramter period 
	
			if ((rand()%100 + 1) <= NUM_ABORTS && 	testdata[i][j].width >= 5 )				//calculate aborts dependent on user parameter NUM_ABORTS
			{	
				zerg=(((testdata[i][j].width * testdata[i][j].period) - (4 * testdata[i][j].period)));	
				if (zerg <= 0)
				{
					testdata[i][j].abort_time  = 0;							//no abort
				}
				else
				{
					testdata[i][j].abort_time = (rand()%zerg) + 2* testdata[i][j].period + 3;	//needs +3us becouse of 3us worm suspend of mcs code
				
				}
			}
			else 
			{
				testdata[i][j].abort_time = 0;								//no abort
			}
			
			
			
			RPT_PRINT << "testdata[" <<i <<"]["<<j <<"], width      = " <<testdata[i][j].width << endl;
			RPT_PRINT << "testdata[" <<i <<"]["<<j <<"], data       = " <<testdata[i][j].data << endl;
			RPT_PRINT << "testdata[" <<i <<"]["<<j <<"], period     = " <<testdata[i][j].period << endl;
			RPT_PRINT << "testdata[" <<i <<"]["<<j <<"], abort_time = " <<testdata[i][j].abort_time << endl << endl;
		}
	}
	
 return 0;	
}


//------------------------------------------------------------------------------
// main thread: 
//------------------------------------------------------------------------------

int mcs_spi_app() {

  cout << "MCS_SPI_APP" << endl;
  cout << "NUM_INST=" <<NUM_INST << endl;
 
  int inst = (NUM_INST-1);   	// instance of mcs 
  int timeout =0;	
  int i = 0;
  int error = 0;


  RPT_PRINT << "########################################################" << endl;
  RPT_PRINT << "start main application " << endl;
  RPT_PRINT << "########################################################" << endl;
  
  
  //Check User Parameters
  if (NUM_ABORTS > 100 || NUM_ABORTS < 0)
  {
  	RPT_PRINT << " ERROR (40) :User Parameter NUM_ABORTS is incorrect (0-100) " << endl;	 	  
  }
  else
  {
  	RPT_PRINT << " User Parameters are correct Start SPI Test with "<< NUM_TEST_DATA  << " data sets, worst case time is "<< max_sim_time <<"us"<< endl;	
  }
  
  fill_test_array();
  
  for (i=NUM_INST; i > 0 ;i--)
  {
  RPT_PRINT << "############START INSTANCE:" <<i <<"#####################" << endl;
  error = spi_common_init(inst);
  if (error != 0 ) 
  {
  	  RPT_PRINT << "Inst:" << inst <<" ERROR (4) :Not enough TIM Instances --> Program Abort" << endl;	 
  	  return 0;
  }
  error = spi_tx_init(inst);
  if (error != 0 ) 
  {
  	  RPT_PRINT << "Inst:" << inst <<" ERROR (5) :Not enough MCS Instances --> Program Abort" << endl;	
  	  return 0;
  }
  spi_rx_init(inst); 
  timeout = (3*testdata[inst][cnt_array[inst]].period) / 2 ;  
  spi_rx_configure(inst, testdata[inst][cnt_array[inst]].width, timeout);
  spi_tx_put(inst, testdata[inst][cnt_array[inst]].data, testdata[inst][cnt_array[inst]].width, testdata[inst][cnt_array[inst]].period);  

  inst --;
  }

  return 0;

}

//------------------------------------------------------------------------------
//isr Receiver!!!
//------------------------------------------------------------------------------


int mcs_spi_rx_isr(int number) 
{

  RPT_PRINT << "########################################################" << endl;		// SPI Interrupt: This ISR Starts New SPI transmissions until the function reaches NUM_TEST_DATA.
  RPT_PRINT << "received interrupt " << number << endl;
  RPT_PRINT << "########################################################" << endl;
  int error = 0;
  int timedelay = 0;
  int inst = 0;
  int timeout = 0;
  int data = 0;

  x++;
  RPT_PRINT << "Number of intterupt receiver calls =" << x << endl;
  
  if (number >= 500)
  {	  
  	inst = ((number - 501) / 8) + 4;
  }	
  else
  {
  	inst = (number - isr_number_offset) / 8; 
  }
  cnt_array[inst]++;		
		  
    		  data = spi_rx_get(inst);
    		  error = spi_rx_get_error(inst);
    		  RPT_PRINT << "cnt_array:" << cnt_array[inst] << endl;
    		  if (error == RX_ERROR_TO && testdata[inst][(cnt_array[inst]-1)].abort_time != 0) //Check error variable for real timeout or abort
    		  {
    		      error = 99;	  					//Error 99 Correct behavier timeout becouse of abort!
    		  }
    		  else 
    		  {
    		  	   if (data == testdata[inst][(cnt_array[inst]-1)].data)
    		  	   {
    		  	   	   RPT_PRINT << "Inst:" << inst <<" correct data received =" << data << endl;  
  	  	  	   }
  	  	  	   else 
  	  	  	   {
  	  	  	   	   RPT_PRINT << "Inst:" << inst <<" ERROR(1): wrong data received =" << data << endl;   
  	  	  	   }
  	  	  }
  	  	  
  		 error = spi_print_error(inst, error);				// return value always 0 --> print errors and delete error variable with return value of 0
  		  
  		  
  		  timeout = (3*testdata[inst][cnt_array[inst]].period) / 2 ;  	// timeout = 1,5* period
  		  if (cnt_array[inst] < (NUM_TEST_DATA ))			//last isr only reads data and does not start a new transmission
  		  {
  		  timedelay=(TBU_CH0_BASE + testdata[inst][cnt_array[inst-1]].period) & 0xFFFFFF;
  		  while (timedelay != TBU_CH0_BASE);
  		  
  		  	  error=spi_rx_configure(inst, testdata[inst][cnt_array[inst]].width, timeout);
  	  	  
  		
  		  
  			error=spi_tx_put(inst, testdata[inst][cnt_array[inst]].data, testdata[inst][cnt_array[inst]].width, testdata[inst][cnt_array[inst]].period);
  		    
  		  
  			if (testdata[inst][cnt_array[inst]].abort_time != 0 )
  			{		
  		  	  timedelay = (TBU_CH0_BASE + testdata[inst][cnt_array[inst]].abort_time) & 0xFFFFFF;			
  		  	  while (timedelay != TBU_CH0_BASE);
  		  	  RPT_PRINT << "Inst:" << inst <<" abort time =" << testdata[inst][cnt_array[inst]].abort_time << endl;  
  		 	  spi_tx_abort(inst);
  		 	  
  		 	}
  		  
  		   	
  		  }	  MCS_CH_IRQ_NOTIFY(inst,1) = 0x1;  
  
  		  
  		 
  		  if (x <= (NUM_INST*NUM_TEST_DATA))				
  		  {
  		  	  RPT_PRINT << "Inst:" << inst <<" leave irq"  << endl;	  
  		  }
  		  else
  		  {
  		  	  RPT_PRINT << "Inst:" << inst <<" ERROR(30): Too much Interrupt calls " << endl;  	    
  		  }
  		  
  		  if ( TBU_CH0_BASE >= (unsigned int)max_sim_time)
  		  {
  		  	  RPT_PRINT << "Inst:" << inst <<" ERROR(31): Entering isr after maximum runtime "  << endl;  	  
  		  }
  		  if (error != 0)
  		  {
  		  	  RPT_PRINT << "Inst:" << inst <<" ERROR from register check: "<< error << endl;  
  		  }
  		  	  
  return 0;
}


//------------------------------------------------------------------------------
// All other isr's (Transceiver IRQs)
//------------------------------------------------------------------------------

int mcs_spi_app_isr(int number) 
{

	//ISR for Transceiver IRQs, Application specific routine 
	RPT_PRINT << "irq number:" << number <<" Transceiver irq received " << endl; 

  return 0;
}



