//head:-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// $Id: brc_mcs_test.cpp,v 1.10 2012/12/14 05:57:34 jhanisch Exp $
//------------------------------------------------------------------------------
// NO WARRANTIES: TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER THE
// INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND CONTRIBUTORS, NOR ANY
// PERSON, EITHER EXPRESSLY OR IMPLICITLY, WARRANTS ANY ASPECT OF THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// INCLUDING ANY OUTPUT OR RESULTS OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO UNLESS AGREED TO IN WRITING.
// THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED
// THERETO IS BEING PROVIDED "AS IS", WITHOUT ANY WARRANTY OF ANY TYPE OR
// NATURE, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY
// WARRANTY THAT THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO IS FREE FROM DEFECTS.
//
// ASSUMPTION OF RISK: THE RISK OF ANY AND ALL LOSS, DAMAGE, OR UNSATISFACTORY
// PERFORMANCE OF THIS SPECIFICATION (RESPECTIVELY THE PRODUCTS MAKING USE OF
// IT IN PART OR AS A WHOLE), SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM
// RELATED THERETO RESTS WITH YOU AS THE USER. TO THE MAXIMUM EXTENT PERMITTED
// BY LAW, NEITHER THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND
// CONTRIBUTORS, NOR ANY PERSON EITHER EXPRESSLY OR IMPLICITLY, MAKES ANY
// REPRESENTATION OR WARRANTY REGARDING THE APPROPRIOATENESS OF THE USE, OUTPUT,
// OR RESULTS OF THE USE OF THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE
// AND/OR PROGRAM RELATED THERETO IN TERMS OF ITS CORRECTNESS, ACCURACY,
// RELIABILITY, BEING CURRENT OR OTHERWISE. NOR DO THEY HAVE ANY OBLIGATION TO
// CORRECT ERRORS, MAKE CHANGES, SUPPORT THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, DISTRIBUTE UPDATES, OR PROVIDE
// NOTIFICATION OF ANY ERROR OR DEFECT, KNOWN OR UNKNOWN. IF YOU RELY UPON THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// YOU DO SO AT YOUR OWN RISK, AND YOU ASSUME THE RESPONSIBILITY FOR THE
// RESULTS. SHOULD THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL LOSSES,
// INCLUDING, BUT NOT LIMITED TO, ANY NECESSARY SERVICING, REPAIR OR CORRECTION
// OF ANY PROPERTY INVOLVED TO THE MAXIMUM EXTEND PERMITTED BY LAW.
//
// DISCLAIMER: IN NO EVENT, UNLESS REQUIRED BY LAW OR AGREED TO IN WRITING,
// SHALL THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS OR ANY PERSON BE
// LIABLE FOR ANY LOSS, EXPENSE OR DAMAGE, OF ANY TYPE OR NATURE ARISING OUT OF
// THE USE OF, OR INABILITY TO USE THIS SPECIFICATION, SOFTWARE RELATED THERETO,
// CODE AND/OR PROGRAM RELATED THERETO, INCLUDING, BUT NOT LIMITED TO, CLAIMS,
// SUITS OR CAUSES OF ACTION INVOLVING ALLEGED INFRINGEMENT OF COPYRIGHTS,
// PATENTS, TRADEMARKS, TRADE SECRETS, OR UNFAIR COMPETITION.
//
// INDEMNIFICATION: TO THE MAXIMUM EXTEND PERMITTED BY LAW YOU AGREE TO
// INDEMNIFY AND HOLD HARMLESS THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT
// HOLDERS AND CONTRIBUTORS, AND EMPLOYEES, AND ANY PERSON FROM AND AGAINST ALL
// CLAIMS, LIABILITIES, LOSSES, CAUSES OF ACTION, DAMAGES, JUDGMENTS, AND
// EXPENSES, INCLUDING THE REASONABLE COST OF ATTORNEYS' FEES AND COURT COSTS,
// FOR INJURIES OR DAMAGES TO THE PERSON OR PROPERTY OF THIRD PARTIES,
// INCLUDING, WITHOUT LIMITATIONS, CONSEQUENTIAL, DIRECT AND INDIRECT DAMAGES
// AND ANY ECONOMIC LOSSES, THAT ARISE OUT OF OR IN CONNECTION WITH YOUR USE,
// MODIFICATION, OR DISTRIBUTION OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, ITS OUTPUT, OR ANY ACCOMPANYING
// DOCUMENTATION.
//
// GOVERNING LAW: THE RELATIONSHIP BETWEEN YOU AND ROBERT BOSCH GMBH SHALL BE
// GOVERNED SOLELY BY THE LAWS OF THE FEDERAL REPUBLIC OF GERMANY. THE
// STIPULATIONS OF INTERNATIONAL CONVENTIONS REGARDING THE INTERNATIONAL SALE OF
// GOODS SHALL NOT BE APPLICABLE. THE EXCLUSIVE LEGAL VENUE SHALL BE
// DUESSELDORF, GERMANY.
//
// MANDATORY LAW SHALL BE UNAFFECTED BY THE FOREGOING PARAGRAPHS.
//
// INTELLECTUAL PROPERTY OWNERS/COPYRIGHT OWNERS/CONTRIBUTORS: ROBERT BOSCH
// GMBH, ROBERT BOSCH PLATZ 1, 70839 GERLINGEN, GERMANY AND ITS LICENSORS.
//
// ALL RIGHTS RESERVED.
//------------------------------------------------------------------------------
// Project Name : GTM - Generic Timer Module
//------------------------------------------------------------------------------
// Copyright   : Robert Bosch GmbH, Gerlingen, Germany
// Department  : AE/EIY
// Created     : 25.01.2011
//------------------------------------------------------------------------------
//:head-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// Description     : BRC MCS test
//============================================================================ 
// Important Notes : 
//============================================================================ 

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "gtm.h"
#include "gtm_device_cfg.h"
#include "functions.h"
#include "platform.h"
#include "testcase_control_variables.h"


#define MAX_MCS_INSTANCES_BRC_MCS MCS_INSTANCES
using namespace std;

extern testcase_ctrl_type testcase_ctrl;
extern int (*test_function)(char* variant);
extern int (*test_init_function)(void);
extern char testcase_rptline[100];


//============================================================================ 
// MCS program 
//============================================================================ 

#include "brc_mcs_MCS0_RAM.h"
#include "brc_mcs_label.h"

//============================================================================ 
// original testcase (single execution)
//============================================================================ 

int brc_mcs_test_single(int i) {

  unsigned n, val,x;
  gtm_ptr ptr;
  
  activate_gtm_reset();

#if MCS_ARCH == 1
  MCS_CTRL(i) = 0x1;
#else
  MCS_CTRL_STAT(i) = 0x1;
#endif
  
  // CMU configuration structure
  tCmu_param theCmuConfig;
  theCmuConfig.gclk_num = GCLK_NUM_BASE * testcase_ctrl.glb_clk_div;		// define 100 MHz clock
  theCmuConfig.gclk_den = GCLK_DEN_BASE ;
  theCmuConfig.clk_0	= 0;			// define 100 MHz clock
  theCmuConfig.clk_1	= 0;			// define 100 MHz clock
  theCmuConfig.clk_2	= 0;			// define 100 MHz clock
  theCmuConfig.clk_3	= 0;			
  theCmuConfig.clk_4	= 0;			
  theCmuConfig.clk_5	= 0;			
  theCmuConfig.clk_6	= 0;			
  theCmuConfig.clk_7	= 0;			
 
  // setup TBU channel 0
  TBU_CH0_CTRL = 0x0;	// no LOW_RES, choose CMU_CLK0
  // setup TBU channel 1
  TBU_CH1_CTRL = 0x0;	// no LOW_RES, choose CMU_CLK0
  // setup TBU channel 2
  TBU_CH2_CTRL = 0x0;	// no LOW_RES, choose CMU_CLK0
  val = TBU_CHEN;
  
  // enable tbu 0
  TBU_CHEN = 0x2A;


  if(DEBUG_MESSAGES) RPT_PRINT << "===========================" << testcase_ctrl.loop_index << "=============================" << endl;
  testcase_init_cmu(theCmuConfig, 0x2);	// configure  CMU and enable

  // while ( TBU_CH0_BASE < testcase_ctrl.loop_index );

  //start_testcase_runtime_measurement(testcase_ctrl.bridge_mode);
  
  if(DEBUG_MESSAGES) RPT_PRINT << "Initializing BRC module." << endl;

  BRC_SRC_0_DEST = 0x0;
  BRC_SRC_1_DEST = 0x0;
  BRC_SRC_2_DEST = 0x0;

  BRC_SRC_0_ADDR = 0x077 + i * 24;
  BRC_SRC_1_ADDR = 0x078 + i * 24;
  BRC_SRC_2_ADDR = 0x079 + i * 24;

  BRC_SRC_0_DEST = 0x1555;
  BRC_SRC_1_DEST = 0x2AAA;
  BRC_SRC_2_DEST = 0x001FC000;

  if(DEBUG_MESSAGES) RPT_PRINT << "Initializing MCS module." << endl;

#if MCS_ARCH == 1
  while(MCS_CTRL(i) & 0x10000) testcase_ctrl.wait_loop_cnt++;
#else
  while(MCS_CTRL_STAT(i) & 0x10000) testcase_ctrl.wait_loop_cnt++;
#endif

  MCS_CH_CTRL(i, 0) = 0x0;
  MCS_CH_CTRL(i, 1) = 0x0;
  MCS_CH_CTRL(i, 2) = 0x0;
  MCS_CH_PC(i, 0) = 0x0;
  MCS_CH_PC(i, 1) = 0x4;
  MCS_CH_PC(i, 2) = 0x8;
  MCS_CTRG(i) = 0xFF;
  for (x = 0; x < 3; x++ ) {
    for (n = 0; n < 8; n++ ) {
      MCS_CH_R(i, x, n) = 0x0;
    }
  }
  
  if(DEBUG_MESSAGES) RPT_PRINT << "Loading MCS program." << endl;
  
  ptr = &MCS_MEM(i);
  for(n = 0; n < SIZE_MCS0_RAM/4; n++) {
    ptr[n] = MCS0_RAM[n];
  }

  if(DEBUG_MESSAGES) RPT_PRINT << "Enabling MCS channels." << endl;
  MCS_CH_CTRL(i, 0) = 0x1;
  MCS_CH_CTRL(i, 1) = 0x1;
  MCS_CH_CTRL(i, 2) = 0x1;


  if(DEBUG_MESSAGES) RPT_PRINT << "Wait until MCS channels finished." << endl;
  while(MCS_STRG(i) != 0x7) testcase_ctrl.wait_loop_cnt++;
  
  if(DEBUG_MESSAGES) RPT_PRINT << "Check Results." << endl;
  
    for(x = 0; x < 8; x++) {
      val = MCS_CH_R(i, 0, x);
      if ( val != 0x12345 ) {
	if(DEBUG_MESSAGES) RPT_PRINT << "ERROR: unexpected value in MCSi_CH0_R" << x << "=" << val << endl;
	testcase_ctrl.error1[0 + i*3] |= (0x1 << x);
	testcase_ctrl.errors += 1;
      }
    }
    for(x = 0; x < 8; x++) {
      val = MCS_CH_R(i, 1, x);
      if ( val != 0x67890 ) {
	if(DEBUG_MESSAGES) RPT_PRINT << "ERROR: unexpected value in MCSi_CH1_R" << x << "=" << val << endl;
	testcase_ctrl.error1[1 + i*3] |= (0x1 << x);
	testcase_ctrl.errors += 1;
      }
    }
	
    for(x = 0; x < 8; x++) {
      val = MCS_CH_R(i, 2, x);
      if ( val != 0x54321 ) {
	if(DEBUG_MESSAGES) RPT_PRINT << "ERROR: unexpected value in MCSi_CH2_R" << x << "=" << val << endl;
	testcase_ctrl.error1[2 + i*3] |= (0x1 << x);
	testcase_ctrl.errors += 1;
      }
    }
	  
    if(DEBUG_MESSAGES) RPT_PRINT << "Done." << endl;
 
    testcase_ctrl.runtime += TBU_CH0_BASE;
    TBU_CHEN = 0x15;
    CMU_CLK_EN = 0x1;
    TBU_CH0_BASE = 0x0;

    return testcase_ctrl.errors;
}

int brc_mcs_test_all(char* variant) {
  unsigned int j;


  testcase_ctrl.errors = 0;
  testcase_ctrl.runtime = 0;
  for ( j=0; j< MAX_MCS_INSTANCES_BRC_MCS; j = j + 1) {
     brc_mcs_test_single(j);
  }   
  return testcase_ctrl.errors;
}


//============================================================================ 
// testcase initialization
//============================================================================ 

int brc_mcs_test_init() {
  unsigned int i,j;

  // control testcase environment
  testcase_ctrl.tbu_pre_runtime = 0x0;
  testcase_ctrl.tbu_post_runtime = 0x0;
  testcase_ctrl.glb_clk_div = 0x1;
  testcase_ctrl.mask_loop_cnt = 0;
  testcase_ctrl.loop_cnt = TESTCASE_LOOP_CNT;
  testcase_ctrl.tbu_runtime_limt= 0x02000 * MAX_MCS_INSTANCES_BRC_MCS ;

  for (i=0; i<ERROR_STACK_SIZE; i++){
    testcase_ctrl.error_stack[i] = 0xFFFFFFFF;
  }   
  for ( j=0; j< MAX_MCS_INSTANCES_BRC_MCS; j = j + 1) {
  for (i=0; i<3; i++){
    testcase_ctrl.error1[i+ j*3] = 0x0;
    testcase_ctrl.error0[i+ j*3] = 0x0;
  }   
  }   
  testcase_ctrl.error_stack_ptr = 0;


  return 0;
}

//============================================================================ 
// testcase reporting
//============================================================================ 

int brc_mcs_test_report() {
    int i,j;

  global_testcase_report();

  for ( j=0; j< MAX_MCS_INSTANCES_BRC_MCS; j = j + 1) {
  for ( i=0; i< 3; i = i + 1) {
    if (testcase_ctrl.error1[i+ j*3] != 0) {
      sprintf(testcase_rptline,"ERROR : MCS%d_CH%d : bad register value pattern: 0x%x\n",j,i,testcase_ctrl.error1[i+ j*3]);
      RPT_TC_PRINT(testcase_rptline);
    } 
  }
  }
  return 0;
}

//============================================================================ 
// testcase  function
//============================================================================ 

int brc_mcs_test() {

  if (BRC_INSTANCES == 0) {
    if(DEBUG_MESSAGES) RPT_PRINT << "Warning: no BRC instance available for this device" << endl;
    return testcase_ctrl.sum_errors;
  }
  // define Bridge mode
  testcase_ctrl.bridge_mode = ASYNC;

  char test_name[15] = "brc_mcs_test";
  testcase_ctrl.test_name       = test_name;
  test_init_function   = brc_mcs_test_init;
  test_function        = brc_mcs_test_all;
  testcase_ctrl.parameter       = NULL;

  loop_testcase();
  brc_mcs_test_report();
  return testcase_ctrl.sum_errors;
}
