//head:-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// $Id: fifo_mem_access.cpp,v 1.12 2013/04/17 08:02:52 aohler Exp $
//------------------------------------------------------------------------------
// NO WARRANTIES: TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER THE
// INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND CONTRIBUTORS, NOR ANY
// PERSON, EITHER EXPRESSLY OR IMPLICITLY, WARRANTS ANY ASPECT OF THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// INCLUDING ANY OUTPUT OR RESULTS OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO UNLESS AGREED TO IN WRITING.
// THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED
// THERETO IS BEING PROVIDED "AS IS", WITHOUT ANY WARRANTY OF ANY TYPE OR
// NATURE, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY
// WARRANTY THAT THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO IS FREE FROM DEFECTS.
//
// ASSUMPTION OF RISK: THE RISK OF ANY AND ALL LOSS, DAMAGE, OR UNSATISFACTORY
// PERFORMANCE OF THIS SPECIFICATION (RESPECTIVELY THE PRODUCTS MAKING USE OF
// IT IN PART OR AS A WHOLE), SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM
// RELATED THERETO RESTS WITH YOU AS THE USER. TO THE MAXIMUM EXTENT PERMITTED
// BY LAW, NEITHER THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND
// CONTRIBUTORS, NOR ANY PERSON EITHER EXPRESSLY OR IMPLICITLY, MAKES ANY
// REPRESENTATION OR WARRANTY REGARDING THE APPROPRIOATENESS OF THE USE, OUTPUT,
// OR RESULTS OF THE USE OF THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE
// AND/OR PROGRAM RELATED THERETO IN TERMS OF ITS CORRECTNESS, ACCURACY,
// RELIABILITY, BEING CURRENT OR OTHERWISE. NOR DO THEY HAVE ANY OBLIGATION TO
// CORRECT ERRORS, MAKE CHANGES, SUPPORT THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, DISTRIBUTE UPDATES, OR PROVIDE
// NOTIFICATION OF ANY ERROR OR DEFECT, KNOWN OR UNKNOWN. IF YOU RELY UPON THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// YOU DO SO AT YOUR OWN RISK, AND YOU ASSUME THE RESPONSIBILITY FOR THE
// RESULTS. SHOULD THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL LOSSES,
// INCLUDING, BUT NOT LIMITED TO, ANY NECESSARY SERVICING, REPAIR OR CORRECTION
// OF ANY PROPERTY INVOLVED TO THE MAXIMUM EXTEND PERMITTED BY LAW.
//
// DISCLAIMER: IN NO EVENT, UNLESS REQUIRED BY LAW OR AGREED TO IN WRITING,
// SHALL THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS OR ANY PERSON BE
// LIABLE FOR ANY LOSS, EXPENSE OR DAMAGE, OF ANY TYPE OR NATURE ARISING OUT OF
// THE USE OF, OR INABILITY TO USE THIS SPECIFICATION, SOFTWARE RELATED THERETO,
// CODE AND/OR PROGRAM RELATED THERETO, INCLUDING, BUT NOT LIMITED TO, CLAIMS,
// SUITS OR CAUSES OF ACTION INVOLVING ALLEGED INFRINGEMENT OF COPYRIGHTS,
// PATENTS, TRADEMARKS, TRADE SECRETS, OR UNFAIR COMPETITION.
//
// INDEMNIFICATION: TO THE MAXIMUM EXTEND PERMITTED BY LAW YOU AGREE TO
// INDEMNIFY AND HOLD HARMLESS THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT
// HOLDERS AND CONTRIBUTORS, AND EMPLOYEES, AND ANY PERSON FROM AND AGAINST ALL
// CLAIMS, LIABILITIES, LOSSES, CAUSES OF ACTION, DAMAGES, JUDGMENTS, AND
// EXPENSES, INCLUDING THE REASONABLE COST OF ATTORNEYS' FEES AND COURT COSTS,
// FOR INJURIES OR DAMAGES TO THE PERSON OR PROPERTY OF THIRD PARTIES,
// INCLUDING, WITHOUT LIMITATIONS, CONSEQUENTIAL, DIRECT AND INDIRECT DAMAGES
// AND ANY ECONOMIC LOSSES, THAT ARISE OUT OF OR IN CONNECTION WITH YOUR USE,
// MODIFICATION, OR DISTRIBUTION OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, ITS OUTPUT, OR ANY ACCOMPANYING
// DOCUMENTATION.
//
// GOVERNING LAW: THE RELATIONSHIP BETWEEN YOU AND ROBERT BOSCH GMBH SHALL BE
// GOVERNED SOLELY BY THE LAWS OF THE FEDERAL REPUBLIC OF GERMANY. THE
// STIPULATIONS OF INTERNATIONAL CONVENTIONS REGARDING THE INTERNATIONAL SALE OF
// GOODS SHALL NOT BE APPLICABLE. THE EXCLUSIVE LEGAL VENUE SHALL BE
// DUESSELDORF, GERMANY.
//
// MANDATORY LAW SHALL BE UNAFFECTED BY THE FOREGOING PARAGRAPHS.
//
// INTELLECTUAL PROPERTY OWNERS/COPYRIGHT OWNERS/CONTRIBUTORS: ROBERT BOSCH
// GMBH, ROBERT BOSCH PLATZ 1, 70839 GERLINGEN, GERMANY AND ITS LICENSORS.
//
// ALL RIGHTS RESERVED.
//------------------------------------------------------------------------------
// Project Name : GTM - Generic Timer Module
//------------------------------------------------------------------------------
// Copyright   : Robert Bosch GmbH, Gerlingen, Germany
// Department  : AE/EIY
// Created     : 25.01.2011
//------------------------------------------------------------------------------
//:head-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// Description     : FIFO memory access test
//============================================================================ 
// Important Notes : 
//============================================================================ 

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "gtm.h"
#include "gtm_device_cfg.h"

#include "functions.h"
#include "platform.h"
#include "testcase_control_variables.h"

using namespace std;

extern testcase_ctrl_type testcase_ctrl;
extern int (*test_function)(char* variant);
extern int (*test_init_function)(void);
extern char testcase_rptline[100];

int fifo_mem_access_single(char* variant) {

    gtm_ptr p;
    testcase_ctrl.errors = 0;
    const int N = 64;
    unsigned int data[N];
    int i;

    //---------------------------------------------------------------------------
    // PSM 0:
    int errorPos = 0;

    // global reset:
    testcase_ctrl.runtime     = 0;
    start_testcase_runtime_measurement(testcase_ctrl.bridge_mode);

    //  prepare test data set
    for (i = 0; i < N; i++ ) {
        data[i] = rand() & 0x00FFFFFF;
        if(DEBUG_MESSAGES) RPT_PRINT << "data[" << i << "]=" << data[i] << endl;
    }

    if (PSM_INSTANCES > 0) {
      if(DEBUG_MESSAGES) RPT_PRINT << "configure ARU" << endl;
      // configure FIFO-ARU chain
      F2A0_CH0_ARU_RD_FIFO = 0x0000;
      F2A0_CH1_ARU_RD_FIFO = 0x0051;  
      F2A0_CH0_STR_CFG = 0x40000;
      F2A0_CH1_STR_CFG = 0x00101;
      F2A0_ENABLE = 0x000000A;

      // populate FIFO 0 using AFD
      if(DEBUG_MESSAGES) RPT_PRINT << "populate FIFO0 CH0 using AFD" << endl;
      for (i = 0; i < N; i++ ) {
          AFD0_CH0_BUF_ACC = data[i];
      }   

      // wait until FIFO is filled
      if(DEBUG_MESSAGES) RPT_PRINT << "wait until FIFO is filled" << endl;
	  while ( FIFO0_CH1_FILL_LEVEL < N ) testcase_ctrl.wait_loop_cnt++;

      // initialize pointer with FIFO memory address
      p = &FIFO0_MEMORY; 
      p = p + FIFO0_CH1_START_ADDR;   
      if(DEBUG_MESSAGES) RPT_PRINT << "read back data directly from destination memory" << endl;
	  // read back data directly from destination memory
	  for (i = 0; i < N; i++ ) {
		  if ( p[i] != data[i] ) {
              if(DEBUG_MESSAGES) RPT_PRINT << "data mismatch on FIFO0 CH1 data[" << i << "]:" << "expected : " << data[i] << " read  : " << p[i] << endl;
			  testcase_ctrl.status[errorPos] += 1;
		  }
      }
    } else {
       if(DEBUG_MESSAGES) RPT_PRINT << "Info: NO PSM resources included in this device !" << endl;
    }
    testcase_ctrl.errors += testcase_ctrl.status[errorPos];
    errorPos++;
    testcase_ctrl.status_ptr = errorPos;
 
    testcase_ctrl.runtime     = TBU_CH0_BASE;

    // PSM 0
    //---------------------------------------------------------------------------

	if (PSM_INSTANCES < 2) {
	  if(DEBUG_MESSAGES) RPT_PRINT << "Test finished : ";
	  if (testcase_ctrl.errors != 0) {
	    if(DEBUG_MESSAGES) RPT_PRINT << testcase_ctrl.errors << " error(s) detected during test" << endl;
	  } else {
	    if(DEBUG_MESSAGES) RPT_PRINT << " no errors" << endl;
	  }
	  return testcase_ctrl.errors;
	}
    //---------------------------------------------------------------------------
    // PSM 1:

    //  prepare test data set
    for (i = 0; i < N; i++ ) {
        data[i] = rand() & 0x00FFFFFF;
        if(DEBUG_MESSAGES) RPT_PRINT << "data[" << i << "]=" << data[i] << endl;
    }

    if(DEBUG_MESSAGES) RPT_PRINT << "configure ARU" << endl;
    // configure FIFO-ARU chain
    F2A1_CH0_ARU_RD_FIFO = 0x0000;
    F2A1_CH1_ARU_RD_FIFO = 0x0051;  
    F2A1_CH0_STR_CFG = 0x40000;
    F2A1_CH1_STR_CFG = 0x00101;
    F2A1_ENABLE = 0x000000A;

    // populate FIFO 0 using AFD
    if(DEBUG_MESSAGES) RPT_PRINT << "populate FIFO1 CH0 using AFD" << endl;
    for (i = 0; i < N; i++ ) {
        AFD1_CH0_BUF_ACC = data[i];
    }   

    // wait until FIFO is filled
    if(DEBUG_MESSAGES) RPT_PRINT << "wait until FIFO is filled" << endl;
	while ( FIFO1_CH1_FILL_LEVEL < N ) testcase_ctrl.wait_loop_cnt++;
    
    // initialize pointer with FIFO memory address
    p = &FIFO1_MEMORY; 
    p = p + FIFO1_CH1_START_ADDR;   

    if(DEBUG_MESSAGES) RPT_PRINT << "read back data directly from destination memory" << endl;
	// read back data directly from destination memory
	for (i = 0; i < N; i++ ) {
		if ( p[i] != data[i] ) {
            if(DEBUG_MESSAGES) RPT_PRINT << "data mismatch on FIFO0 CH1 data[" << i << "]:" << "expected : " << data[i] << " read  : " << p[i] << endl;
			testcase_ctrl.status[errorPos] += 1;
		}
    }

    // PSM 1
    //---------------------------------------------------------------------------
    testcase_ctrl.errors += testcase_ctrl.status[errorPos];
    errorPos++;

    testcase_ctrl.status_ptr = errorPos;
 
    testcase_ctrl.runtime     = TBU_CH0_BASE;
    
    if(DEBUG_MESSAGES) RPT_PRINT << "Test finished : ";
    if (testcase_ctrl.errors != 0) {
      if(DEBUG_MESSAGES) RPT_PRINT << testcase_ctrl.errors << " error(s) detected during test" << endl;
    }
    else {
      if(DEBUG_MESSAGES) RPT_PRINT << " no errors" << endl;
    }
    return testcase_ctrl.errors;
}

int fifo_mem_access_init() {
    int i;

  // control testcase environment
  testcase_ctrl.tbu_pre_runtime = 0x0;
  testcase_ctrl.tbu_post_runtime = 0x0;
  testcase_ctrl.glb_clk_div = 0x1;
  testcase_ctrl.tbu_runtime_limt= 0x03600 ;
  testcase_ctrl.mask_loop_cnt = 0;
  testcase_ctrl.loop_cnt = TESTCASE_LOOP_CNT;

  for (i=0; i<ERROR_STACK_SIZE; i++){
    testcase_ctrl.error_stack[i] = 0xFFFFFFFF;
  }   
  for (i=0; i<100; i++){
    testcase_ctrl.status[i] = 0x0;
  }   
  testcase_ctrl.error_stack_ptr = 0;
  testcase_ctrl.status_ptr = 0;

  return 0; 
}

int fifo_mem_access_report() {
  unsigned int i;

  global_testcase_report();

  for ( i=0; i< testcase_ctrl.status_ptr; i = i + 1) {
   if (testcase_ctrl.status[i] != 0) {
      sprintf(testcase_rptline,"ERROR : Check PSM%d : errors: 0x%d\n",i,testcase_ctrl.status[i]);
      RPT_TC_PRINT(testcase_rptline);
   } 
  }
  
  return 0; 
}

int fifo_mem_access() {
  
  // define Bridge mode
  testcase_ctrl.bridge_mode = ASYNC;

  char test_name[20] = "fifo_mem_access";
  testcase_ctrl.test_name       = test_name;
  test_init_function   = fifo_mem_access_init;
  test_function        = fifo_mem_access_single;
  testcase_ctrl.parameter       = NULL;
  loop_testcase();
  fifo_mem_access_report();
  return testcase_ctrl.sum_errors;
}
