//head:-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// $Id: functions.cpp,v 1.28 2013/03/01 13:16:46 rub1rt Exp $
//------------------------------------------------------------------------------
// NO WARRANTIES: TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER THE
// INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND CONTRIBUTORS, NOR ANY
// PERSON, EITHER EXPRESSLY OR IMPLICITLY, WARRANTS ANY ASPECT OF THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// INCLUDING ANY OUTPUT OR RESULTS OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO UNLESS AGREED TO IN WRITING.
// THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED
// THERETO IS BEING PROVIDED "AS IS", WITHOUT ANY WARRANTY OF ANY TYPE OR
// NATURE, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY
// WARRANTY THAT THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO IS FREE FROM DEFECTS.
//
// ASSUMPTION OF RISK: THE RISK OF ANY AND ALL LOSS, DAMAGE, OR UNSATISFACTORY
// PERFORMANCE OF THIS SPECIFICATION (RESPECTIVELY THE PRODUCTS MAKING USE OF
// IT IN PART OR AS A WHOLE), SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM
// RELATED THERETO RESTS WITH YOU AS THE USER. TO THE MAXIMUM EXTENT PERMITTED
// BY LAW, NEITHER THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND
// CONTRIBUTORS, NOR ANY PERSON EITHER EXPRESSLY OR IMPLICITLY, MAKES ANY
// REPRESENTATION OR WARRANTY REGARDING THE APPROPRIOATENESS OF THE USE, OUTPUT,
// OR RESULTS OF THE USE OF THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE
// AND/OR PROGRAM RELATED THERETO IN TERMS OF ITS CORRECTNESS, ACCURACY,
// RELIABILITY, BEING CURRENT OR OTHERWISE. NOR DO THEY HAVE ANY OBLIGATION TO
// CORRECT ERRORS, MAKE CHANGES, SUPPORT THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, DISTRIBUTE UPDATES, OR PROVIDE
// NOTIFICATION OF ANY ERROR OR DEFECT, KNOWN OR UNKNOWN. IF YOU RELY UPON THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// YOU DO SO AT YOUR OWN RISK, AND YOU ASSUME THE RESPONSIBILITY FOR THE
// RESULTS. SHOULD THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL LOSSES,
// INCLUDING, BUT NOT LIMITED TO, ANY NECESSARY SERVICING, REPAIR OR CORRECTION
// OF ANY PROPERTY INVOLVED TO THE MAXIMUM EXTEND PERMITTED BY LAW.
//
// DISCLAIMER: IN NO EVENT, UNLESS REQUIRED BY LAW OR AGREED TO IN WRITING,
// SHALL THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS OR ANY PERSON BE
// LIABLE FOR ANY LOSS, EXPENSE OR DAMAGE, OF ANY TYPE OR NATURE ARISING OUT OF
// THE USE OF, OR INABILITY TO USE THIS SPECIFICATION, SOFTWARE RELATED THERETO,
// CODE AND/OR PROGRAM RELATED THERETO, INCLUDING, BUT NOT LIMITED TO, CLAIMS,
// SUITS OR CAUSES OF ACTION INVOLVING ALLEGED INFRINGEMENT OF COPYRIGHTS,
// PATENTS, TRADEMARKS, TRADE SECRETS, OR UNFAIR COMPETITION.
//
// INDEMNIFICATION: TO THE MAXIMUM EXTEND PERMITTED BY LAW YOU AGREE TO
// INDEMNIFY AND HOLD HARMLESS THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT
// HOLDERS AND CONTRIBUTORS, AND EMPLOYEES, AND ANY PERSON FROM AND AGAINST ALL
// CLAIMS, LIABILITIES, LOSSES, CAUSES OF ACTION, DAMAGES, JUDGMENTS, AND
// EXPENSES, INCLUDING THE REASONABLE COST OF ATTORNEYS' FEES AND COURT COSTS,
// FOR INJURIES OR DAMAGES TO THE PERSON OR PROPERTY OF THIRD PARTIES,
// INCLUDING, WITHOUT LIMITATIONS, CONSEQUENTIAL, DIRECT AND INDIRECT DAMAGES
// AND ANY ECONOMIC LOSSES, THAT ARISE OUT OF OR IN CONNECTION WITH YOUR USE,
// MODIFICATION, OR DISTRIBUTION OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, ITS OUTPUT, OR ANY ACCOMPANYING
// DOCUMENTATION.
//
// GOVERNING LAW: THE RELATIONSHIP BETWEEN YOU AND ROBERT BOSCH GMBH SHALL BE
// GOVERNED SOLELY BY THE LAWS OF THE FEDERAL REPUBLIC OF GERMANY. THE
// STIPULATIONS OF INTERNATIONAL CONVENTIONS REGARDING THE INTERNATIONAL SALE OF
// GOODS SHALL NOT BE APPLICABLE. THE EXCLUSIVE LEGAL VENUE SHALL BE
// DUESSELDORF, GERMANY.
//
// MANDATORY LAW SHALL BE UNAFFECTED BY THE FOREGOING PARAGRAPHS.
//
// INTELLECTUAL PROPERTY OWNERS/COPYRIGHT OWNERS/CONTRIBUTORS: ROBERT BOSCH
// GMBH, ROBERT BOSCH PLATZ 1, 70839 GERLINGEN, GERMANY AND ITS LICENSORS.
//
// ALL RIGHTS RESERVED.
//------------------------------------------------------------------------------
// Project Name : GTM - Generic Timer Module
//------------------------------------------------------------------------------
// Copyright   : Robert Bosch GmbH, Gerlingen, Germany
// Department  : AE/EIY
// Created     : 13.05.2011
//------------------------------------------------------------------------------
//:head-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// Description     : helper functions
//============================================================================ 
// Important Notes : 
//============================================================================ 
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "gtm.h"
#include "gtm_device_cfg.h"

#include "platform.h"
#include "functions.h"
#include "loopback.h"
#include "testcase_control_variables.h"
#include "signature24_label.h"

using namespace std;

extern testcase_ctrl_type testcase_ctrl;
extern int (*test_function)(char* variant);
extern int (*test_init_function)(void);
extern char testcase_rptline[100];

int get_device() {
  int device;
  device = GTM_REV;
  device = (device & 0xFFF00000) >> 20;
  return device;
}

void wait_until (gtm_ptr reg, int exp) {
  int status;
  int i = 0;
  RPT_PRINT << "start waiting ...";
  do {
    testcase_ctrl.wait_loop_cnt++;
    status = *reg;
    i += 1;
    if (i == 10) {
      RPT_PRINT << ".";
      i=0;
    }
  }
  while (status != exp);
  RPT_PRINT << "." << endl;
}

int check(int val, int exp, STR_TYPE STR_TYPE_NAME) {
  if (val != exp) {
    RPT_PRINT << "ERROR reading " << name << " : read 0x" << hex << val << ", expected 0x" << hex << exp << endl;
    return 1;
  } else {
    return 0;
  }
}

int checkm(int val, int exp, int mask, STR_TYPE STR_TYPE_NAME) {
  if ((val&mask) != exp) {
    RPT_PRINT << "ERROR reading " << name << " : read 0x" << hex << val << ", expected 0x" << hex << exp << endl;
    return 1;
  } else {
    return 0;
  }
}

int checkr(int val, int exp, STR_TYPE STR_TYPE_NAME, int range) {
  int max = exp+range;
  int min = exp-range;
  if (val > max) {
    RPT_PRINT << "ERROR reading " << name << " : read 0x" << hex << val << ", expected less 0x" << hex << max << endl;
    return 1;
  } else {
    if (val < min) {
      RPT_PRINT << "ERROR reading " << name << " : read 0x" << hex << val << ", expected greater 0x" << hex << min << endl;
      return 1;
    } else {
      return 0;
    }
  }
}

int checkmr(int val, int exp, int mask, STR_TYPE STR_TYPE_NAME, int range) {
  int max = exp+range;
  int min = exp-range;
  if ((val&mask) > max) {
    RPT_PRINT << "ERROR reading " << name << " : read " << hex << val << ", expected less " << hex << max << endl;
    return 1;
  } else {
    if ((val&mask) < min) {
      RPT_PRINT << "ERROR reading " << name << " : read " << hex << val << ", expected greater " << hex << min << endl;
      return 1;
    } else {
      return 0;
    }
  }
}

// Converts sint24 representation into int (signed)
int sint24tolong(unsigned int sint24) {
  int slong = sint24 & 0x7FFFFF;
  if(sint24 & 0x800000){
    slong = 0xFF800000 | slong;
  }
  return slong;
}

//------------------------------------------------------------------------------
// MCS Submodule setup for trigger event logging
//------------------------------------------------------------------------------

void signature24_init_mcs() {

#include "signature24_MCS0_RAM.h"

  // wait until MCS RAM initialized
#if MCS_ARCH == 1
  while ( MCS_CTRL(0) & 0x10000 ) testcase_ctrl.wait_loop_cnt++;
#else
  while ( MCS_CTRL_STAT(0) & 0x10000 ) testcase_ctrl.wait_loop_cnt++;
#endif

  // load MCS code to RAM
  int i;
  gtm_ptr p_mem = &MCS_MEM(0);  // initialize memory pointer with target instance
  for (i=0; i<(SIZE_MCS0_RAM/4); i++) {
    p_mem[i] = MCS0_RAM[i];        // store value to MCS RAM
  }
  // run MCS channel 0
  MCS0_CH0_CTRL = 0x1;

}

//------------------------------------------------------------------------------
// MCS signature log 
//------------------------------------------------------------------------------

void signature24_log() {

//  unsigned int i, val;

   if( MCS_CH_R(0, 0, 6) == 0x1) {
    //    RPT_PRINT << endl;
	MCS_STRG(0) = 0x02;
	if(( MCS_STRG(0) & 0x1) == 0x0) {
	  if(DEBUG_MESSAGES_MCSSIGNATURE_LOG) RPT_PRINT << " gtmhalt cnt: " << hex << testcase_ctrl.gtm_halt_cnt << endl;
	  if(DEBUG_MESSAGES_MCSSIGNATURE_LOG) RPT_PRINT << " ARU_L sig: " << hex << MCS_CH_R(0, 0, 1) << " val: " << hex << MCS_CH_R(0, 0, 0) << endl;
	  if(DEBUG_MESSAGES_MCSSIGNATURE_LOG) RPT_PRINT << " ARU_H sig: " << hex << MCS_CH_R(0, 0, 3) << " val: " << hex << MCS_CH_R(0, 0, 2) << endl;
	  if(DEBUG_MESSAGES_MCSSIGNATURE_LOG) RPT_PRINT << " ACB sig  : "   << hex << MCS_CH_R(0, 0, 5) << " val: " << hex << MCS_CH_R(0, 0, 4) << endl;
	  testcase_ctrl.status2[1] = MCS_CH_R(0, 0, 0);
	  testcase_ctrl.status2[2] = MCS_CH_R(0, 0, 2);
	  testcase_ctrl.status2[3] = MCS_CH_R(0, 0, 4);
	  MCS_CH_R(0, 0, 6) = 0x0;
	  if ( MCS_CH_R(0, 0, 6) == 0x1) {
             testcase_ctrl.errors++;
            if(DEBUG_MESSAGES_MCSSIGNATURE) RPT_PRINT << "ERROR: cound not reset R6:  " << hex << MCS_CH_R(0, 0, 6) << endl;
	  }
	}
	MCS_CTRG(0) = 0x02;
  }

}
//------------------------------------------------------------------------------
// MCS wait until next signature ready
//------------------------------------------------------------------------------

void wait_for_signature24() {

   while ( MCS_CH_R(0, 0, 6) != 0x1) {
      testcase_ctrl.wait_loop_cnt++;
   }

}

//------------------------------------------------------------------------------
// MCS signature compare 
//------------------------------------------------------------------------------

void signature24_compare(unsigned sigl, unsigned sigh, unsigned sigacb,const char* str) {

        gtm_ptr p_mem = &MCS_MEM(0);  // initialize memory pointer with target instance
	
	  if(DEBUG_MESSAGES_MCSSIGNATURE_LOG) RPT_PRINT << " ARU_L sig: " << hex << MCS_CH_R(0, 0, 1) << " val: " << hex << MCS_CH_R(0, 0, 0) << endl;
	  if(DEBUG_MESSAGES_MCSSIGNATURE_LOG) RPT_PRINT << " ARU_H sig: " << hex << MCS_CH_R(0, 0, 3) << " val: " << hex << MCS_CH_R(0, 0, 2) << endl;
	  if(DEBUG_MESSAGES_MCSSIGNATURE_LOG) RPT_PRINT << " ACB sig  : "   << hex << MCS_CH_R(0, 0, 5) << " val: " << hex << MCS_CH_R(0, 0, 4) << endl;

	MCS_STRG(0) = 0x02;
	if(( MCS_STRG(0) & 0x1) == 0x0) {
	  testcase_ctrl.status[0] = MCS_CH_R(0, 0, 1);
	  testcase_ctrl.status2[1] = MCS_CH_R(0, 0, 0);
	  if (sigl != testcase_ctrl.status[0]) {
             testcase_ctrl.errors++;
	    if(DEBUG_MESSAGES_MCSSIGNATURE) RPT_PRINT << "ERROR: " << str << " ARU_L signature mismatch    0x" << hex << testcase_ctrl.status[0] << " ref: 0x" << hex << sigl << endl;
	  }
	  testcase_ctrl.status[1] = MCS_CH_R(0, 0, 3);
	  testcase_ctrl.status2[2] = MCS_CH_R(0, 0, 2);
	  if (sigh != testcase_ctrl.status[1]) {
             testcase_ctrl.errors++;
	    if(DEBUG_MESSAGES_MCSSIGNATURE) RPT_PRINT << "ERROR: " << str << " ARU_H signature mismatch    0x" << hex << testcase_ctrl.status[1] << " ref: 0x" << hex << sigh << endl;
	  }
	  testcase_ctrl.status[2] = MCS_CH_R(0, 0, 5);
	  testcase_ctrl.status2[3] = MCS_CH_R(0, 0, 4);
	  if (sigacb != testcase_ctrl.status[2]) {
             testcase_ctrl.errors++;
	    if(DEBUG_MESSAGES_MCSSIGNATURE) RPT_PRINT << "ERROR: " << str << " ARU_ACB signature mismatch  0x" << hex << testcase_ctrl.status[2] << " ref: 0x" << hex << sigacb << endl;
	  }
	  MCS_CH_R(0, 0, 6) = 0x0;
	}
	MCS_CTRG(0) = 0x02;

}
//------------------------------------------------------------------------------
// MCS signature history 
//------------------------------------------------------------------------------

void signature24_history(unsigned start_i,unsigned amount_i) {
  unsigned int i;
  unsigned int start, end;
  gtm_ptr p_mem = &MCS_MEM(0);  // initialize memory pointer with target instance
  unsigned  int v0,v1;
  // decrement 400 due to array start is assigned to Ram address 100
  end = ((p_mem[LABEL_MCS0_RAM_MEM]  - 400) >> 5) - 1;
  start = 0;
  if (end < start_i + amount_i) {
    start_i = end - amount_i;
  } else {
    end = start_i + amount_i;
  }
  if (start_i < 0) {
    start = 0;
  } else {
    start = start_i;
  }
  RPT_TC_PRINT("\n");
  for (i= (start << 3); i <= (end << 3) ; i = i + 8 ) {
    v0 = p_mem[100 + i];
    sprintf(testcase_rptline,"%d tbu beg:  0x%x \n",(i >> 3),v0);
    RPT_TC_PRINT(testcase_rptline);
    v0 = p_mem[101 + i];
    v1 = p_mem[102 + i];
    sprintf(testcase_rptline,"%d ARU_L: val 0x%x  sig: 0x%x\n",(i >> 3),v0,v1 );
     //RPT_PRINT << dec << (i >> 3) << " ARU_L: val 0x" << hex << p_mem[101 + i] << " sig: 0x" << hex <<  p_mem[102 + i]  << endl;
    RPT_TC_PRINT(testcase_rptline);
    v0 = p_mem[103 + i];
    v1 = p_mem[104 + i];
    sprintf(testcase_rptline,"%d ARU_H: val 0x%x  sig: 0x%x\n",(i >> 3),v0,v1 );
     //RPT_PRINT << dec << (i >> 3) << " ARU_H: val 0x" << hex << p_mem[103 + i] << " sig: 0x" << hex <<  p_mem[104 + i]  << endl;
    RPT_TC_PRINT(testcase_rptline);
    v0 = p_mem[105 + i];
    v1 = p_mem[106 + i];
    sprintf(testcase_rptline,"%d ARU_ACB: val 0x%x  sig: 0x%x\n",(i >> 3),v0,v1 );
     //RPT_PRINT << dec << (i >> 3) << " ARU_ACB: val 0x" << hex << p_mem[105 + i] << " sig: 0x" << hex <<  p_mem[106 + i]  << endl;
    RPT_TC_PRINT(testcase_rptline);
    v0 = p_mem[107 + i];
    sprintf(testcase_rptline,"%d tbu end:  0x%x \n",(i >> 3),v0);
     //RPT_PRINT << dec << (i >> 3) << " tbu end:  0x" << hex << p_mem[107 + i]  << endl;
    RPT_TC_PRINT(testcase_rptline);
   }
  RPT_TC_PRINT("\n");

}
//------------------------------------------------------------------------------
// gtmhalt cnt compare
//------------------------------------------------------------------------------

void gtmhalt_cnt_compare(unsigned sigl, const char* str) {

	  testcase_ctrl.status[3] = testcase_ctrl.gtm_halt_cnt;
	  if (sigl != testcase_ctrl.gtm_halt_cnt) {
             testcase_ctrl.errors++;
	    if(DEBUG_MESSAGES_MCSSIGNATURE) RPT_PRINT << "ERROR: " << str << " gtmhalt count mismatch    0x" << hex << testcase_ctrl.status[3] << " ref: 0x" << hex << sigl << endl;
	  }

}
//------------------------------------------------------------------------------
// MCS signature init 
//------------------------------------------------------------------------------

void signature24_init(unsigned sigl, unsigned sigh, unsigned sigacb) {

  unsigned int done;

    done = 1;
    //    RPT_PRINT << endl;
    MCS_STRG(0) = 0x02;
    while (done == 1) {
        testcase_ctrl.wait_loop_cnt++;
	if(( MCS_STRG(0) & 0x1) == 0x0) {
	  MCS_CH_R(0, 0, 1) = sigl ;
	  MCS_CH_R(0, 0, 3) = sigh ;
	  MCS_CH_R(0, 0, 5) = sigacb ;
          done = 0;
	}
    }
     MCS_CTRG(0) = 0x02;

}

//------------------------------------------------------------------------------
// wait some time unit is 1 us
//------------------------------------------------------------------------------
void wait_until_tbu_value(unsigned int val)
{
   if ( val != 0 ) {
        // GTM reset
	GTM_CTRL = 0;
	GTM_RST = 1;

	TBU_CH1_CTRL = 0x2;	// no LOW_RES, choose CMU_CLK1

	// setup global clock divider
	CMU_GCLK_NUM 	= GCLK_NUM_BASE * testcase_ctrl.glb_clk_div;		// define 100 MHz clock
	CMU_GCLK_DEN 	= GCLK_DEN_BASE;

	// setup the CMU_CLKx prescalers
	int tbu1_clk_div = 100;
	CMU_CLK_1_CTRL	= tbu1_clk_div - 1;              // define 1 MHz clock

	// enable the clock prescalers
	CMU_CLK_EN		= 0x8;

	// enable tbu 1
        TBU_CHEN = 0x8;
	
        if(DEBUG_MESSAGES_WAIT_TBU) RPT_PRINT << "Wait until TBU1 value: 0x" << hex << val << " tbu0/tbu1 divider : " << dec << tbu1_clk_div << endl;
        while(TBU_CH1_BASE < val ) testcase_ctrl.wait_loop_cnt++;

	GTM_CTRL = 0;
	GTM_RST = 1;
  }
}
//------------------------------------------------------------------------------
// function to serve the looping of single tests
//------------------------------------------------------------------------------
int loop_testcase() {
  unsigned int val = 0;
  unsigned int i = 0;
  unsigned int status = 0;
  
  
  // setup GTM clocking synchronous/asynchronous
  gtm_clk_ctrl(testcase_ctrl.bridge_mode);
  
  // control testcase environment
  test_init_function();

  // initialize output variables
  testcase_ctrl.sum_errors = 0;
  testcase_ctrl.min_errors = 0xFFFFFFFF;
  testcase_ctrl.max_errors = 0;
  testcase_ctrl.sum_runtime = 0;
  testcase_ctrl.min_runtime = 0xFFFFFFFF;
  testcase_ctrl.max_runtime = 0;
  testcase_ctrl.wait_loop_cnt = 0;
  

  for (i=0; i< (testcase_ctrl.loop_cnt + testcase_ctrl.mask_loop_cnt); i++){   
    testcase_ctrl.loop_index = i;
    //RPT_PRINT << "Amount of test loops: 0x" << hex << testcase_ctrl.loop_cnt << "(0x" << hex << (i+1) << ")" << endl;
    wait_until_tbu_value(testcase_ctrl.tbu_pre_runtime);
//    if (strcmp(testcase_ctrl.parameter, "") == 0){
    //if (testcase_ctrl.parameter == NULL){
    //  status = test_function(); 
    //} else {
     status = test_function(testcase_ctrl.parameter); 
    //}
    wait_until_tbu_value(testcase_ctrl.tbu_post_runtime);
    if (i >= testcase_ctrl.mask_loop_cnt ) {
        if ( testcase_ctrl.runtime > testcase_ctrl.tbu_runtime_limt ) { 
           testcase_ctrl.errors++;
        }
	testcase_ctrl.sum_runtime += testcase_ctrl.runtime;
	if (testcase_ctrl.runtime > testcase_ctrl.max_runtime) testcase_ctrl.max_runtime=testcase_ctrl.runtime;
	if (testcase_ctrl.runtime < testcase_ctrl.min_runtime) testcase_ctrl.min_runtime=testcase_ctrl.runtime;

	testcase_ctrl.sum_errors += testcase_ctrl.errors;
	if (testcase_ctrl.errors > testcase_ctrl.max_errors) testcase_ctrl.max_errors=testcase_ctrl.errors;
	if (testcase_ctrl.errors < testcase_ctrl.min_errors) testcase_ctrl.min_errors=testcase_ctrl.errors;
	
        if (testcase_ctrl.error_stack_ptr < ERROR_STACK_SIZE && testcase_ctrl.errors != 0) {
            testcase_ctrl.error_stack[testcase_ctrl.error_stack_ptr] = i - testcase_ctrl.mask_loop_cnt;
            testcase_ctrl.errorcnt_stack[testcase_ctrl.error_stack_ptr] = testcase_ctrl.errors;
            testcase_ctrl.error_stack_ptr++;
	}
    } 
  }
  testcase_ctrl.aver_errors = testcase_ctrl.sum_errors / (testcase_ctrl.loop_cnt );
  testcase_ctrl.aver_runtime = (unsigned int)testcase_ctrl.sum_runtime / (testcase_ctrl.loop_cnt );
	


  return testcase_ctrl.sum_errors;
}

//------------------------------------------------------------------------------
// function to do global testcase reporting
//------------------------------------------------------------------------------
void global_testcase_report() {
  unsigned int i;
  unsigned int val = GTM_REV;
  sprintf(testcase_rptline,"Tested device: 0x%x\n\n",val);
  RPT_TC_PRINT(testcase_rptline);
  sprintf(testcase_rptline,"Executed test: %s\n\n",testcase_ctrl.test_name);
  RPT_TC_PRINT(testcase_rptline);
  sprintf(testcase_rptline,"Global GTM clock divider: 0x%x\n",testcase_ctrl.glb_clk_div);
  RPT_TC_PRINT(testcase_rptline);
  sprintf(testcase_rptline,"CMU_GCLK_NUM base: %d\n",GCLK_NUM_BASE);
  RPT_TC_PRINT(testcase_rptline);
  sprintf(testcase_rptline,"CMU_GCLK_DEN base: %d\n\n",GCLK_DEN_BASE);
  RPT_TC_PRINT(testcase_rptline);

  sprintf(testcase_rptline,"Amount of masked loops: 0x%x\n",testcase_ctrl.mask_loop_cnt);
  RPT_TC_PRINT(testcase_rptline);
  
  sprintf(testcase_rptline,"Amount of test loops  : 0x%x\n",testcase_ctrl.loop_cnt);
  RPT_TC_PRINT(testcase_rptline);

  sprintf(testcase_rptline,"Min     run time: 0x%x\n",testcase_ctrl.min_runtime);
  RPT_TC_PRINT(testcase_rptline);

  sprintf(testcase_rptline,"Average run time: 0x%x\n",testcase_ctrl.aver_runtime);
  RPT_TC_PRINT(testcase_rptline);

  sprintf(testcase_rptline,"Max     run time: 0x%x\n",testcase_ctrl.max_runtime);
  RPT_TC_PRINT(testcase_rptline);

  sprintf(testcase_rptline,"GTM accesses in wait loops: %d\n",testcase_ctrl.wait_loop_cnt);
  RPT_TC_PRINT(testcase_rptline);

  RPT_TC_PRINT("\n");


  if (testcase_ctrl.sum_errors != 0) {
    RPT_TC_PRINT("\n");

    sprintf(testcase_rptline,"%d error(s) detected during test\n", testcase_ctrl.sum_errors);
    RPT_TC_PRINT(testcase_rptline);

    sprintf(testcase_rptline,"Min     errors: 0x%x\n", testcase_ctrl.min_errors);
    RPT_TC_PRINT(testcase_rptline);
    
    sprintf(testcase_rptline,"Average errors: 0x%x\n", testcase_ctrl.aver_errors);
    RPT_TC_PRINT(testcase_rptline);
    
    sprintf(testcase_rptline,"Max     errors: 0x%x\n", testcase_ctrl.max_errors);
    RPT_TC_PRINT(testcase_rptline);
    
    RPT_TC_PRINT("\n");
    for (i=0; i<testcase_ctrl.error_stack_ptr; i++){  
      sprintf(testcase_rptline,"%d ERROR(s) in iteration: %d\n",  testcase_ctrl.errorcnt_stack[i],testcase_ctrl.error_stack[i]);
      RPT_TC_PRINT(testcase_rptline);
    }

    RPT_TC_PRINT("\n");
    RPT_TC_PRINT("details of last iteration :\n");
    if (testcase_ctrl.max_runtime >= testcase_ctrl.tbu_runtime_limt) {
      sprintf(testcase_rptline,"ERROR: runtime limit exceeded! 0x%x\n",  testcase_ctrl.tbu_runtime_limt);
      RPT_TC_PRINT(testcase_rptline);
    }
  } else { 
    RPT_TC_PRINT("No errors\n");
  }

 }
 
 
//------------------------------------------------------------------------------
// CMU Submodule setup
//------------------------------------------------------------------------------
void testcase_init_cmu(tCmu_param cParam, unsigned int en_msk) 
{
	// setup global clock divider
	CMU_GCLK_NUM 	= cParam.gclk_num;
	CMU_GCLK_DEN 	= cParam.gclk_den;

	// setup the CMU_CLKx prescalers
	CMU_CLK_0_CTRL	= cParam.clk_0;
	CMU_CLK_1_CTRL	= cParam.clk_1;
	CMU_CLK_2_CTRL	= cParam.clk_2;
	CMU_CLK_3_CTRL	= cParam.clk_3;
	CMU_CLK_4_CTRL	= cParam.clk_4;
	CMU_CLK_5_CTRL	= cParam.clk_5;
	CMU_CLK_6_CTRL	= cParam.clk_6;
	CMU_CLK_7_CTRL	= cParam.clk_7;

	// enable the clock prescalers
	CMU_CLK_EN		= en_msk;
	// read back CMU_CLk_EN to be sure that fractional divider initialisation has passed 
        int val = CMU_CLK_EN;
}
//------------------------------------------------------------------------------
// Global GTM reset
//------------------------------------------------------------------------------

void activate_gtm_reset() {

    BOOL_TYPE ram_init = ram_hw_init_from_reset_c;
    int i;
    int val;

    GTM_CTRL = 0;
    GTM_RST = 1;
    GTM_CTRL = 0;
    val = GTM_REV;
    int spec_rev = ((val & 0x0FFF00) >> 8);
    if (ram_init != TRUE) {
	if (DPLL_INSTANCES > 0) {
	     DPLL_RAM_INI = 0x10;
	}
	for (i=0; i<MCS_INSTANCES; i++) {    
	       #if MCS_ARCH == 1 
		       MCS_CTRL(i) = 0x10000;
	       #elif MCS_ARCH == 2
		       MCS_CTRL_STAT(i) = 0x10000;
	       #endif
	 }
    }
    for (i=0; i<MCS_INSTANCES; i++) {    
	  #if MCS_ARCH == 1 
		  while(MCS_CTRL(i) !=0) testcase_ctrl.wait_loop_cnt++;
	  #elif MCS_ARCH == 2
		  while(MCS_CTRL_STAT(i) !=0) testcase_ctrl.wait_loop_cnt++;
	  #endif
    }
    if (DPLL_INSTANCES > 0) {
	 // reset bridge  to be sure that aeitranaction buffers are empty, otherwise DPLL_RAM_INI bug gets invoked
	 val = GTM_BRIDGE_MODE;
	 if ( spec_rev == 0x142 ) { GTM_BRIDGE_MODE = val | 0x10000;val = GTM_BRIDGE_MODE; }
	while( DPLL_RAM_INI != 0) {
          testcase_ctrl.wait_loop_cnt++;
 	  if ( spec_rev == 0x142 ) { GTM_BRIDGE_MODE = val | 0x10000;val = GTM_BRIDGE_MODE; }
	}
	while( DPLL_RAM_INI != 0) {
          testcase_ctrl.wait_loop_cnt++;
	  if ( spec_rev == 0x142 ) { GTM_BRIDGE_MODE = val | 0x10000;val = GTM_BRIDGE_MODE; }
	}
    }
}
//------------------------------------------------------------------------------
// function to start testcase run time measurement
//------------------------------------------------------------------------------
void start_testcase_runtime_measurement(unsigned int mode)
{
  int i;

  // CMU configuration structure
  tCmu_param theCmuConfig;
  theCmuConfig.gclk_num = GCLK_NUM_BASE * testcase_ctrl.glb_clk_div;		// define 100 MHz clock
  theCmuConfig.gclk_den = GCLK_DEN_BASE ;
  theCmuConfig.clk_0	= 0;			// define 100 MHz clock
  theCmuConfig.clk_1	= 0;			// define 100 MHz clock
  theCmuConfig.clk_2	= 0;			// define 100 MHz clock
  theCmuConfig.clk_3	= 0;			
  theCmuConfig.clk_4	= 0;			
  theCmuConfig.clk_5	= 0;			
  theCmuConfig.clk_6	= 0;			
  theCmuConfig.clk_7	= 0;			
 
   //------------------------------------------------------------------------------
   // Global GTM reset
   //------------------------------------------------------------------------------
	//GTM_CTRL = 0;
	//GTM_RST = 1;
	activate_gtm_reset();
	
  //------------------------------------------------------------------------------
  // configure Bridge mode
  //------------------------------------------------------------------------------
	GTM_BRIDGE_MODE = mode;
	// consume time that GTM_BRIDGE mode change is done
	for (i=0; i<3; i = i + 1) {
          consume_time();
	}
        int val = GTM_BRIDGE_MODE;
        if((val & 0x3) != mode) {
	     int xx = (val & 0x3);
	     if(DEBUG_MESSAGES) RPT_PRINT << "xx has value " << hex << xx << endl;
	     if(DEBUG_MESSAGES) RPT_PRINT << "GTM_BRIDGE_MODE has value " << hex << val << endl;
	     if(DEBUG_MESSAGES) RPT_PRINT << "ERROR: GTM_BRIDGE_MODE not set correctly to " << mode << endl;
	     testcase_ctrl.errors++;
	}

 	if(DEBUG_MESSAGES) RPT_PRINT << "Configure TBU" << endl;
	if(DEBUG_MESSAGES) RPT_PRINT << "=======================================================" << endl;
	// setup TBU channel 0
	TBU_CH0_CTRL = 0x0;	// no LOW_RES, choose CMU_CLK0
	// setup TBU channel 1
	TBU_CH1_CTRL = 0x0;	// no LOW_RES, choose CMU_CLK0
	// setup TBU channel 2
	if (TBU_CHANNEL > 2) {
	  TBU_CH2_CTRL = 0x0;	// no LOW_RES, choose CMU_CLK0
	}
        val = TBU_CHEN;

	// enable tbu 0
	if (TBU_CHANNEL > 2) {
	  TBU_CHEN = 0x2A;
	} else {
	  TBU_CHEN = 0x0A;
	}

	if(DEBUG_MESSAGES) RPT_PRINT << "configure CMU" << endl;
	if(DEBUG_MESSAGES) RPT_PRINT << "========================================================" << endl;
	testcase_init_cmu(theCmuConfig, 0x2);	// configure  CMU and enable
	
}
void set_bridge_wr_mask(unsigned int mode)
{
        int i;
        int set_val;
        int val = GTM_BRIDGE_MODE ;
        if (mode == 0) {
	   set_val = val & 0xFFFFFFFD;
	} else {
	   set_val = val | 0x2;
	}
	GTM_BRIDGE_MODE = set_val;
	// consume time that GTM_BRIDGE mode change is done
	for (i=0; i<3; i = i + 1) {
          consume_time();
	}
        val = GTM_BRIDGE_MODE;
        if((val & 0x3) != (set_val & 0x3) ) {
	     testcase_ctrl.errors++;
	}
}
//------------------------------------------------------------------------------
// configure Bridge mode
//------------------------------------------------------------------------------

void set_bridge_mode(unsigned int mode) {
        int i;
	GTM_BRIDGE_MODE = mode;
	// consume time that GTM_BRIDGE mode change is done
	for (i=0; i<3; i = i + 1) {
          consume_time();
	}
        int val = GTM_BRIDGE_MODE;
        if((val & 0x3) != mode) {
	     int xx = (val & 0x3);
	     if(DEBUG_MESSAGES) RPT_PRINT << "xx has value " << hex << xx << endl;
	     if(DEBUG_MESSAGES) RPT_PRINT << "GTM_BRIDGE_MODE has value " << hex << val << endl;
	     if(DEBUG_MESSAGES) RPT_PRINT << "ERROR: GTM_BRIDGE_MODE not set correctly to " << mode << endl;
	     testcase_ctrl.errors++;
	}
}

