//head:-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// $Id: gtm_main_v104.cpp,v 1.2 2014/04/09 09:17:02 twagner Exp $
//------------------------------------------------------------------------------
// NO WARRANTIES: TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER THE
// INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND CONTRIBUTORS, NOR ANY
// PERSON, EITHER EXPRESSLY OR IMPLICITLY, WARRANTS ANY ASPECT OF THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// INCLUDING ANY OUTPUT OR RESULTS OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO UNLESS AGREED TO IN WRITING.
// THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED
// THERETO IS BEING PROVIDED "AS IS", WITHOUT ANY WARRANTY OF ANY TYPE OR
// NATURE, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY
// WARRANTY THAT THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO IS FREE FROM DEFECTS.
//
// ASSUMPTION OF RISK: THE RISK OF ANY AND ALL LOSS, DAMAGE, OR UNSATISFACTORY
// PERFORMANCE OF THIS SPECIFICATION (RESPECTIVELY THE PRODUCTS MAKING USE OF
// IT IN PART OR AS A WHOLE), SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM
// RELATED THERETO RESTS WITH YOU AS THE USER. TO THE MAXIMUM EXTENT PERMITTED
// BY LAW, NEITHER THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND
// CONTRIBUTORS, NOR ANY PERSON EITHER EXPRESSLY OR IMPLICITLY, MAKES ANY
// REPRESENTATION OR WARRANTY REGARDING THE APPROPRIOATENESS OF THE USE, OUTPUT,
// OR RESULTS OF THE USE OF THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE
// AND/OR PROGRAM RELATED THERETO IN TERMS OF ITS CORRECTNESS, ACCURACY,
// RELIABILITY, BEING CURRENT OR OTHERWISE. NOR DO THEY HAVE ANY OBLIGATION TO
// CORRECT ERRORS, MAKE CHANGES, SUPPORT THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, DISTRIBUTE UPDATES, OR PROVIDE
// NOTIFICATION OF ANY ERROR OR DEFECT, KNOWN OR UNKNOWN. IF YOU RELY UPON THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// YOU DO SO AT YOUR OWN RISK, AND YOU ASSUME THE RESPONSIBILITY FOR THE
// RESULTS. SHOULD THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL LOSSES,
// INCLUDING, BUT NOT LIMITED TO, ANY NECESSARY SERVICING, REPAIR OR CORRECTION
// OF ANY PROPERTY INVOLVED TO THE MAXIMUM EXTEND PERMITTED BY LAW.
//
// DISCLAIMER: IN NO EVENT, UNLESS REQUIRED BY LAW OR AGREED TO IN WRITING,
// SHALL THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS OR ANY PERSON BE
// LIABLE FOR ANY LOSS, EXPENSE OR DAMAGE, OF ANY TYPE OR NATURE ARISING OUT OF
// THE USE OF, OR INABILITY TO USE THIS SPECIFICATION, SOFTWARE RELATED THERETO,
// CODE AND/OR PROGRAM RELATED THERETO, INCLUDING, BUT NOT LIMITED TO, CLAIMS,
// SUITS OR CAUSES OF ACTION INVOLVING ALLEGED INFRINGEMENT OF COPYRIGHTS,
// PATENTS, TRADEMARKS, TRADE SECRETS, OR UNFAIR COMPETITION.
//
// INDEMNIFICATION: TO THE MAXIMUM EXTEND PERMITTED BY LAW YOU AGREE TO
// INDEMNIFY AND HOLD HARMLESS THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT
// HOLDERS AND CONTRIBUTORS, AND EMPLOYEES, AND ANY PERSON FROM AND AGAINST ALL
// CLAIMS, LIABILITIES, LOSSES, CAUSES OF ACTION, DAMAGES, JUDGMENTS, AND
// EXPENSES, INCLUDING THE REASONABLE COST OF ATTORNEYS' FEES AND COURT COSTS,
// FOR INJURIES OR DAMAGES TO THE PERSON OR PROPERTY OF THIRD PARTIES,
// INCLUDING, WITHOUT LIMITATIONS, CONSEQUENTIAL, DIRECT AND INDIRECT DAMAGES
// AND ANY ECONOMIC LOSSES, THAT ARISE OUT OF OR IN CONNECTION WITH YOUR USE,
// MODIFICATION, OR DISTRIBUTION OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, ITS OUTPUT, OR ANY ACCOMPANYING
// DOCUMENTATION.
//
// GOVERNING LAW: THE RELATIONSHIP BETWEEN YOU AND ROBERT BOSCH GMBH SHALL BE
// GOVERNED SOLELY BY THE LAWS OF THE FEDERAL REPUBLIC OF GERMANY. THE
// STIPULATIONS OF INTERNATIONAL CONVENTIONS REGARDING THE INTERNATIONAL SALE OF
// GOODS SHALL NOT BE APPLICABLE. THE EXCLUSIVE LEGAL VENUE SHALL BE
// DUESSELDORF, GERMANY.
//
// MANDATORY LAW SHALL BE UNAFFECTED BY THE FOREGOING PARAGRAPHS.
//
// INTELLECTUAL PROPERTY OWNERS/COPYRIGHT OWNERS/CONTRIBUTORS: ROBERT BOSCH
// GMBH, ROBERT BOSCH PLATZ 1, 70839 GERLINGEN, GERMANY AND ITS LICENSORS.
//
// ALL RIGHTS RESERVED.
//------------------------------------------------------------------------------
// Project Name : GTM - Generic Timer Module
//------------------------------------------------------------------------------
// Copyright   : Robert Bosch GmbH, Gerlingen, Germany
// Department  : AE/EIN2
// Created     : 02.04.2014
//------------------------------------------------------------------------------
//:head-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// Description     : Gateway function for integration of user defined SW
//============================================================================ 
// Important Notes : 
//============================================================================ 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "gtm.h"

#include "platform.h"
#include "functions.h"

// integration tests:
int fifo_mem_access();
int atom_port_test();
int tim_port_test();
int tom_port_test();
int brc_mcs_test();

// application notes:
int atom_pmsm();
int atom_pmsm_isr(int);
int mcs_atom_pmsm();
int mcs_atom_pmsm_isr(int);
int dpll_an011();
int dpll_an011_isr(int);
int dpll_an013();
int dpll_an013_isr(int);
int encoder1();
int encoder1_isr(int);
int encoder2();
int encoder2_isr(int);
int encoder3();
int encoder3_isr(int);
int sw_atom_flex_pwm_an012();
int sw_atom_flex_pwm_an012_isr(int);
int mcs_spi_app();
int mcs_spi_app_isr(int);
int mcs_spi_rx_isr(int); 

// new test template:
int my_test();
int my_test_isr(int);

//-----------------------------------------------------------------------
#define DEFINE_TEST_FCT(name) if(strcmp(argv[1], #name) == 0) test_fct = name
#define DEFINE_TEST_FCT1(name) if(strcmp(argv[1], #name) == 0) test_fct1 = name
#define DEFINE_ISR_FCT(name) if(strcmp(argv[1], #name) == 0) isr_fct = name

unsigned int dut_is_rm = 0;
unsigned int nr_of_calls=0;

int gtm_main(int argc, char* argv[]) {

  // argv[0] : contains the IFS commmand name (i.e. RUN_SW)
  // argv[1] : contains the test function name
  // argv[2] : contains the test function calling paramter (of type *char)

   int status= 0;
   int (*test_fct)(void) = NULL;
   int (*test_fct1)(char*) = NULL;

   if ( argc == 1 ) {
        printf("Function gtm_main expects a single argument identifying the C-function of the test.");
   } else if ( argc == 2 || argc == 3) {
     // select desired test function
     DEFINE_TEST_FCT(fifo_mem_access);
     DEFINE_TEST_FCT(atom_port_test);
     DEFINE_TEST_FCT(tim_port_test);
     DEFINE_TEST_FCT(tom_port_test);
     DEFINE_TEST_FCT(brc_mcs_test);

     DEFINE_TEST_FCT(atom_pmsm);
     DEFINE_TEST_FCT(mcs_atom_pmsm);
     DEFINE_TEST_FCT(dpll_an011);
     DEFINE_TEST_FCT(dpll_an013);
     DEFINE_TEST_FCT(encoder1);
     DEFINE_TEST_FCT(encoder2);
     DEFINE_TEST_FCT(encoder3);
     DEFINE_TEST_FCT(mcs_spi_app);
     DEFINE_TEST_FCT(sw_atom_flex_pwm_an012);

     //--------------------
     // test template
     DEFINE_TEST_FCT(my_test);
     // add new tests below:


     //-----------------------------------------------------------------
     // invoke the test
     if ( test_fct != NULL || test_fct1 != NULL)  {
       if ( argc == 3) {
         printf("Invoking test \"%s\" ...\n", argv[1]);
         status = test_fct1(argv[2]);
       } else {
         printf("Invoking test \"%s\" ...\n", argv[1]);
         status = test_fct();
       }
       if ( status == 0 ) {
         printf("Test \"%s\" finished successfully.\n", argv[1]);
         //test_fct = NULL;
       } else {
         printf("Test \"%s\" finished with errors.\n", argv[1]);
         //test_fct = NULL;
       }
     } else {
       printf("Test \"%s\" is not available.\n", argv[1]);
     }
   } else {
     printf("Function gtm_main is called with too many arguments.\n");
   } 
   test_fct = NULL;
   test_fct1 = NULL;
   return status;
}

int gtm_isr(int argc, char* argv[]) {

  // argv[0] : contains the IFS commmand name (i.e. RUN_SW)
  // argv[1] : contains the ISR name
  // argv[2] : contains the ISR number

   int (*isr_fct)(int) = NULL;

   if ( argc == 0 ) {
        printf("Function gtm_isr expects a single argument identifying the ISR number.");
   } else if ( argc == 3 ) {
     // select desired isr

     DEFINE_ISR_FCT(atom_pmsm_isr);
     DEFINE_ISR_FCT(mcs_atom_pmsm_isr);
     DEFINE_ISR_FCT(dpll_an011_isr);
     DEFINE_ISR_FCT(dpll_an013_isr);
     DEFINE_ISR_FCT(encoder1_isr);
     DEFINE_ISR_FCT(encoder2_isr);
     DEFINE_ISR_FCT(encoder3_isr);
     DEFINE_ISR_FCT(mcs_spi_app_isr);
     DEFINE_ISR_FCT(mcs_spi_rx_isr);
     DEFINE_ISR_FCT(sw_atom_flex_pwm_an012_isr);

     //--------------------
     // test template
     DEFINE_ISR_FCT(my_test_isr);
     // add new tests below:

     //-----------------------------------------------------------------
     // invoke the isr
     if ( isr_fct != NULL )  {
       if(DEBUG_ISR_CALLMESSAGES) printf("Invoking ISR \"%s\" with number %s ...\n", argv[1], argv[2]);
       int number= atoi(argv[2]);
       
       int status = isr_fct(number);
       if ( status == 0 ) {
         if(DEBUG_ISR_CALLMESSAGES) printf("ISR \"%s\" finished successfully.\n", argv[1]);
       } else {
         printf("ISR \"%s\" finished with errors.\n", argv[1]);
         isr_fct = NULL;
       }
     } else {
       printf("ISR \"%s\" is not available.\n", argv[1]);
     }
   }
   return isr_fct == NULL;
}
