//head:-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// $Id: gtm_mem_test.cpp,v 1.14 2013/08/06 08:32:03 jhanisch Exp $
//------------------------------------------------------------------------------
// NO WARRANTIES: TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER THE
// INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND CONTRIBUTORS, NOR ANY
// PERSON, EITHER EXPRESSLY OR IMPLICITLY, WARRANTS ANY ASPECT OF THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// INCLUDING ANY OUTPUT OR RESULTS OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO UNLESS AGREED TO IN WRITING.
// THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED
// THERETO IS BEING PROVIDED "AS IS", WITHOUT ANY WARRANTY OF ANY TYPE OR
// NATURE, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY
// WARRANTY THAT THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO IS FREE FROM DEFECTS.
//
// ASSUMPTION OF RISK: THE RISK OF ANY AND ALL LOSS, DAMAGE, OR UNSATISFACTORY
// PERFORMANCE OF THIS SPECIFICATION (RESPECTIVELY THE PRODUCTS MAKING USE OF
// IT IN PART OR AS A WHOLE), SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM
// RELATED THERETO RESTS WITH YOU AS THE USER. TO THE MAXIMUM EXTENT PERMITTED
// BY LAW, NEITHER THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND
// CONTRIBUTORS, NOR ANY PERSON EITHER EXPRESSLY OR IMPLICITLY, MAKES ANY
// REPRESENTATION OR WARRANTY REGARDING THE APPROPRIOATENESS OF THE USE, OUTPUT,
// OR RESULTS OF THE USE OF THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE
// AND/OR PROGRAM RELATED THERETO IN TERMS OF ITS CORRECTNESS, ACCURACY,
// RELIABILITY, BEING CURRENT OR OTHERWISE. NOR DO THEY HAVE ANY OBLIGATION TO
// CORRECT ERRORS, MAKE CHANGES, SUPPORT THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, DISTRIBUTE UPDATES, OR PROVIDE
// NOTIFICATION OF ANY ERROR OR DEFECT, KNOWN OR UNKNOWN. IF YOU RELY UPON THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// YOU DO SO AT YOUR OWN RISK, AND YOU ASSUME THE RESPONSIBILITY FOR THE
// RESULTS. SHOULD THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL LOSSES,
// INCLUDING, BUT NOT LIMITED TO, ANY NECESSARY SERVICING, REPAIR OR CORRECTION
// OF ANY PROPERTY INVOLVED TO THE MAXIMUM EXTEND PERMITTED BY LAW.
//
// DISCLAIMER: IN NO EVENT, UNLESS REQUIRED BY LAW OR AGREED TO IN WRITING,
// SHALL THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS OR ANY PERSON BE
// LIABLE FOR ANY LOSS, EXPENSE OR DAMAGE, OF ANY TYPE OR NATURE ARISING OUT OF
// THE USE OF, OR INABILITY TO USE THIS SPECIFICATION, SOFTWARE RELATED THERETO,
// CODE AND/OR PROGRAM RELATED THERETO, INCLUDING, BUT NOT LIMITED TO, CLAIMS,
// SUITS OR CAUSES OF ACTION INVOLVING ALLEGED INFRINGEMENT OF COPYRIGHTS,
// PATENTS, TRADEMARKS, TRADE SECRETS, OR UNFAIR COMPETITION.
//
// INDEMNIFICATION: TO THE MAXIMUM EXTEND PERMITTED BY LAW YOU AGREE TO
// INDEMNIFY AND HOLD HARMLESS THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT
// HOLDERS AND CONTRIBUTORS, AND EMPLOYEES, AND ANY PERSON FROM AND AGAINST ALL
// CLAIMS, LIABILITIES, LOSSES, CAUSES OF ACTION, DAMAGES, JUDGMENTS, AND
// EXPENSES, INCLUDING THE REASONABLE COST OF ATTORNEYS' FEES AND COURT COSTS,
// FOR INJURIES OR DAMAGES TO THE PERSON OR PROPERTY OF THIRD PARTIES,
// INCLUDING, WITHOUT LIMITATIONS, CONSEQUENTIAL, DIRECT AND INDIRECT DAMAGES
// AND ANY ECONOMIC LOSSES, THAT ARISE OUT OF OR IN CONNECTION WITH YOUR USE,
// MODIFICATION, OR DISTRIBUTION OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, ITS OUTPUT, OR ANY ACCOMPANYING
// DOCUMENTATION.
//
// GOVERNING LAW: THE RELATIONSHIP BETWEEN YOU AND ROBERT BOSCH GMBH SHALL BE
// GOVERNED SOLELY BY THE LAWS OF THE FEDERAL REPUBLIC OF GERMANY. THE
// STIPULATIONS OF INTERNATIONAL CONVENTIONS REGARDING THE INTERNATIONAL SALE OF
// GOODS SHALL NOT BE APPLICABLE. THE EXCLUSIVE LEGAL VENUE SHALL BE
// DUESSELDORF, GERMANY.
//
// MANDATORY LAW SHALL BE UNAFFECTED BY THE FOREGOING PARAGRAPHS.
//
// INTELLECTUAL PROPERTY OWNERS/COPYRIGHT OWNERS/CONTRIBUTORS: ROBERT BOSCH
// GMBH, ROBERT BOSCH PLATZ 1, 70839 GERLINGEN, GERMANY AND ITS LICENSORS.
//
// ALL RIGHTS RESERVED.
//------------------------------------------------------------------------------
// Project Name : GTM - Generic Timer Module
//------------------------------------------------------------------------------
// Copyright   : Robert Bosch GmbH, Gerlingen, Germany
// Department  : AE/EIY
// Created     : 25.01.2011
//------------------------------------------------------------------------------
//:head-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// Description     : GTM memory test
//============================================================================ 
// Important Notes : 
//============================================================================ 

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "gtm.h"
#include "gtm_device_cfg.h"
#include "functions.h"
#include "dpll_def.h"
#include "platform.h"
#include "testcase_control_variables.h"

#define MCS_RAM_OFFSET 20
#define PSM_RAM_OFFSET 10

using namespace std;

extern testcase_ctrl_type testcase_ctrl;
extern int (*test_function)(char* variant);
extern int (*test_init_function)(void);
extern char testcase_rptline[100];

static const char *dpll_check_label[] = { 
   "DPLL_RAM1a",
   "DPLL_RAM1b",
   "DPLL_RAM2"
};

int gtm_mem_test_single(char* variant) {

    gtm_ptr p;
    int i;
    testcase_ctrl.errors = 0;
    for (i=0; i<100; i++){
      testcase_ctrl.status[i] = 0x0;
    }   

    int errorPos = 0;

    BOOL_TYPE ram_init = ram_hw_init_from_reset_c;

    testcase_ctrl.runtime     = 0;
    // global reset:
    start_testcase_runtime_measurement(testcase_ctrl.bridge_mode);

    //-------------------------------------------------------------------------
    if(DEBUG_MESSAGES) RPT_PRINT << "Testing DPLL RAM's. ram_init_from_reset=" << ram_hw_init_from_reset_c << endl;

    // reset bridge  to be sure that aeitranaction buffers are empty, otherwise DPLL_RAM_INI bug gets invoked
    int val = GTM_REV;
    int spec_rev = ((val & 0x0FFF00) >> 8);
    val = GTM_BRIDGE_MODE;
    if ( spec_rev == 0x142 ) { GTM_BRIDGE_MODE = val | 0x10000;val = GTM_BRIDGE_MODE; }
    if ( spec_rev >= 0x200 ) {  
      val = GTM_HW_CONF;
      int ram_ini = ((val & 0x00001000) >> 12);
      if ( !( ram_hw_init_from_reset_c && ram_ini == 1) ) {
        testcase_ctrl.errors += testcase_ctrl.status[errorPos];
      }
      if ( !( (! ram_hw_init_from_reset_c) && ram_ini == 0) ) {
        testcase_ctrl.errors += testcase_ctrl.status[errorPos];
      }
    }
    if (DPLL_INSTANCES > 0) {
       if(DEBUG_MESSAGES) RPT_PRINT << "waiting until DPLL RAM init finished" << endl;
       while( DPLL_RAM_INI != 0) {
           testcase_ctrl.wait_loop_cnt++;
    	   if ( spec_rev == 0x142 ) { GTM_BRIDGE_MODE = val | 0x10000;val = GTM_BRIDGE_MODE; testcase_ctrl.wait_loop_cnt += 2;}
       }

       // Testing DPLL RAM 1A
       p = &DPLL_RR1A;
       // Fill RAM
       if(DEBUG_MESSAGES) RPT_PRINT << "Filling DPLL RAM 1A";
       for ( i = 0; i < DPLL_RR1A_ENTRIES; i++ ) {
	 if (!(i%10))
           if(DEBUG_MESSAGES) RPT_PRINT << ".";
	 p[i] = 0xFFFFFFFF;
       }
       if(DEBUG_MESSAGES) RPT_PRINT << "." << endl;

       // Testing DPLL RAM 1A content
       if(DEBUG_MESSAGES) RPT_PRINT << "Testing DPLL RAM 1A";
       for ( i = 0; i < DPLL_RR1A_ENTRIES; i++ ) {
	 if (!(i%10))
           if(DEBUG_MESSAGES) RPT_PRINT << ".";
	 if ( p[i] != 0xFFFFFF ) {
           if(DEBUG_MESSAGES) RPT_PRINT << "data mismatch on DPLL RAM1A data[" << i << "]:" << "expected : " << 0xFFFFFF << " read  : " << p[i] << endl;
           testcase_ctrl.status[errorPos] += 1;
	 }
       }
       if(DEBUG_MESSAGES) RPT_PRINT << "." << endl;
       testcase_ctrl.errors += testcase_ctrl.status[errorPos];
       errorPos++;

       // Testing DPLL RAM 1bc
       p = &DPLL_RR1B;
       // Fill RAM
       if(DEBUG_MESSAGES) RPT_PRINT << "Filling DPLL RAM 1BC";
       for ( i = 0; i < DPLL_RR1BC_ENTRIES; i++ ) {
	 if (!(i%10))
           if(DEBUG_MESSAGES) RPT_PRINT << ".";
	 p[i] = 0xFFFFFFFF;
       }
       if(DEBUG_MESSAGES) RPT_PRINT << "." << endl;

       // Testing DPLL RAM 1bc content
       if(DEBUG_MESSAGES) RPT_PRINT << "Testing DPLL RAM 1BC";
       for ( i = 0; i < DPLL_RR1BC_ENTRIES; i++ ) {
	 if (!(i%10))
           if(DEBUG_MESSAGES) RPT_PRINT << ".";
	 if ( p[i] != 0xFFFFFF ) {
           if(DEBUG_MESSAGES) RPT_PRINT << "data mismatch on DPLL RAM1bc data[" << i << "]:" << "expected : " << 0xFFFFFF << " read  : " << p[i] << endl;
           testcase_ctrl.status[errorPos] += 1;
	 }
       }
       if(DEBUG_MESSAGES) RPT_PRINT << "." << endl;
       testcase_ctrl.errors += testcase_ctrl.status[errorPos];
       errorPos++;

       // Testing DPLL RAM 2
       // Define size of RAM region 2 to 2048 entries 
       DPLL_OSW = 0x200;

       p = &DPLL_RR2;
       // Fill RAM
       if(DEBUG_MESSAGES) RPT_PRINT << "Filling DPLL RAM 2";
       for ( i = 0; i < DPLL_RR2_ENTRIES; i++ ) {
	 if (!(i%50))
           if(DEBUG_MESSAGES) RPT_PRINT << ".";
	 p[i] = 0xFFFFFFFF;
       }
       if(DEBUG_MESSAGES) RPT_PRINT << "." << endl;

       // Test DPLL RAM 2 content
       if(DEBUG_MESSAGES) RPT_PRINT << "Testing DPLL RAM 2";
       for ( i = 0; i < DPLL_RR2_ENTRIES; i++ ) {
	 if (!(i%50))
           if(DEBUG_MESSAGES) RPT_PRINT << ".";
	 if ( p[i] != 0xFFFFFF ) {
           if(DEBUG_MESSAGES) RPT_PRINT << "data mismatch on DPLL RAM2 data[" << i << "]:" << "expected : " << 0xFFFFFF << " read  : " << p[i] << endl;
           testcase_ctrl.status[errorPos] += 1;
	 }
       }
       if(DEBUG_MESSAGES) RPT_PRINT << "." << endl;
    }
    if (ram_init == TRUE) {

      // reset GTM
      if(DEBUG_MESSAGES) RPT_PRINT << "resetting GTM" << endl;
      testcase_ctrl.runtime     += TBU_CH0_BASE;
      GTM_CTRL = 0x00; // clear RF_PROT
      GTM_RST  = 0x01; // reset GTM
      
      // check again that reset has cleared RAM (if enabled)
      
    if (DPLL_INSTANCES > 0) {
	  if(DEBUG_MESSAGES) RPT_PRINT << "Testing DPLL RAM intialization." << endl;

	  // reset bridge  to be sure that aeitranaction buffers are empty, otherwise DPLL_RAM_INI bug gets invoked
	  int val = GTM_REV;
	  int spec_rev = ((val & 0x0FFF00) >> 8);
	  val = GTM_BRIDGE_MODE;
	  if ( spec_rev == 0x142 ) { GTM_BRIDGE_MODE = val | 0x10000;val = GTM_BRIDGE_MODE; }
	  if(DEBUG_MESSAGES) RPT_PRINT << "waiting until DPLL RAM init finished" << endl;
	  while( DPLL_RAM_INI != 0) {
            testcase_ctrl.wait_loop_cnt++;
    	    if ( spec_rev == 0x142 ) { GTM_BRIDGE_MODE = val | 0x10000;val = GTM_BRIDGE_MODE; testcase_ctrl.wait_loop_cnt += 2;}
	  }

	  // Testing DPLL RAM 1A content
	  p = &DPLL_RR1A;
	  if(DEBUG_MESSAGES) RPT_PRINT << "Testing DPLL RAM 1A";
	  for ( i = 0; i < DPLL_RR1A_ENTRIES; i++ ) {
            if (!(i%10))
              if(DEBUG_MESSAGES) RPT_PRINT << ".";
            if ( p[i] != 0x000000 ) {
              if(DEBUG_MESSAGES) RPT_PRINT << "data mismatch on DPLL RAM1A data[" << i << "]:" << "expected : " << 0x000000 << " read  : " << p[i] << endl;
              testcase_ctrl.status[errorPos] += 1;
            }
	  }
	  if(DEBUG_MESSAGES) RPT_PRINT << "." << endl;
	  testcase_ctrl.errors += testcase_ctrl.status[errorPos];
	  errorPos++;


	  // Testing DPLL RAM 1bc content
	  p = &DPLL_RR1B;
	  if(DEBUG_MESSAGES) RPT_PRINT << "Testing DPLL RAM 1BC";
	  for ( i = 0; i < DPLL_RR1BC_ENTRIES; i++ ) {
            if (!(i%10))
              if(DEBUG_MESSAGES) RPT_PRINT << ".";
            if ( p[i] != 0x000000 ) {
              if(DEBUG_MESSAGES) RPT_PRINT << "data mismatch on DPLL RAM1bc data[" << i << "]:" << "expected : " << 0x000000 << " read  : " << p[i] << endl;
              testcase_ctrl.status[errorPos] += 1;
            }
	  }
	  if(DEBUG_MESSAGES) RPT_PRINT << "." << endl;
	  testcase_ctrl.errors += testcase_ctrl.status[errorPos];
	  errorPos++;


	  // Test DPLL RAM 2 content
	  p = &DPLL_RR2;
	  if(DEBUG_MESSAGES) RPT_PRINT << "Testing DPLL RAM 2";
	  for ( i = 0; i < DPLL_RR2_ENTRIES; i++ ) {
            if (!(i%50))
              if(DEBUG_MESSAGES) RPT_PRINT << ".";
            if ( p[i] != 0x000000 ) {
              if(DEBUG_MESSAGES) RPT_PRINT << "data mismatch on DPLL RAM2 data[" << i << "]:" << "expected : " << 0x000000 << " read  : " << p[i] << endl;
              testcase_ctrl.status[errorPos] += 1;
            }
	  }
	  if(DEBUG_MESSAGES) RPT_PRINT << "." << endl;
      } 
      start_testcase_runtime_measurement(testcase_ctrl.bridge_mode);
    } // if (ram_init == TRUE) ..

    //-------------------------------------------------------------------------
    testcase_ctrl.errors += testcase_ctrl.status[errorPos];
    errorPos = MCS_RAM_OFFSET;

    if (MCS_INSTANCES > 0) {
       if(DEBUG_MESSAGES) RPT_PRINT << "Testing MCS0 RAM's" << endl;

       p = &MCS0_MEM;
       // Fill RAM
       if(DEBUG_MESSAGES) RPT_PRINT << "Filling MCS0 RAM";
       for ( i = 0; i < MCS_RAM_ENTRIES; i++ ) {
	 if (!(i%50))
           if(DEBUG_MESSAGES) RPT_PRINT << ".";
	 p[i] = 0xFFFFFFFF;
       }
       if(DEBUG_MESSAGES) RPT_PRINT << "." << endl;

       // Test MCS0 RAM content
       if(DEBUG_MESSAGES) RPT_PRINT << "Testing MCS0 RAM";
       for ( i = 0; i < MCS_RAM_ENTRIES; i++ ) {
	 if (!(i%50))
           if(DEBUG_MESSAGES) RPT_PRINT << ".";
	 if ( p[i] != 0xFFFFFFFF ) {
           if(DEBUG_MESSAGES) RPT_PRINT << "data mismatch on MCS0 RAM data[" << i << "]:" << "expected : " << 0xFFFFFFFF << " read  : " << p[i] << endl;
           testcase_ctrl.status[errorPos] += 1;
	 }
       }
       if(DEBUG_MESSAGES) RPT_PRINT << "." << endl;
    }
    testcase_ctrl.errors += testcase_ctrl.status[errorPos];
    errorPos++;
    
    //-------------------------------------------------------------------------
    if (MCS_INSTANCES > 1) {
      if(DEBUG_MESSAGES) RPT_PRINT << "Testing MCS1 RAM's" << endl;
    
      p = &MCS1_MEM;
      // Fill RAM
      if(DEBUG_MESSAGES) RPT_PRINT << "Filling MCS1 RAM";
      for ( i = 0; i < MCS_RAM_ENTRIES; i++ ) {
        if (!(i%50))
          if(DEBUG_MESSAGES) RPT_PRINT << ".";
        p[i] = 0xFFFFFFFF;
      }
      if(DEBUG_MESSAGES) RPT_PRINT << "." << endl;

      // Test MCS0 RAM content
      if(DEBUG_MESSAGES) RPT_PRINT << "Testing MCS1 RAM";
      for ( i = 0; i < MCS_RAM_ENTRIES; i++ ) {
        if (!(i%50))
          if(DEBUG_MESSAGES) RPT_PRINT << ".";
        if ( p[i] != 0xFFFFFFFF ) {
          if(DEBUG_MESSAGES) RPT_PRINT << "data mismatch on MCS1 RAM data[" << i << "]:" << "expected : " << 0xFFFFFFFF << " read  : " << p[i] << endl;
          testcase_ctrl.status[errorPos] += 1;
        }
      }
      if(DEBUG_MESSAGES) RPT_PRINT << "." << endl;
    }
    testcase_ctrl.errors += testcase_ctrl.status[errorPos];
    errorPos++;
        
    //-------------------------------------------------------------------------
    if (MCS_INSTANCES > 2) {
      if(DEBUG_MESSAGES) RPT_PRINT << "Testing MCS2 RAM's" << endl;

      p = &MCS2_MEM;
      // Fill RAM
      if(DEBUG_MESSAGES) RPT_PRINT << "Filling MCS2 RAM";
      for ( i = 0; i < MCS_RAM_ENTRIES; i++ ) {
        if (!(i%50))
          if(DEBUG_MESSAGES) RPT_PRINT << ".";
        p[i] = 0xFFFFFFFF;
      }
      if(DEBUG_MESSAGES) RPT_PRINT << "." << endl;
      
      // Test MCS2 RAM content
      if(DEBUG_MESSAGES) RPT_PRINT << "Testing MCS2 RAM";
      for ( i = 0; i < MCS_RAM_ENTRIES; i++ ) {
        if (!(i%50))
          if(DEBUG_MESSAGES) RPT_PRINT << ".";
        if ( p[i] != 0xFFFFFFFF ) {
          if(DEBUG_MESSAGES) RPT_PRINT << "data mismatch on MCS2 RAM data[" << i << "]:"  << "expected : " << 0xFFFFFFFF << " read  : " << p[i] << endl;
          testcase_ctrl.status[errorPos] += 1;
        }
      }
      if(DEBUG_MESSAGES) RPT_PRINT << "." << endl;
    }
    testcase_ctrl.errors += testcase_ctrl.status[errorPos];
    errorPos++;

    //-------------------------------------------------------------------------
    if (MCS_INSTANCES > 3) {
      if(DEBUG_MESSAGES) RPT_PRINT << "Testing MCS3 RAM's" << endl;

      p = &MCS3_MEM;
      // Fill RAM
      if(DEBUG_MESSAGES) RPT_PRINT << "Filling MCS3 RAM";
        for ( i = 0; i < MCS_RAM_ENTRIES; i++ ) {
          if (!(i%50))
            if(DEBUG_MESSAGES) RPT_PRINT << ".";
          p[i] = 0xFFFFFFFF;
        }
        if(DEBUG_MESSAGES) RPT_PRINT << "." << endl;
        
        // Test MCS3 RAM content
        if(DEBUG_MESSAGES) RPT_PRINT << "Testing MCS3 RAM";
        for ( i = 0; i < MCS_RAM_ENTRIES; i++ ) {
          if (!(i%50))
            if(DEBUG_MESSAGES) RPT_PRINT << ".";
          if ( p[i] != 0xFFFFFFFF ) {
            if(DEBUG_MESSAGES) RPT_PRINT << "data mismatch on MCS3 RAM data[" << i << "]:"  << "expected : " << 0xFFFFFFFF << " read  : " << p[i] << endl;
            testcase_ctrl.status[errorPos] += 1;
          }
        }
        if(DEBUG_MESSAGES) RPT_PRINT << "." << endl;
    }
    testcase_ctrl.errors += testcase_ctrl.status[errorPos];
    errorPos = PSM_RAM_OFFSET;
        
    //-------------------------------------------------------------------------
    if(DEBUG_MESSAGES) RPT_PRINT << "Testing PSM RAM" << endl;

    if (PSM_INSTANCES > 0) {
       p = &FIFO0_MEMORY; 

       // now enable the FIFO RAM for writting
       FIFO0_CH0_CTRL = 0x8;
       // Fill RAM
       if(DEBUG_MESSAGES) RPT_PRINT << "Filling FIFO RAM, writting capability enabled";
       for ( i = 0; i < FIFO_ENTRIES; i++ ) {
	 if (!(i%10))
           if(DEBUG_MESSAGES) RPT_PRINT << ".";
	 p[i] = 0xFFFFFFFF;
       }
       if(DEBUG_MESSAGES) RPT_PRINT << "." << endl;

       // Testing FIFO_RAM content
       if(DEBUG_MESSAGES) RPT_PRINT << "Testing FIFO RAM";
       for ( i = 0; i < FIFO_ENTRIES; i++ ) {
	 if (!(i%10))
           if(DEBUG_MESSAGES) RPT_PRINT << ".";
           if ( p[i] != 0x1FFFFFFF ) {
             if(DEBUG_MESSAGES) RPT_PRINT << "data mismatch on FIFO entry[" << i << "]:" << "expected : " << 0x1FFFFFFF << " read  : " << p[i] << endl;
             testcase_ctrl.status[errorPos] += 1;
           }
       }
       if(DEBUG_MESSAGES) RPT_PRINT << "." << endl;

       // now enable the FIFO RAM for writting
       FIFO0_CH0_CTRL = 0x8;

       // Fill RAM again
       if(DEBUG_MESSAGES) RPT_PRINT << "Filling FIFO RAM, writting capability enabled";
       for ( i = 0; i < FIFO_ENTRIES; i++ ) {
	 if (!(i%10))
           if(DEBUG_MESSAGES) RPT_PRINT << ".";
	 p[i] = 0x00000000;
       }
       if(DEBUG_MESSAGES) RPT_PRINT << "." << endl;

       // Testing FIFO_RAM content
       if(DEBUG_MESSAGES) RPT_PRINT << "Testing FIFO RAM";
       for ( i = 0; i < FIFO_ENTRIES; i++ ) {
	 if (!(i%10))
           if(DEBUG_MESSAGES) RPT_PRINT << ".";
	 if ( p[i] != 0x00000000 ) {
           if(DEBUG_MESSAGES) RPT_PRINT << "data mismatch on FIFO entry[" << i << "]:"  << "expected : " << 0x00000000 << " read  : " << p[i] << endl;
           testcase_ctrl.status[errorPos] += 1;
	 }
       }
       if(DEBUG_MESSAGES) RPT_PRINT << "." << endl;

       // now disable the FIFO RAM for writting
       FIFO0_CH0_CTRL = 0x0;

       // Fill RAM again
       if(DEBUG_MESSAGES) RPT_PRINT << "Filling FIFO RAM, writting capability disabled";
       for ( i = 0; i < FIFO_ENTRIES; i++ ) {
	 if (!(i%10))
           if(DEBUG_MESSAGES) RPT_PRINT << ".";
	 p[i] = 0xFFFFFFFF;
       }
       if(DEBUG_MESSAGES) RPT_PRINT << "." << endl;

       // Testing FIFO_RAM content
       if(DEBUG_MESSAGES) RPT_PRINT << "Testing FIFO RAM";
       for (i = 0; i < FIFO_ENTRIES; i++ ) {
	 if (!(i%10))
           if(DEBUG_MESSAGES) RPT_PRINT << ".";
	 if ( p[i] != 0x00000000 ) {
           if(DEBUG_MESSAGES) RPT_PRINT << "data mismatch on FIFO entry[" << i << "]:"  << "expected : " << 0x00000000 << " read  : " << p[i] << endl;
           testcase_ctrl.status[errorPos] += 1;
	 }
       }
       if(DEBUG_MESSAGES) RPT_PRINT << "." << endl;
    }
    testcase_ctrl.errors += testcase_ctrl.status[errorPos];
    errorPos++;


    testcase_ctrl.runtime     += TBU_CH0_BASE;

    if(DEBUG_MESSAGES) RPT_PRINT << "Test finished : ";
    if (testcase_ctrl.errors != 0) {
      if(DEBUG_MESSAGES) RPT_PRINT << testcase_ctrl.errors << " error(s) detected during test" << endl;
    } else {
      if(DEBUG_MESSAGES) RPT_PRINT << " no errors" << endl;
    }
    return testcase_ctrl.errors;
}

int gtm_mem_test_init() {
    int i;

  // control testcase environment
  testcase_ctrl.tbu_pre_runtime = 0x0;
  testcase_ctrl.tbu_post_runtime = 0x0;
  testcase_ctrl.glb_clk_div = 0x1;
  testcase_ctrl.tbu_runtime_limt= 0x07C000 ;
  testcase_ctrl.mask_loop_cnt = 0;
  testcase_ctrl.loop_cnt = TESTCASE_LOOP_CNT;

  for (i=0; i<ERROR_STACK_SIZE; i++){
    testcase_ctrl.error_stack[i] = 0xFFFFFFFF;
  }   
  for (i=0; i<100; i++){
    testcase_ctrl.status[i] = 0x0;
  }   
  testcase_ctrl.error_stack_ptr = 0;
  testcase_ctrl.expected[0] = 0;

  return 0; 
}

int gtm_mem_test_report() {
    int i;
    int j;

  global_testcase_report();

  for ( i=0; i< DPLL_INSTANCES; i = i + 1) {
   for ( j=0; j< 3; j = j + 1) {
    if (testcase_ctrl.status[i*2 + j] != 0) {
       sprintf(testcase_rptline,"ERROR : Check %s : errors: 0x%d\n",dpll_check_label[j],testcase_ctrl.status[i*2 + j]);
       RPT_TC_PRINT(testcase_rptline);
    } 
   } 
  }
  for ( i=PSM_RAM_OFFSET; i< PSM_RAM_OFFSET + PSM_INSTANCES; i = i + 1) {
   if (testcase_ctrl.status[i] != 0) {
      sprintf(testcase_rptline,"ERROR : Check PSM_RAM%d : errors: 0x%d\n",i - PSM_RAM_OFFSET ,testcase_ctrl.status[i]);
      RPT_TC_PRINT(testcase_rptline);
   } 
  }
  for ( i=MCS_RAM_OFFSET; i< MCS_RAM_OFFSET + MCS_INSTANCES; i = i + 1) {
   if (testcase_ctrl.status[i] != 0) {
      sprintf(testcase_rptline,"ERROR : Check MCS_RAM%d : errors: 0x%d\n",i - MCS_RAM_OFFSET ,testcase_ctrl.status[i]);
      RPT_TC_PRINT(testcase_rptline);
   } 
  }
  
  return 0; 
}

int gtm_mem_test() {
  
  // define Bridge mode
  testcase_ctrl.bridge_mode = ASYNC;

  char test_name[15] = "gtm_mem_test";
  testcase_ctrl.test_name       = test_name;
  test_init_function   = gtm_mem_test_init;
  test_function        = gtm_mem_test_single;
  testcase_ctrl.parameter       = NULL;
  loop_testcase();
  gtm_mem_test_report();
  return testcase_ctrl.sum_errors;
}
