//head:-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// $Id: loopback.cpp,v 1.7 2012/10/19 06:45:34 jhanisch Exp $
//------------------------------------------------------------------------------
// NO WARRANTIES: TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER THE
// INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND CONTRIBUTORS, NOR ANY
// PERSON, EITHER EXPRESSLY OR IMPLICITLY, WARRANTS ANY ASPECT OF THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// INCLUDING ANY OUTPUT OR RESULTS OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO UNLESS AGREED TO IN WRITING.
// THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED
// THERETO IS BEING PROVIDED "AS IS", WITHOUT ANY WARRANTY OF ANY TYPE OR
// NATURE, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY
// WARRANTY THAT THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO IS FREE FROM DEFECTS.
//
// ASSUMPTION OF RISK: THE RISK OF ANY AND ALL LOSS, DAMAGE, OR UNSATISFACTORY
// PERFORMANCE OF THIS SPECIFICATION (RESPECTIVELY THE PRODUCTS MAKING USE OF
// IT IN PART OR AS A WHOLE), SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM
// RELATED THERETO RESTS WITH YOU AS THE USER. TO THE MAXIMUM EXTENT PERMITTED
// BY LAW, NEITHER THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND
// CONTRIBUTORS, NOR ANY PERSON EITHER EXPRESSLY OR IMPLICITLY, MAKES ANY
// REPRESENTATION OR WARRANTY REGARDING THE APPROPRIOATENESS OF THE USE, OUTPUT,
// OR RESULTS OF THE USE OF THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE
// AND/OR PROGRAM RELATED THERETO IN TERMS OF ITS CORRECTNESS, ACCURACY,
// RELIABILITY, BEING CURRENT OR OTHERWISE. NOR DO THEY HAVE ANY OBLIGATION TO
// CORRECT ERRORS, MAKE CHANGES, SUPPORT THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, DISTRIBUTE UPDATES, OR PROVIDE
// NOTIFICATION OF ANY ERROR OR DEFECT, KNOWN OR UNKNOWN. IF YOU RELY UPON THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// YOU DO SO AT YOUR OWN RISK, AND YOU ASSUME THE RESPONSIBILITY FOR THE
// RESULTS. SHOULD THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL LOSSES,
// INCLUDING, BUT NOT LIMITED TO, ANY NECESSARY SERVICING, REPAIR OR CORRECTION
// OF ANY PROPERTY INVOLVED TO THE MAXIMUM EXTEND PERMITTED BY LAW.
//
// DISCLAIMER: IN NO EVENT, UNLESS REQUIRED BY LAW OR AGREED TO IN WRITING,
// SHALL THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS OR ANY PERSON BE
// LIABLE FOR ANY LOSS, EXPENSE OR DAMAGE, OF ANY TYPE OR NATURE ARISING OUT OF
// THE USE OF, OR INABILITY TO USE THIS SPECIFICATION, SOFTWARE RELATED THERETO,
// CODE AND/OR PROGRAM RELATED THERETO, INCLUDING, BUT NOT LIMITED TO, CLAIMS,
// SUITS OR CAUSES OF ACTION INVOLVING ALLEGED INFRINGEMENT OF COPYRIGHTS,
// PATENTS, TRADEMARKS, TRADE SECRETS, OR UNFAIR COMPETITION.
//
// INDEMNIFICATION: TO THE MAXIMUM EXTEND PERMITTED BY LAW YOU AGREE TO
// INDEMNIFY AND HOLD HARMLESS THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT
// HOLDERS AND CONTRIBUTORS, AND EMPLOYEES, AND ANY PERSON FROM AND AGAINST ALL
// CLAIMS, LIABILITIES, LOSSES, CAUSES OF ACTION, DAMAGES, JUDGMENTS, AND
// EXPENSES, INCLUDING THE REASONABLE COST OF ATTORNEYS' FEES AND COURT COSTS,
// FOR INJURIES OR DAMAGES TO THE PERSON OR PROPERTY OF THIRD PARTIES,
// INCLUDING, WITHOUT LIMITATIONS, CONSEQUENTIAL, DIRECT AND INDIRECT DAMAGES
// AND ANY ECONOMIC LOSSES, THAT ARISE OUT OF OR IN CONNECTION WITH YOUR USE,
// MODIFICATION, OR DISTRIBUTION OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, ITS OUTPUT, OR ANY ACCOMPANYING
// DOCUMENTATION.
//
// GOVERNING LAW: THE RELATIONSHIP BETWEEN YOU AND ROBERT BOSCH GMBH SHALL BE
// GOVERNED SOLELY BY THE LAWS OF THE FEDERAL REPUBLIC OF GERMANY. THE
// STIPULATIONS OF INTERNATIONAL CONVENTIONS REGARDING THE INTERNATIONAL SALE OF
// GOODS SHALL NOT BE APPLICABLE. THE EXCLUSIVE LEGAL VENUE SHALL BE
// DUESSELDORF, GERMANY.
//
// MANDATORY LAW SHALL BE UNAFFECTED BY THE FOREGOING PARAGRAPHS.
//
// INTELLECTUAL PROPERTY OWNERS/COPYRIGHT OWNERS/CONTRIBUTORS: ROBERT BOSCH
// GMBH, ROBERT BOSCH PLATZ 1, 70839 GERLINGEN, GERMANY AND ITS LICENSORS.
//
// ALL RIGHTS RESERVED.
//------------------------------------------------------------------------------
// Project Name : GTM - Generic Timer Module
//------------------------------------------------------------------------------
// Copyright   : Robert Bosch GmbH, Gerlingen, Germany
// Department  : AE/EIY
// Created     : 13.05.2011
//------------------------------------------------------------------------------
//:head-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// Description     : helper functions
//============================================================================ 
// Important Notes : 
//============================================================================ 
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "gtm.h"
#include "gtm_device_cfg.h"

using namespace std;

#include "platform.h"
#include "functions.h"
#include "testcase_control_variables.h"

extern int testcase_errors ;
extern testcase_ctrl_type testcase_ctrl;
//extern void GTM_LOOP_BACK(void);

//------------------------------------------------------------------------------
// loopback control to route (A)TOM to TIM
//------------------------------------------------------------------------------
//
void loopback_control(unsigned  type_i,unsigned  from_i,unsigned  from_ch,unsigned to_i,unsigned to_ch) {
  unsigned int val;

  if ( to_i < TIM_INSTANCES ) {
    if(DEBUG_MESSAGES) RPT_PRINT << "AUX Routing" << endl;
    switch (testcase_ctrl.loop_back) {
	     case LOOP_BACK_INTERNAL:
               if(DEBUG_MESSAGES) RPT_PRINT << "internal loopback" << endl;
  # ifdef GTM_TIM_AUX_IN_SRC
	       val = GTM_TIM_AUX_IN_SRC(to_i);
	       GTM_TIM_AUX_IN_SRC(to_i) 	=  val | (type_i << to_ch); // Route ATOM0_CH0 into TIM0_CH0
  # endif	     
  # ifdef TIM_IN_SRC
	       val = TIM_IN_SRC(to_i);
	       TIM_IN_SRC(to_i) 		= val | (0x6 << (4 * to_ch)); // Select AUX_IN for ATOM0_CH0
  # endif	     
	       break;
	     case LOOP_BACK_EXTERNAL_TB:
               if(DEBUG_MESSAGES) RPT_PRINT << "Testbench loopback" << endl;
  # ifdef TIM_IN_SRC
	       val = TIM_IN_SRC(to_i);
	       TIM_IN_SRC(to_i) 	 = val & (~(0xF << (4 * to_ch))); // Select primary input
  # endif	     
	       break;
             case LOOP_BACK_INFINEON:
               //GTM_LOOP_BACK();
              break;
             case LOOP_BACK_JDP:
               //GTM_LOOP_BACK();
              break;
	     default:
               testcase_ctrl.errors++;
               RPT_PRINT << "ERROR: Unkown Loopback" << dec << LOOP_BACK << endl;
	       break;
    }
  }
}
//------------------------------------------------------------------------------
// GTM_HALT function
// IO_CTRL drives the activation of the gtm_halt functionality
// this register is microcontroller dependant , adapt to your needs
//------------------------------------------------------------------------------

void dpll_gtm_halt(int val) {
   if ( GTM_HALT_IN_USE == 1) {
      if ( val == 1 ) {
	 IO_CTRL = 0x10;
         testcase_ctrl.gtm_halt_cnt += 1;
	 //if(DEBUG_MESSAGES) RPT_PRINT << "GTM_HALT on"  << endl;
      } else {
	 IO_CTRL = 0x0;
	 //if(DEBUG_MESSAGES) RPT_PRINT << "GTM_HALT off"  << endl;
      }
   } else {
       // ensure by dummy write that tbu time is eqaul even if gtm halt is not applied
	 IO_CTRL = 0x0;
   }
}
//------------------------------------------------------------------------------
// consume time  (Do a register/Memory access not in addressrange of GTM_IP
//------------------------------------------------------------------------------

void consume_time(void) {
  // following access ensures that time will be consumed
  // must be adapted for porting to different microcontrollers
   dpll_gtm_halt(0); // can be any other register !! PORTPIN register can be used instead
}
//------------------------------------------------------------------------------
// set up clock system in microcontroller
//------------------------------------------------------------------------------
//
void gtm_clk_ctrl(unsigned  gtm_bridge_mode) {

    switch (gtm_bridge_mode) {
      // setup Microcontroller infrastructure to ensure that gtm and Bus Interface operate on a Synchronous Clock
	     case SYNC_MSKWR:
	     case SYNC:
               if(DEBUG_MESSAGES) RPT_PRINT << "sync mode" << endl;
	       switch (UC_SOURCE) {
		       case UC_ALTERA:
			 break;
		       case UC_IFX:
			 break;
		       case UC_JDP:
			 break;
		       default:
        		 testcase_ctrl.errors++;
        		 RPT_PRINT << "ERROR: Unkown UC Source" << dec << UC_SOURCE << endl;
			 break;
	       }
	       break;
      // setup Microcontroller infrastructure to ensure that gtm and Bus Interface operate a Asynchronous Clock
	     case ASYNC_MSKWR:
	     case ASYNC:
               if(DEBUG_MESSAGES) RPT_PRINT << "async mode" << endl;
	       switch (UC_SOURCE) {
		       case UC_ALTERA:
			 break;
		       case UC_IFX:
			 break;
		       case UC_JDP:
			 break;
		       default:
        		 testcase_ctrl.errors++;
        		 RPT_PRINT << "ERROR: Unkown UC Source" << dec << UC_SOURCE << endl;
			 break;
	       }
	       break;
	     default:
               testcase_ctrl.errors++;
               RPT_PRINT << "ERROR: Unkown gtm clk mode" << dec << gtm_bridge_mode << endl;
	       break;
    }
}
//------------------------------------------------------------------------------
// set_gtm_clk function
// 1 enables the clock for the gtm peripheral
// 0 disables the clock for the gtm peripheral
// this function/register seetting is microcontroller dependant , adapt to your needs
//------------------------------------------------------------------------------

void set_gtm_clk(int on) {
   if ( on == 1) {
     // switch on clock of GTM peripheral
     switch (UC_SOURCE) {
	     case UC_ALTERA:
	       break;
	     case UC_IFX:
	       break;
	     case UC_JDP:
	       break;
	     default:
               testcase_ctrl.errors++;
               RPT_PRINT << "ERROR: Unkown UC Source" << dec << UC_SOURCE << endl;
	       break;
     }
   } else {
     // switch off clock of GTM peripheral
     switch (UC_SOURCE) {
	     case UC_ALTERA:
	       break;
	     case UC_IFX:
	       break;
	     case UC_JDP:
	       break;
	     default:
               testcase_ctrl.errors++;
               RPT_PRINT << "ERROR: Unkown UC Source" << dec << UC_SOURCE << endl;
	       break;
     }
   }
}
