//head:-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// $Id: tim_port_test.cpp,v 1.8 2014/02/13 12:20:41 uscheure Exp $
//------------------------------------------------------------------------------
// NO WARRANTIES: TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER THE
// INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND CONTRIBUTORS, NOR ANY
// PERSON, EITHER EXPRESSLY OR IMPLICITLY, WARRANTS ANY ASPECT OF THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// INCLUDING ANY OUTPUT OR RESULTS OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO UNLESS AGREED TO IN WRITING.
// THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED
// THERETO IS BEING PROVIDED "AS IS", WITHOUT ANY WARRANTY OF ANY TYPE OR
// NATURE, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY
// WARRANTY THAT THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO IS FREE FROM DEFECTS.
//
// ASSUMPTION OF RISK: THE RISK OF ANY AND ALL LOSS, DAMAGE, OR UNSATISFACTORY
// PERFORMANCE OF THIS SPECIFICATION (RESPECTIVELY THE PRODUCTS MAKING USE OF
// IT IN PART OR AS A WHOLE), SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM
// RELATED THERETO RESTS WITH YOU AS THE USER. TO THE MAXIMUM EXTENT PERMITTED
// BY LAW, NEITHER THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND
// CONTRIBUTORS, NOR ANY PERSON EITHER EXPRESSLY OR IMPLICITLY, MAKES ANY
// REPRESENTATION OR WARRANTY REGARDING THE APPROPRIOATENESS OF THE USE, OUTPUT,
// OR RESULTS OF THE USE OF THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE
// AND/OR PROGRAM RELATED THERETO IN TERMS OF ITS CORRECTNESS, ACCURACY,
// RELIABILITY, BEING CURRENT OR OTHERWISE. NOR DO THEY HAVE ANY OBLIGATION TO
// CORRECT ERRORS, MAKE CHANGES, SUPPORT THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, DISTRIBUTE UPDATES, OR PROVIDE
// NOTIFICATION OF ANY ERROR OR DEFECT, KNOWN OR UNKNOWN. IF YOU RELY UPON THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// YOU DO SO AT YOUR OWN RISK, AND YOU ASSUME THE RESPONSIBILITY FOR THE
// RESULTS. SHOULD THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL LOSSES,
// INCLUDING, BUT NOT LIMITED TO, ANY NECESSARY SERVICING, REPAIR OR CORRECTION
// OF ANY PROPERTY INVOLVED TO THE MAXIMUM EXTEND PERMITTED BY LAW.
//
// DISCLAIMER: IN NO EVENT, UNLESS REQUIRED BY LAW OR AGREED TO IN WRITING,
// SHALL THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS OR ANY PERSON BE
// LIABLE FOR ANY LOSS, EXPENSE OR DAMAGE, OF ANY TYPE OR NATURE ARISING OUT OF
// THE USE OF, OR INABILITY TO USE THIS SPECIFICATION, SOFTWARE RELATED THERETO,
// CODE AND/OR PROGRAM RELATED THERETO, INCLUDING, BUT NOT LIMITED TO, CLAIMS,
// SUITS OR CAUSES OF ACTION INVOLVING ALLEGED INFRINGEMENT OF COPYRIGHTS,
// PATENTS, TRADEMARKS, TRADE SECRETS, OR UNFAIR COMPETITION.
//
// INDEMNIFICATION: TO THE MAXIMUM EXTEND PERMITTED BY LAW YOU AGREE TO
// INDEMNIFY AND HOLD HARMLESS THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT
// HOLDERS AND CONTRIBUTORS, AND EMPLOYEES, AND ANY PERSON FROM AND AGAINST ALL
// CLAIMS, LIABILITIES, LOSSES, CAUSES OF ACTION, DAMAGES, JUDGMENTS, AND
// EXPENSES, INCLUDING THE REASONABLE COST OF ATTORNEYS' FEES AND COURT COSTS,
// FOR INJURIES OR DAMAGES TO THE PERSON OR PROPERTY OF THIRD PARTIES,
// INCLUDING, WITHOUT LIMITATIONS, CONSEQUENTIAL, DIRECT AND INDIRECT DAMAGES
// AND ANY ECONOMIC LOSSES, THAT ARISE OUT OF OR IN CONNECTION WITH YOUR USE,
// MODIFICATION, OR DISTRIBUTION OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, ITS OUTPUT, OR ANY ACCOMPANYING
// DOCUMENTATION.
//
// GOVERNING LAW: THE RELATIONSHIP BETWEEN YOU AND ROBERT BOSCH GMBH SHALL BE
// GOVERNED SOLELY BY THE LAWS OF THE FEDERAL REPUBLIC OF GERMANY. THE
// STIPULATIONS OF INTERNATIONAL CONVENTIONS REGARDING THE INTERNATIONAL SALE OF
// GOODS SHALL NOT BE APPLICABLE. THE EXCLUSIVE LEGAL VENUE SHALL BE
// DUESSELDORF, GERMANY.
//
// MANDATORY LAW SHALL BE UNAFFECTED BY THE FOREGOING PARAGRAPHS.
//
// INTELLECTUAL PROPERTY OWNERS/COPYRIGHT OWNERS/CONTRIBUTORS: ROBERT BOSCH
// GMBH, ROBERT BOSCH PLATZ 1, 70839 GERLINGEN, GERMANY AND ITS LICENSORS.
//
// ALL RIGHTS RESERVED.
//------------------------------------------------------------------------------
// Project Name : GTM - Generic Timer Module
//------------------------------------------------------------------------------
// Copyright   : Robert Bosch GmbH, Gerlingen, Germany
// Department  : AE/EIY
// Created     : 25.01.2011
//------------------------------------------------------------------------------
//:head-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// Description     : TIM input test
//============================================================================ 
// Important Notes : 
//============================================================================ 

#include <iostream>
#include <stdlib.h> // for rand() function
#include "gtm.h"
#include "functions.h"
#include "gtm_device_cfg.h"

using namespace std;

void toggle_tom_out(int inst) {
  int status, c;
    if (TOM_INSTANCES >= TIM_INSTANCES) {
      if (get_device() < 0x200) {
        switch (inst) {
	case 0:
	  TOM0_CH0_CTRL  = ((~TOM0_CH0_CTRL) & 0x00000800);     // toggle SL
	  break;
        case 1:
          TOM0_CH1_CTRL  = ((~TOM0_CH1_CTRL) & 0x00000800);     // toggle SL
          break;
        case 2:
          TOM0_CH2_CTRL  = ((~TOM0_CH2_CTRL) & 0x00000800);     // toggle SL
          break;
        case 3:
          TOM0_CH3_CTRL  = ((~TOM0_CH3_CTRL) & 0x00000800);     // toggle SL
          break;
        case 4:
          TOM0_CH4_CTRL  = ((~TOM0_CH4_CTRL) & 0x00000800);     // toggle SL
          break;
        case 5:
          TOM0_CH5_CTRL  = ((~TOM0_CH5_CTRL) & 0x00000800);     // toggle SL
          break;
        case 6:
          TOM0_CH6_CTRL  = ((~TOM0_CH6_CTRL) & 0x00000800);     // toggle SL
          break;
        default:
          cout << "ERROR : number of TIM instances too high. Test only supports up to 7" << endl;
          break;
        }
      } else {
	for (c=0; c<TOM_CHANNEL_CNT(inst); c++) {
	  TOM_CH_CTRL(inst,c)  = ((~TOM_CH_CTRL(inst,c)) & 0x00000800);     // toggle SL
	}
      }
    } else {
      for (c=0; c<ATOM_CHANNEL_CNT(inst); c++) {    
	ATOM_CH_CTRL(inst,c)  = ((~ATOM_CH_CTRL(inst,c)) & 0x00000800);     // toggle SL
      }
    }
    // dummy read to waste time
    for (int k=0; k<10; k++) {
      status = GTM_CTRL;
    }
}

int tim_port_test() {

    gtm_ptr p;

    int errors = 0;
    int status = 0;
    
    if (TOM_INSTANCES >= TIM_INSTANCES) {
      if (get_device() < 0x200) {
	cout << "configure TOM0_CHx_OUT to signal state of check" << endl;
	TOM0_CH0_CTRL  = 0x800;     // set SL to 1 -> output = 0
	TOM0_CH1_CTRL  = 0x800;     // set SL to 1 -> output = 0
	TOM0_CH2_CTRL  = 0x800;     // set SL to 1 -> output = 0
	TOM0_CH3_CTRL  = 0x800;     // set SL to 1 -> output = 0
	TOM0_CH4_CTRL  = 0x800;     // set SL to 1 -> output = 0
	TOM0_CH5_CTRL  = 0x800;     // set SL to 1 -> output = 0
	TOM0_CH6_CTRL  = 0x800;     // set SL to 1 -> output = 0
      }
    } else {
      if (ATOM_INSTANCES > 0) {
	if (get_device() >= 0x200) {
	  for (int i=0; i<TIM_INSTANCES; i++) {    
	    GTM_TIM_AUX_IN_SRC(i) = 0x000000FF;
	    TIM_IN_SRC(i) = 0x22222222; // set MODE_x,VAL_x = "10"
	  }
	}
	cout << "configure ATOM0_CHx_OUT to signal state of check" << endl;
      } else {
	// neither TOM nor ATOM avaialble -> noe test!
	cout << "Test not executed : neither TOM nor ATOM avaialble";
	return 1;
      }
    }
    
    cout << "Checking TIM inputs." << endl;

    for (int i=0; i<TIM_INSTANCES; i++) {    
      cout << " .. instance " << i << endl;

      cout << "configure TIM to TIEM mode to count edges" << endl;
      for (int c=0; c<TIM_CHANNEL_CNT(i); c++) {    
#ifdef TIM0_CH0_TDU
	TIM_CH_TDU(i,c) = 0;
#else
	TIM_CH_TDUC(i,c) = 0;
	TIM_CH_TDUV(i,c) = 0;
#endif
	TIM_CH_CTRL(i,c) = 0x4005; // ISL=1, TIM_MODE=010, TIM_EN=1
      }


      cout << "check edge counter values:" << endl;
      for (int c=0; c<TIM_CHANNEL_CNT(i); c++) {    
	status = TIM_CH_CNT(i,c);
	cout << "TIM"<<i<<"_CH"<<c<<"_CNT = 0x" << hex << status;
	if (status != 0x00000000) {cout << " ERROR : unexpected counter value" << endl; errors +=1;}
	else cout << endl;
      }

      cout << "generate on each TIM"<<i<<" input a rising edge (triggered by (A)TOM0_OUT"<<i<<")" << endl;
      toggle_tom_out(i);
      cout << "generate on each TIM"<<i<<" input a falling edge (triggered by (A)TOM0_OUT"<<i<<")" << endl;
      toggle_tom_out(i);
      cout << "generate on each TIM"<<i<<" input a rising edge (triggered by (A)TOM0_OUT"<<i<<")" << endl;
      toggle_tom_out(i);
      
      cout << "check edge counter values again:" << endl;
      for (int c=0; c<TIM_CHANNEL_CNT(i); c++) { 
	int max_cnt = ATOM_CHANNEL_CNT(i);
        if (TOM_INSTANCES >= TIM_INSTANCES)
	   max_cnt = TOM_CHANNEL_CNT(i);

        if (c <   max_cnt ) {  
	  status = TIM_CH_CNT(i,c);
	  cout << "TIM"<<i<<"_CH"<<c<<"_CNT = 0x" << hex << status;
	  if (status != 0x00000003) {cout << " - ERROR : unexpected counter value" << endl; errors +=1;}
	  else cout << endl;
	}
      }

    } // loop over instances

    cout << "Test finished : ";
    if (errors != 0) {cout << errors << " error(s) detected during test" << endl;}
    else {cout << " no errors" << endl;}
    return errors;
}

