//head:-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// $Id: tom_port_test.cpp,v 1.9 2012/12/14 05:57:37 jhanisch Exp $
//------------------------------------------------------------------------------
// NO WARRANTIES: TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER THE
// INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND CONTRIBUTORS, NOR ANY
// PERSON, EITHER EXPRESSLY OR IMPLICITLY, WARRANTS ANY ASPECT OF THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// INCLUDING ANY OUTPUT OR RESULTS OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO UNLESS AGREED TO IN WRITING.
// THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED
// THERETO IS BEING PROVIDED "AS IS", WITHOUT ANY WARRANTY OF ANY TYPE OR
// NATURE, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY
// WARRANTY THAT THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO IS FREE FROM DEFECTS.
//
// ASSUMPTION OF RISK: THE RISK OF ANY AND ALL LOSS, DAMAGE, OR UNSATISFACTORY
// PERFORMANCE OF THIS SPECIFICATION (RESPECTIVELY THE PRODUCTS MAKING USE OF
// IT IN PART OR AS A WHOLE), SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM
// RELATED THERETO RESTS WITH YOU AS THE USER. TO THE MAXIMUM EXTENT PERMITTED
// BY LAW, NEITHER THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS AND
// CONTRIBUTORS, NOR ANY PERSON EITHER EXPRESSLY OR IMPLICITLY, MAKES ANY
// REPRESENTATION OR WARRANTY REGARDING THE APPROPRIOATENESS OF THE USE, OUTPUT,
// OR RESULTS OF THE USE OF THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE
// AND/OR PROGRAM RELATED THERETO IN TERMS OF ITS CORRECTNESS, ACCURACY,
// RELIABILITY, BEING CURRENT OR OTHERWISE. NOR DO THEY HAVE ANY OBLIGATION TO
// CORRECT ERRORS, MAKE CHANGES, SUPPORT THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, DISTRIBUTE UPDATES, OR PROVIDE
// NOTIFICATION OF ANY ERROR OR DEFECT, KNOWN OR UNKNOWN. IF YOU RELY UPON THIS
// SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR PROGRAM RELATED THERETO,
// YOU DO SO AT YOUR OWN RISK, AND YOU ASSUME THE RESPONSIBILITY FOR THE
// RESULTS. SHOULD THIS SPECIFICATION, SOFTWARE RELATED THERETO, CODE AND/OR
// PROGRAM RELATED THERETO PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL LOSSES,
// INCLUDING, BUT NOT LIMITED TO, ANY NECESSARY SERVICING, REPAIR OR CORRECTION
// OF ANY PROPERTY INVOLVED TO THE MAXIMUM EXTEND PERMITTED BY LAW.
//
// DISCLAIMER: IN NO EVENT, UNLESS REQUIRED BY LAW OR AGREED TO IN WRITING,
// SHALL THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT HOLDERS OR ANY PERSON BE
// LIABLE FOR ANY LOSS, EXPENSE OR DAMAGE, OF ANY TYPE OR NATURE ARISING OUT OF
// THE USE OF, OR INABILITY TO USE THIS SPECIFICATION, SOFTWARE RELATED THERETO,
// CODE AND/OR PROGRAM RELATED THERETO, INCLUDING, BUT NOT LIMITED TO, CLAIMS,
// SUITS OR CAUSES OF ACTION INVOLVING ALLEGED INFRINGEMENT OF COPYRIGHTS,
// PATENTS, TRADEMARKS, TRADE SECRETS, OR UNFAIR COMPETITION.
//
// INDEMNIFICATION: TO THE MAXIMUM EXTEND PERMITTED BY LAW YOU AGREE TO
// INDEMNIFY AND HOLD HARMLESS THE INTELLECTUAL PROPERTY OWNERS, COPYRIGHT
// HOLDERS AND CONTRIBUTORS, AND EMPLOYEES, AND ANY PERSON FROM AND AGAINST ALL
// CLAIMS, LIABILITIES, LOSSES, CAUSES OF ACTION, DAMAGES, JUDGMENTS, AND
// EXPENSES, INCLUDING THE REASONABLE COST OF ATTORNEYS' FEES AND COURT COSTS,
// FOR INJURIES OR DAMAGES TO THE PERSON OR PROPERTY OF THIRD PARTIES,
// INCLUDING, WITHOUT LIMITATIONS, CONSEQUENTIAL, DIRECT AND INDIRECT DAMAGES
// AND ANY ECONOMIC LOSSES, THAT ARISE OUT OF OR IN CONNECTION WITH YOUR USE,
// MODIFICATION, OR DISTRIBUTION OF THIS SPECIFICATION, SOFTWARE RELATED
// THERETO, CODE AND/OR PROGRAM RELATED THERETO, ITS OUTPUT, OR ANY ACCOMPANYING
// DOCUMENTATION.
//
// GOVERNING LAW: THE RELATIONSHIP BETWEEN YOU AND ROBERT BOSCH GMBH SHALL BE
// GOVERNED SOLELY BY THE LAWS OF THE FEDERAL REPUBLIC OF GERMANY. THE
// STIPULATIONS OF INTERNATIONAL CONVENTIONS REGARDING THE INTERNATIONAL SALE OF
// GOODS SHALL NOT BE APPLICABLE. THE EXCLUSIVE LEGAL VENUE SHALL BE
// DUESSELDORF, GERMANY.
//
// MANDATORY LAW SHALL BE UNAFFECTED BY THE FOREGOING PARAGRAPHS.
//
// INTELLECTUAL PROPERTY OWNERS/COPYRIGHT OWNERS/CONTRIBUTORS: ROBERT BOSCH
// GMBH, ROBERT BOSCH PLATZ 1, 70839 GERLINGEN, GERMANY AND ITS LICENSORS.
//
// ALL RIGHTS RESERVED.
//------------------------------------------------------------------------------
// Project Name : GTM - Generic Timer Module
//------------------------------------------------------------------------------
// Copyright   : Robert Bosch GmbH, Gerlingen, Germany
// Department  : AE/EIY
// Created     : 25.01.2011
//------------------------------------------------------------------------------
//:head-------------------------------------------------------------------------
//------------------------------------------------------------------------------
// Description     : TOM output test
//============================================================================ 
// Important Notes : 
//============================================================================ 

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "gtm.h"
#include "gtm_device_cfg.h"
#include "functions.h"
#include "platform.h"
#include "testcase_control_variables.h"

using namespace std;

extern testcase_ctrl_type testcase_ctrl;
extern int (*test_function)(char* variant);
extern int (*test_init_function)(void);
extern char testcase_rptline[100];

int tom_port_test_single(char* variant) {
    int i;
    int c;
    gtm_ptr p;
    testcase_ctrl.errors = 0;
    
    testcase_ctrl.runtime     = 0;
    start_testcase_runtime_measurement(testcase_ctrl.bridge_mode);
    
    if(DEBUG_MESSAGES) RPT_PRINT << "Manipulating TOM outputs." << endl;

    for (i=0; i<TOM_INSTANCES; i++) {

      if(DEBUG_MESSAGES) RPT_PRINT << "Testing TOM"<< i<< ".." << endl;

      for (c=0; c<16; c++) {
	// Resetting TOM0 outputs
	TOM_CH_CTRL(i,c)  = 0x800;     // signal level should be set to '0'
      }

	  
      for (c=0; c<16; c++) {
	// Testing TOM0 output levels in status register
	if (TOM_CH_STAT(i,c) != 0x0) {
	  if(DEBUG_MESSAGES) RPT_PRINT << "ERROR TOM0 CH0 output level not 0!" << endl;
          testcase_ctrl.error1[i] |= (0x1 << c);
	  testcase_ctrl.errors += 1;
	}
      }
    
      for (c=0; c<16; c++) {
	// Now seetting TOM0 outputs again
	TOM_CH_CTRL(i,c)  = 0x0;     // signal level should be set to '1'
      }

      for (c=0; c<16; c++) {
	// Testing TOM0 output levels in status register
	if (TOM_CH_STAT(i,c) != 0x1) {
	  if(DEBUG_MESSAGES) RPT_PRINT << "ERROR TOM0 CH0 output level not 1!" << endl;
          testcase_ctrl.error0[i] |= (0x1 << c);
	  testcase_ctrl.errors += 1;
	}
      }
    }

    if(DEBUG_MESSAGES) RPT_PRINT << "Test finished : ";
    if (testcase_ctrl.errors != 0) {
      if(DEBUG_MESSAGES) RPT_PRINT << testcase_ctrl.errors << " error(s) detected during test" << endl;
    } else {
      if(DEBUG_MESSAGES) RPT_PRINT << " no errors" << endl;
    }
    testcase_ctrl.runtime     = TBU_CH0_BASE;
    return testcase_ctrl.errors;
}

int tom_port_test_init() {
  unsigned int i;

  // control testcase environment
  testcase_ctrl.tbu_pre_runtime = 0x0;
  testcase_ctrl.tbu_post_runtime = 0x0;
  testcase_ctrl.glb_clk_div = 0x1;
  testcase_ctrl.tbu_runtime_limt= 0x02000 ;
  testcase_ctrl.mask_loop_cnt = 0;
  testcase_ctrl.loop_cnt = TESTCASE_LOOP_CNT;

  for (i=0; i<ERROR_STACK_SIZE; i++){
    testcase_ctrl.error_stack[i] = 0xFFFFFFFF;
  }   
  for (i=0; i<TOM_INSTANCES; i++){
    testcase_ctrl.error1[i] = 0x0;
    testcase_ctrl.error0[i] = 0x0;
  }   
  testcase_ctrl.error_stack_ptr = 0;

  return 0;
}

int tom_port_test_report() {
    int i;

  global_testcase_report();

  for ( i=0; i< TOM_INSTANCES; i = i + 1) {
    if (testcase_ctrl.error1[i] != 0) {
      sprintf(testcase_rptline,"ERROR : TOM instance  %d : bitpos with signal level !=0: 0x%x\n",i,testcase_ctrl.error1[i]);
      RPT_TC_PRINT(testcase_rptline);
      sprintf(testcase_rptline,"ERROR : TOM instance  %d : bitpos with signal level !=1: 0x%x\n",i,testcase_ctrl.error0[i]);
      RPT_TC_PRINT(testcase_rptline);
    } 
  }
  return 0;
}

int tom_port_test() {
  
  // define Bridge mode
  testcase_ctrl.bridge_mode = ASYNC;
  char test_name[15] = "tom_port_test";
  testcase_ctrl.test_name       = test_name;
  test_init_function   = tom_port_test_init;
  test_function        = tom_port_test_single;
  testcase_ctrl.parameter       = NULL;
  loop_testcase();
  tom_port_test_report();
  return testcase_ctrl.sum_errors;
}
